/*
 * cf.h
 *
 * Copyright (C) 2002, Stefan Eletzhofer <stefan.eletzhofer@eletztrick.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef BLOB_CF_H
#define BLOB_CF_H 1

/*****************************************************************
 * CF Flash register definitions
 */
/* config register - offset 0 */
#define CF_REG_CFG		(0x00)
#define CF_CFG_SRST		(0x80)
#define CF_CFG_LVLREQ	(0x40)
#define CF_CFG_MMAP		(0x00)
#define CF_CFG_IOMAP	(0x01)
#define CF_CFG_IO_IDE0	(0x02)
#define CF_CFG_IO_IDE1	(0x03)

/* config status register - offset 2 */
#define CF_REG_CFGSTAT	(0x02)

/* init CF card in PCMCIA slot <slot> */
int cf_init( int slot );

/* io driver init */
int cf_io_init( io_driver_t *io );

#endif
