//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this sample source code is subject to the terms of the Microsoft
// license agreement under which you licensed this sample source code. If
// you did not accept the terms of the license agreement, you are not
// authorized to use this sample source code. For the terms of the license,
// please see the license agreement between you and Microsoft or, if applicable,
// see the LICENSE.RTF on your install media or the root of your tools installation.
// THE SAMPLE SOURCE CODE IS PROVIDED "AS IS", WITH NO WARRANTIES OR INDEMNITIES.
//
//
// (C) Copyright 2006 Marvell International Ltd.
// All Rights Reserved
//
/* 
** INTEL CONFIDENTIAL
** Copyright 2000-2006 Intel Corporation All Rights Reserved.
**
** The source code contained or described herein and all documents
** related to the source code (Material) are owned by Intel Corporation
** or its suppliers or licensors.  Title to the Material remains with
** Intel Corporation or its suppliers and licensors. The Material contains
** trade secrets and proprietary and confidential information of Intel
** or its suppliers and licensors. The Material is protected by worldwide
** copyright and trade secret laws and treaty provisions. No part of the
** Material may be used, copied, reproduced, modified, published, uploaded,
** posted, transmitted, distributed, or disclosed in any way without Intel's
** prior express written permission.
**
** No license under any patent, copyright, trade secret or other intellectual
** property right is granted to or conferred upon you by disclosure or
** delivery of the Materials, either expressly, by implication, inducement,
** estoppel or otherwise. Any license under such intellectual property rights
** must be express and approved by Intel in writing.
*/
/** FILENAME:	pmic_lp3972.h
**
** PURPOSE:	head file for arava PMIC.
**
******************************************************************************/

#ifndef __PMIC_LP3972_H
#define __PMIC_LP3972_H

#include "xllp_defs.h"
#include "xllp_pi2c.h"
#include "xllp_ost.h"
#include "xllp_pm.h"

#define SPARE_WAKEUP (1 << 0)
#define TEST_JIG_WAKEUP (1 << 1)
#define PWB_SHORT_PULSE_WAKEUP (1 << 2)
#define PWB_LONG_PULSE_WAKEUP (1 << 3)
#define GPIO1_WAKEUP (1 << 4)
#define GPIO2_WAKEUP (1 << 5)
#define THERMAL_WARN_WAKEUP (1 << 6)

extern void PowerOnUsb(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu, XLLP_BOOL_T isOn);
extern void PowerOnCodec(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu, XLLP_BOOL_T isOn);
extern void PowerOnCI(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu, XLLP_BOOL_T isOn);
extern void PowerOnLCD(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu, XLLP_BOOL_T isOn);
extern void PowerOnCamera(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu, XLLP_BOOL_T isOn);
extern void PowerOnMMC(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu, XLLP_BOOL_T isOn);
extern XLLP_UINT32_T GetPmicWakeupReason(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu);
extern XLLP_UINT32_T GetVccCore(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu);
extern void SetVccCore(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu, XLLP_UINT32_T mv);
extern XLLP_UINT32_T GetVccSram(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu);
extern void SetVccSram(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu, XLLP_UINT32_T mv);
extern void SetVccCombo(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu, XLLP_UINT32_T Coremv, XLLP_UINT32_T SRAMmv);
extern void EnVolChange(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu);
extern void DisBuBatt(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu);
extern XLLP_BOOL_T IsBuBattEn(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu);
extern void SetBflt(P_XLLP_PI2C_T pI2C, P_XLLP_OST_T pOst, P_XLLP_PM_SPMU_T pSpmu, XLLP_UINT32_T mv);

#endif
