/*
 *  arp.h
 *
 *  Copyright 1996-2001 Russell King
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

struct arp_ethernet {
	unsigned char hw[6];
	unsigned char ip[4];
} __attribute__ ((packed));

struct arp_packet {
	unsigned short hw_type;
	unsigned short proto_type;
	unsigned char hw_len;
	unsigned char proto_len;
	unsigned short opcode;
	struct arp_ethernet sender;
	struct arp_ethernet target;
} __attribute__ ((packed));

/**********************************************************************
 * do_arp - send ARP request to server
 * @thwaddr: the target HW address we received
 * @tipaddr: the server IP address we want the HAW address for
 *
 * Sends and ARP REQUEST packet to the network and tries to get the
 * ethernet HW address <thwaddr> for the IP address <tipaddr>.
 */
int do_arp(unsigned char *thwaddr, unsigned char *tipaddr);

int do_arp_reply(unsigned char *rx_pkt, unsigned int size);
