/*
 *  ip_bits.h
 *
 *  Copyright 1996-2001 Russell King
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#ifndef _BLOB_IPBITS_H
#define _BLOB_IPBITS_H 1

#define SIZE_ETHER	14
#define SIZE_IP		20
#define SIZE_UDP	8
#define SIZE_BOOTP	300

#define OFF_ETHER	(0)
#define OFF_IP		(OFF_ETHER + SIZE_ETHER)
#define OFF_UDP		(OFF_IP + SIZE_IP)
#define OFF_BOOTP	(OFF_UDP + SIZE_UDP)
#define OFF_TFTP	(OFF_UDP + SIZE_UDP)

#define MIN_UDPPKTSIZE	(OFF_UDP + SIZE_UDP)

extern unsigned int checksum (unsigned char *ptr, int len, unsigned int cksum);
extern void printip (char *msg, unsigned char *ip);
extern int ipbits_tx (unsigned char *ptr, unsigned int size);
extern int ipbits_rcv (unsigned char *ptr, unsigned int size, unsigned int *dsz, int sport, int dport);

#endif
