@ This program is free software; you can redistribute it and/or modify
@ it under the terms of the GNU General Public License as published by
@ the Free Software Foundation; either version 2 of the License, or
@ (at your option) any later version.
@ 
@ This program is distributed in the hope that it will be useful,
@ but WITHOUT ANY WARRANTY; without even the implied warranty of
@ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
@ GNU General Public License for more details.
@ 
@ You should have received a copy of the GNU General Public License
@ along with this program; if not, write to the Free Software
@ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
@
@ 
@  (C) Copyright 2006 Marvell International Ltd.  
@  All Rights Reserved 
@
@

#ifdef HAVE_CONFIG_H
# include <blob/config.h>
#endif

.text
.global xsc3_dma_inv_range	  @ Invalidate the vaddr range
.global xsc3_dma_clean_range	  @ clean the vaddr range
.global xsc3_dma_flush_range	  @ flush the vaddr range

	.equ	CACHELINESIZE,32
@*
@*	dma_inv_range(start, end)
@*
@*	Invalidate (discard) the specified virtual address range.
@*	May not write back any entries.  If 'start' or 'end'
@*	are not cache line aligned, those lines must be written
@*	back.
@*
@*	- start  - virtual start address
@*	- end	 - virtual end address
@*/
xsc3_dma_inv_range:
	tst	r0, #CACHELINESIZE - 1
	bic	r0, r0, #CACHELINESIZE - 1
	mcrne	p15, 0, r0, c7, c10, 1		@ clean L1 D line
	mcrne	p15, 1, r0, c7, c11, 1		@ clean L2 line
	tst	r1, #CACHELINESIZE - 1
	mcrne	p15, 0, r1, c7, c10, 1		@ clean L1 D line
	mcrne	p15, 1, r1, c7, c11, 1		@ clean L2 line
1:	mcr	p15, 0, r0, c7, c6, 1		@ invalidate L1 D line
	mcr	p15, 1, r0, c7, c7, 1		@ invalidate L2 line
	add	r0, r0, #CACHELINESIZE
	cmp	r0, r1
	blo	1b
	mcr	p15, 0, r0, c7, c10, 4		@ data write barrier
	mov	pc, lr

@*
@*	dma_clean_range(start, end)
@*
@*	Clean the specified virtual address range.
@*
@*	- start  - virtual start address
@*	- end	 - virtual end address
@*/
xsc3_dma_clean_range:
	bic	r0, r0, #CACHELINESIZE - 1
1:	mcr	p15, 0, r0, c7, c10, 1		@ clean L1 D line
	mcr	p15, 1, r0, c7, c11, 1		@ clean L2 line
	add	r0, r0, #CACHELINESIZE
	cmp	r0, r1
	blo	1b
	mcr	p15, 0, r0, c7, c10, 4		@ data write barrier
	mov	pc, lr

@*
@*	dma_flush_range(start, end)
@*
@*	Clean and invalidate the specified virtual address range.
@*
@*	- start  - virtual start address
@*	- end	 - virtual end address
@*/
xsc3_dma_flush_range:
	bic	r0, r0, #CACHELINESIZE - 1
1:	mcr	p15, 0, r0, c7, c14, 1		@ clean/invalidate L1 D line
	mcr	p15, 1, r0, c7, c11, 1		@ clean L2 line
	mcr	p15, 1, r0, c7, c7, 1		@ invalidate L2 line
	add	r0, r0, #CACHELINESIZE
	cmp	r0, r1
	blo	1b
	mcr	p15, 0, r0, c7, c10, 4		@ data write barrier
	mov	pc, lr
@NOT SUPPORTED:         ENDFUNC
