//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this sample source code is subject to the terms of the Microsoft
// license agreement under which you licensed this sample source code. If
// you did not accept the terms of the license agreement, you are not
// authorized to use this sample source code. For the terms of the license,
// please see the license agreement between you and Microsoft or, if applicable,
// see the LICENSE.RTF on your install media or the root of your tools installation.
// THE SAMPLE SOURCE CODE IS PROVIDED "AS IS", WITH NO WARRANTIES OR INDEMNITIES.
//
//
// (C) Copyright 2006 Marvell International Ltd.
// All Rights Reserved
//
/******************************************************************************
**
** INTEL CONFIDENTIAL
** Copyright 2003-2005 Intel Corporation All Rights Reserved.
**
** The source code contained or described herein and all documents
** related to the source code (Material) are owned by Intel Corporation
** or its suppliers or licensors.  Title to the Material remains with
** Intel Corporation or its suppliers and licensors. The Material contains
** trade secrets and proprietary and confidential information of Intel
** or its suppliers and licensors. The Material is protected by worldwide
** copyright and trade secret laws and treaty provisions. No part of the
** Material may be used, copied, reproduced, modified, published, uploaded,
** posted, transmitted, distributed, or disclosed in any way without Intel�s
** prior express written permission.

** No license under any patent, copyright, trade secret or other intellectual
** property right is granted to or conferred upon you by disclosure or
** delivery of the Materials, either expressly, by implication, inducement,
** estoppel or otherwise. Any license under such intellectual property rights
** must be express and approved by Intel in writing.
**
**  FILENAME:   xllp_dvm.h
**
**  PURPOSE:    contains XLLP DVM typedefs and bit definitions.
**              
**
******************************************************************************/

#ifndef __XLLP_DVM_H__
#define __XLLP_DVM_H__

#include "xllp_defs.h"

typedef struct
{
	XLLP_UINT32_T CPDIS;
	XLLP_UINT32_T PDDIS;
        XLLP_UINT32_T frequency;
	XLLP_UINT32_T fastbus_mode;
	XLLP_UINT32_T turbo_mode;

} XLLP_FREQ_PARAM;

typedef struct
{
	XLLP_UINT32_T frequency;
	XLLP_UINT32_T fastbus_mode;
	XLLP_UINT32_T turbo_mode;
	XLLP_UINT32_T DacValue;

} XLLP_COMBO_PARAM;

#define  PRIMARY_CLOCK_FREQ              13

#define  VOLTAGE_REGULATOR_ADDRESS       0x20

//CLKCFG mask definition
#define XLLP_CLKCFG_T                   0x1
#define XLLP_CLKCFG_F                   (0x1 <<1 )
#define XLLP_CLKCFG_B                   (0x1 <<3 )
          
//define the MACRO for Power Management Change Control Register
#define XLLP_PVCR_VCSA                  (0x1<<14)
#define XLLP_PVCR_CommandDelay          (0xf80)

//define MACRO for Power Manager General Configuration Register (PCFR)
#define XLLP_PCFR_FVC                   (0x1 << 10)
#define XLLP_PCFR_PI2C_EN               (0x1 << 6)
#define XLLP_PCFR_SYSEN_EN              (0x1 << 5)

//define MACRO for Power Manager I2C Command Register File (PCMD)
#define XLLP_PCMD_MBC                  (0x1 << 12)
#define XLLP_PCMD_DCE                  (0x1 << 11)
#define XLLP_PCMD_LC                   (0x1 << 10)
#define XLLP_PCMD_SQC                  (0x3 << 8)

extern unsigned int XllpXSC1ReadCLKCFG(void );
extern unsigned int XllpIntcDisableInts(void);
extern void XllpXSC1FreqChange(int);
extern void XllpIntcRestoreInts(unsigned int);
extern void XllpXSC1ChangeVoltage(void);
void XllpXSC1EnterTurbo(void);
void XllpXSC1ExitTurbo(void);
#endif