//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this sample source code is subject to the terms of the Microsoft
// license agreement under which you licensed this sample source code. If
// you did not accept the terms of the license agreement, you are not
// authorized to use this sample source code. For the terms of the license,
// please see the license agreement between you and Microsoft or, if applicable,
// see the LICENSE.RTF on your install media or the root of your tools installation.
// THE SAMPLE SOURCE CODE IS PROVIDED "AS IS", WITH NO WARRANTIES OR INDEMNITIES.
//
//
// (C) Copyright 2006 Marvell International Ltd.
// All Rights Reserved
//
/* 
** INTEL CONFIDENTIAL
** Copyright 2000-2006 Intel Corporation All Rights Reserved.
**
** The source code contained or described herein and all documents
** related to the source code (Material) are owned by Intel Corporation
** or its suppliers or licensors.  Title to the Material remains with
** Intel Corporation or its suppliers and licensors. The Material contains
** trade secrets and proprietary and confidential information of Intel
** or its suppliers and licensors. The Material is protected by worldwide
** copyright and trade secret laws and treaty provisions. No part of the
** Material may be used, copied, reproduced, modified, published, uploaded,
** posted, transmitted, distributed, or disclosed in any way without Intel�s
** prior express written permission.
**
** No license under any patent, copyright, trade secret or other intellectual
** property right is granted to or conferred upon you by disclosure or
** delivery of the Materials, either expressly, by implication, inducement,
** estoppel or otherwise. Any license under such intellectual property rights
** must be express and approved by Intel in writing.
*/
/**
**  FILENAME:       xllp_pi2c.h
**  
**  PURPOSE: contains all PI2C specific macros, typedefs, and prototypes.
**           Declares no storage.
**  
**  
******************************************************************************/
#ifndef __XLLP_PI2C_H
#define __XLLP_PI2C_H

#include "xllp_defs.h"
#include "xllp_ost.h"
#include "xllp_pi2c_proc.h"

XLLP_PI2C_SPEED_T XllpPI2CGetSpeed(P_XLLP_PI2C_T PI2C_regs);

XLLP_PI2C_SPEED_T XllpPI2CSetSpeed(P_XLLP_PI2C_T PI2C_regs, XLLP_PI2C_SPEED_T speed);

XLLP_STATUS_T XllpPI2cInit(P_XLLP_PI2C_T PI2C_regs, XLLP_UINT32_T dev_id);

XLLP_STATUS_T XllpPI2CWrite(P_XLLP_PI2C_T PI2C_regs, 
                            XLLP_OST_T *pOSTRegs, 
                            XLLP_UINT8_T slaveAddr, 
                            const XLLP_UINT8_T * bytesBuf, 
                            XLLP_UINT32_T bytesCount, 
                            XLLP_BOOL_T bSendStop);

XLLP_STATUS_T XllpPI2CRead(P_XLLP_PI2C_T PI2C_regs, 
                           XLLP_OST_T *pOSTRegs, 
                           XLLP_UINT8_T slaveAddr, 
                           XLLP_UINT8_T * bytesBuf, 
                           XLLP_UINT32_T bytesCount, 
                           XLLP_BOOL_T bSendStop);

#endif /* XLLP_PI2C_H */
