/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * (C) Copyright 2006 Marvell International Ltd.  
 * All Rights Reserved 
 */

/*++

Module Name:  $Workfile: xllp_adcm2650.h $

Abstract:  
      contains all ADCM2650 function prototypes.
    Declares no storage.

Notes:Only valid for processor code named Monahans.

--*/


#ifndef _XLLP_ADCM2650_H_
#define _XLLP_ADCM2650_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "xllp_camera.h"

//////////////////////////////////////////////////////////////////////////////////////
//
//          Prototypes
//
//////////////////////////////////////////////////////////////////////////////////////

XLLP_STATUS_T CameraFuncADCM2650Init( P_XLLP_Camera_Context_T );

XLLP_STATUS_T CameraFuncADCM2650DeInit( P_XLLP_Camera_Context_T );

XLLP_STATUS_T CameraFuncADCM2650Sleep( P_XLLP_Camera_Context_T );

XLLP_STATUS_T CameraFuncADCM2650Wake( P_XLLP_Camera_Context_T );

XLLP_STATUS_T CameraFuncADCM2650SetCaptureFormat( P_XLLP_Camera_Context_T );

XLLP_STATUS_T CameraFuncADCM2650StartCapture( P_XLLP_Camera_Context_T, unsigned int frames );

XLLP_STATUS_T CameraFuncADCM2650StopCapture( P_XLLP_Camera_Context_T );

XLLP_STATUS_T CameraFuncADCM2650Read16bit( P_XLLP_Camera_Context_T camera_context, XLLP_UINT16_T reg_addr,  XLLP_UINT16_T *reg_val);

XLLP_STATUS_T CameraFuncADCM2650Write16bit( P_XLLP_Camera_Context_T camera_context, XLLP_UINT16_T reg_addr,  XLLP_UINT16_T reg_val);

XLLP_STATUS_T CameraFuncADCM2650SetPowerMode(P_XLLP_Camera_Context_T camera_context, XLLP_UINT8_T mode);

XLLP_STATUS_T CameraFuncADCM2650SetContrast( P_XLLP_Camera_Context_T camera_context, XLLP_UINT8_T mode, XLLP_UINT32_T value);

XLLP_STATUS_T CameraFuncADCM2650SetExposure( P_XLLP_Camera_Context_T camera_context,XLLP_UINT8_T mode, XLLP_UINT32_T value);

XLLP_STATUS_T CameraFuncADCM2650SetWhiteBalance( P_XLLP_Camera_Context_T camera_context, XLLP_UINT8_T mode, XLLP_UINT32_T value);

 
#ifdef __cplusplus
}
#endif

#endif

