/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *(C) Copyright 2006 Marvell International Ltd.  
 * All Rights Reserved 
 */

/*++

Module Name:  $Workfile: xllp_ov2630.h $

Abstract:  
      contains all OV2630 function prototypes.
    Declares no storage.

Notes:Only valid for processor code named Monahans.

--*/


#ifndef _XLLP_OV2630_H_
#define _XLLP_OV2630_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "xllp_camera.h"

//////////////////////////////////////////////////////////////////////////////////////
//
//          Prototypes
//
//////////////////////////////////////////////////////////////////////////////////////

XLLP_STATUS_T CameraFuncOV2630Init( P_XLLP_Camera_Context_T );

XLLP_STATUS_T CameraFuncOV2630DeInit( P_XLLP_Camera_Context_T );

XLLP_STATUS_T CameraFuncOV2630Sleep(  P_XLLP_Camera_Context_T camera_context );

XLLP_STATUS_T CameraFuncOV2630Wake(  P_XLLP_Camera_Context_T camera_context );

XLLP_STATUS_T CameraFuncOV2630SetCaptureFormat( P_XLLP_Camera_Context_T );

XLLP_STATUS_T CameraFuncOV2630StartCapture( P_XLLP_Camera_Context_T, unsigned int frames );

XLLP_STATUS_T CameraFuncOV2630StopCapture( P_XLLP_Camera_Context_T );

XLLP_STATUS_T CameraFuncOV2630Read8bit(  P_XLLP_Camera_Context_T camera_context, XLLP_UINT8_T reg_addr,  XLLP_UINT8_T *reg_val);

XLLP_STATUS_T CameraFuncOV2630Write8bit(  P_XLLP_Camera_Context_T camera_context, XLLP_UINT8_T reg_addr,  XLLP_UINT8_T reg_val);

XLLP_STATUS_T CameraFuncOV2630SetPowerMode(P_XLLP_Camera_Context_T camera_context, XLLP_UINT8_T mode);

XLLP_STATUS_T CameraFuncOV2630SetContrast( P_XLLP_Camera_Context_T camera_context, XLLP_UINT8_T mode, XLLP_UINT32_T value);

XLLP_STATUS_T CameraFuncOV2630SetExposure( P_XLLP_Camera_Context_T camera_context, XLLP_UINT8_T mode, XLLP_UINT32_T value);

XLLP_STATUS_T CameraFuncOV2630SetWhiteBalance( P_XLLP_Camera_Context_T camera_context, XLLP_UINT8_T mode, XLLP_UINT32_T value);

#ifdef __cplusplus
}
#endif

#endif

