/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *(C) Copyright 2006 Marvell International Ltd.  
 * All Rights Reserved 
 */

/** FILENAME:	xllp_pm_arava.h
**
** PURPOSE:	head file for arava PMIC.
**
******************************************************************************/

#ifndef __XLLP_PM_ARAVA_H
#define __XLLP_PM_ARAVA_H

#include "xllp_defs.h"

/* SYSMON */
#define XLLP_ARAVA_CHIP_ID	0x00
#define XLLP_ARAVA_EVENT_A 	0x01
#define XLLP_ARAVA_EVENT_B 	0x02
#define XLLP_ARAVA_EVENT_C 	0x03
#define XLLP_ARAVA_STATUS  	0x04
#define XLLP_ARAVA_IRQ_MASK_A 	0x05
#define XLLP_ARAVA_IRQ_MASK_B 	0x06
#define XLLP_ARAVA_IRQ_MASK_C 	0x07
#define XLLP_ARAVA_SYSCTRL_A 	0x08
#define XLLP_ARAVA_SYSCTRL_B	0x09
#define XLLP_ARAVA_SYSCTRL_C 	0x80
#define XLLP_ARAVA_FAULT_LOG	0x0A

/* REG */
#define XLLP_ARAVA_LDO1011		0x10
#define XLLP_ARAVA_LDO15		0x11
#define XLLP_ARAVA_LDO1416		0x12
#define XLLP_ARAVA_LDO1819		0x13
#define XLLP_ARAVA_LDO17_SIMCP0		0x14
#define XLLP_ARAVA_BUCK2DVC1		0x15
#define XLLP_ARAVA_BUCK2DVC2		0x16
#define XLLP_ARAVA_REGCTRL1		0x17
#define XLLP_ARAVA_REGCTRL2		0x18
#define XLLP_ARAVA_USBPUMP		0x19
#define XLLP_ARAVA_APPSLEEP_CTRL	0x1A
#define XLLP_ARAVA_STARTUP_CTRL		0x1B

/* LED - ignored now. Skip */
#define XLLP_ARAVA_LED1_CTRL		0x20
#define XLLP_ARAVA_LED2_CTRL		0x21
#define XLLP_ARAVA_LED3_CTRL		0x23
#define XLLP_ARAVA_LED4_CTRL		0x24
#define XLLP_ARAVA_LEDPC_CTRL		0x25
#define XLLP_ARAVA_WLED_CTRL		0x26

/* MISC */
#define XLLP_ARAVA_MISCA 0x26
#define XLLP_ARAVA_MISCB 0x27

/* Charge */
#define XLLP_ARAVA_CHARGE_CTRL		0x28
#define XLLP_ARAVA_CCTR_CTRL		0x29
#define XLLP_ARAVA_TCTR_CTRL		0x2A
#define XLLP_ARAVA_CHARGE_PULSE		0x2B

#define XLLP_ARAVA_ADDRESS 0x49

#ifdef __cplusplus
extern "C"
{
#endif

extern XLLP_STATUS_T XllpPmAravaInit(void);

extern XLLP_STATUS_T XllpPmAravaWrite(XLLP_UINT8_T reg, XLLP_UINT8_T val);

extern XLLP_STATUS_T XllpPmAravaRead(XLLP_UINT8_T reg, XLLP_UINT8_T *pval);

extern XLLP_STATUS_T XllpPmAravaSetVccSram(XLLP_UINT32_T mv);

extern XLLP_STATUS_T XllpPmAravaSetVccCore(XLLP_UINT32_T mv);

extern XLLP_STATUS_T XllpPmAravaGetVccSram(XLLP_UINT32_T *pmv);

extern XLLP_STATUS_T XllpPmAravaGetVccCore(XLLP_UINT32_T *pmv);

#ifdef __cplusplus
}
#endif

#endif
