/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *(C) Copyright 2006 Marvell International Ltd.  
 * All Rights Reserved 
 */

#ifndef _XLLP_TRUE_IDE_PLAT_H
#define _XLLP_TRUE_IDE_PLAT_H

#include "xllp_true_ide.h"

typedef enum
{
	XLLP_CF_IO_MEM_MOD = 0,
	XLLP_CF_TURE_IDE_MOD =1,
} XLLP_CF_SOCKET_MODE_T;

typedef enum
{
/*micro disk is powered on*/
	XLLP_MICRO_DISK_ON =0,
/*micro disk is powered off*/
	XLLP_MICRO_DISK_OFF =1,
/*micro disk is not inserted on the socket*/
	XLLP_MICRO_DISK_REMOVED = 2,
} XLLP_MICRO_DISK_STATE_T;

/*------------------------------------------------------------
 Function:  xllp_ture_ide_init_plat
 Purpose:  configure the MFP 
 Returns:  XLLP_STATUS_T
 	XLLP_STATUS_INVALIED_STATE 
 	means that the SW1 is not at right position
 I/F type: I/F PLAT 1
--------------------------------------------------------------*/
XLLP_STATUS_T xllp_ture_ide_init_plat(P_XLLP_TRUE_IDE_T true_ide_handle);
/*------------------------------------------------------------
 Function:  get_cf_socket_mode
 Purpose:  This function return the cf socket mode, if the Pin nSEL of CF socket 
	is pull down, the CF socket is in XLLP_CF_TURE_IDE_MOD mode, 
	at this mode micro disk that is CF true_ide interface can be used.
	Otherwise, the CF socket is in XLLP_CF_IO_MEM_MOD, at this 
	mode CF I/O and storage can be used. On zylonite board, we can 
	use register: 0x14200004 bit 4 to decide which mode the socket is in.  
	This function may also be used by XLLP PCCARD module. 
 Returns:  XLLP_CF_SOCKET_MODE
 parameter: hd_switch_addr:  the address of switch of true ide. 
 I/F type: E/F PLAT 2
--------------------------------------------------------------*/
XLLP_CF_SOCKET_MODE_T xllp_get_cf_socket_mode(P_XLLP_VUINT32_T hd_switch_addr);
/*------------------------------------------------------------
 Function:  xllp_ture_ide_deinit_plat
 Purpose:  deinitialize the plat
 Returns:  XLLP_STATUS_T
 	XLLP_STATUS_INVALIED_STATE 
 	means that the SW1 is not at right position
 I/F type: I/F PLAT 1
--------------------------------------------------------------*/
XLLP_STATUS_T xllp_true_ide_deinit_plat(P_XLLP_TRUE_IDE_T true_ide_handle);
/*------------------------------------------------------------
 Function:  xllp_micodisk_state
 Purpose:  get the micro disk state 
 Returns:  XLLP_MICRO_DISK_STATE_T
  I/F type: I/F PLAT 3
--------------------------------------------------------------*/
XLLP_MICRO_DISK_STATE_T xllp_microdisk_state(P_XLLP_TRUE_IDE_T true_ide_handle);

#endif
