/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *(C) Copyright 2006 Marvell International Ltd.  
 * All Rights Reserved 
 */

/****************************************************************************
**  FILENAME:       xllp_usbotg_zylonite.h
**  
**  PURPOSE: contains all USB OTG specific macros, typedefs, and prototypes.
**           Declares no storage.
**  
**  
******************************************************************************/

#ifndef __XLLP_USBOTG_ZYLONITE_H__
#define __XLLP_USBOTG_ZYLONITE_H__

#include "xllp_pm_arava.h"

/* Define bits in arava register event_b*/
#define EVENT_B_SRP_DETECT	( 1 << 6 )
#define EVENT_B_SESSION_VALID	( 1 << 5 )
#define EVENT_B_VBUS_4P0	( 1 << 4 )
#define EVENT_B_VBUS_4P4	( 1 << 3 )

/* Define bits in arava register USBPUMP */
#define USBPUMP_EN_USBVEP	( 1 << 7 )
#define USBPUMP_EN_USBVE	( 1 << 6 )
#define USBPUMP_SRP_DETECT	( 1 << 5 )
#define USBPUMP_SESSION_VALID	( 1 << 4 )
#define USBPUMP_VBUS_VALID_4P0	( 1 << 3 )
#define USBPUMP_VBUS_VALID_4P4	( 1 << 2 )
#define USBPUMP_USBVEP		( 1 << 1 )
#define USBPUMP_USBVE		( 1 << 0 )

/* Define bits in arava register MISC B */
#define MISCB_SESSION_VALID_ENABLE	( 1 << 3 )
#define MISCB_USB_INT_RISING		( 1 << 2 )

#define AravaRead(x, y) XllpPmAravaRead(pOtgHandle->pPI2cRegs, pOtgHandle->pOstRegs, x, y)

#define AravaWrite(x,y) XllpPmAravaWrite(pOtgHandle->pPI2cRegs, pOtgHandle->pOstRegs, x, y)

#endif //__XLLP_USBOTG_ZYLONITE_H__

