/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *(C) Copyright 2006 Marvell International Ltd.  
 * All Rights Reserved 
 */

/**
**  FILENAME:       xllp_dfc_plat.c
**
**  PURPOSE: Implementation for Xllp DFC module
**           
**					 
**            
**                  
**
******************************************************************************/

#include "xllp_dfc_plat.h"

static XLLP_STATUS_T Samsung512MbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1);

static XLLP_STATUS_T Samsung512MbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr);
	
static XLLP_STATUS_T Samsung2GbX8Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1);

static XLLP_STATUS_T Samsung2GbX8NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr);
 	
static XLLP_STATUS_T Micron1GbX8Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1);

static XLLP_STATUS_T Micron1GbX8Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1);

static XLLP_STATUS_T Micron1GbX8NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr);

static XLLP_STATUS_T Micron1GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1);

static XLLP_STATUS_T Micron1GbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr);

static XLLP_STATUS_T STM1GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1);

static XLLP_STATUS_T STM1GbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr);

static XLLP_STATUS_T STM70nm1GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1);

static XLLP_STATUS_T STM70nm1GbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr);

static XLLP_STATUS_T STM2GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1);

static XLLP_STATUS_T STM2GbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr);

static XLLP_STATUS_T TOSHIBA2GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1);

static XLLP_STATUS_T TOSHIBA2GbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr);

static XLLP_STATUS_T HYNIX2GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1);

static XLLP_STATUS_T HYNIX2GbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr);

#if 1

static XLLP_STATUS_T Micron2GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1);

static XLLP_STATUS_T Micron2GbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr);

static XLLP_DFC_FLASH_SPECS_T micron2GbX16 = {
	{
		10,      /* tCH, Enable signal hold time */
		35,      /* tCS, Enable signal setup time */
		15,      /* tWH, ND_nWE high duration */
		25,      /* tWP, ND_nWE pulse time */
		15,      /* tRH, ND_nRE high duration */
		25,      /* tRP, ND_nRE pulse width */
		25000,	 /* tR = tR+tRR+tWB+1, ND_nWE high to ND_nRE low for read */
		80,	/* tWHR, ND_nWE high to ND_nRE low delay for status read */
		10,      /* tAR, ND_ALE low to ND_nRE low delay */
	},
	1,    /* Data flash bus arbiter enable */
	64,   /* Pages per block */
	1,    /* Second cycle start, Row address start position */
	4,     /* Returned ID bytes */
	0,          /* NAND mode */
	0,
	2048,      /* Page size in bytes */
	16,      /* Width of Flash memory */
	16,        /* Width of flash controller */
	2048,     /* Number of physical blocks in Flash */
	0xba2c,
	5,  /* Read, Program Cycles */
	3,	//Block Unlock address cycles

	0x3000,        /* Read */
	0x0050,        /* Read1 unused, current DFC don't support */
	0x1080,      /* Write, two cycle command */
	0x0070,  /* Read status */
	0x0090,      /* Read ID */
	0xD060,       /* Erase, two cycle command */
	0x00FF,        /* Reset */
	0x002A,         /* Lock whole flash */
	0x23,	// set lower boundary of unlocking area
	0x24,	// set upper boundary of unlocking area
	0x007A,  /* Read block lock status */
	Micron2GbX16Addr2NDCB1,
	Micron2GbX16NDBBR2Addr,
};

static XLLP_STATUS_T Micron2GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1)
{
	XLLP_UINT32_T ndcb1 = 0;
	XLLP_UINT32_T page;

	if (addr >= 0x10000000)
		return XLLP_STATUS_UNSUPPORTED;
	page = addr / micron2GbX16.pageSize;
	addr =  (page / micron2GbX16.pagePerBlock) << 17 |
		(page % micron2GbX16.pagePerBlock) << 11;

	if (cmd == micron2GbX16.read1 || cmd == micron2GbX16.program) {
		ndcb1 = (addr & 0x7FF) | ((addr << 5) & 0xFFFF0000);
	}
	else if (cmd == micron2GbX16.erase
			|| cmd == micron2GbX16.unlock_low
			|| cmd == micron2GbX16.unlock_high) {
		ndcb1 = ((addr >> 17) << 6) & 0x1FFFF;
	}
	*pNdcb1 = ndcb1;
	return XLLP_STATUS_SUCCESS;

}

static XLLP_STATUS_T Micron2GbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr)
{
	if (cmd == micron2GbX16.read1 || cmd == micron2GbX16.program) {
		*pAddr = ((ndbbr & 0x7) << 8) | ((ndbbr >> 8) << 16);
	}
	else if (cmd == micron2GbX16.erase) {
		*pAddr = (ndbbr >> 6) << 17;
	}
	
	return XLLP_STATUS_SUCCESS;
}

#endif	//1

static XLLP_DFC_FLASH_SPECS_T samsung512MbX16 =

{
	{
		10,	// tCH, Enable signal hold time.
		0,	// tCS, Enable signal setup time.
		20,	// tWH, ND_nWE high duration.
		40,	// tWP, ND_nWE pulse time.
		20,	// tRH, ND_nRE high duration.
		40,	// tRP, ND_nRE pulse width.
		11123,	// tR = tR + tRR + tWB + 1, ND_nWE high to ND_nRE low for read.
		110,	// tWHR, ND_nWE high to ND_nRE low delay for status read.
		10,	// tAR, ND_ALE low to ND_nRE low delay.
	},
	1,	// Data flash bus arbiter enable (ND_ARB_EN).
	32,	// Pages per block (PG_PER_BLK).
	0,	// Second cycle start, Row address start position (RA_START).
	2,	// 2 bytes, returned ID bytes(RD_ID_CNT).
	0,	// NAND, (ND_MODE)
	0,	// Chip select don't care bit (NCSX).
	512,	// Page size in bytes (PAGE_SZ).
	16,	// 16, Width of Flash memory (DWIDTH_M).
	16,	// 16, Width of flash controller(DWIDTH_C).
	4096,	// Number of physical blocks in Flash
	0x46ec, // NAND chip ID
	4,	// Read, Program address cycles
	0,	// Block Unlock address cycles
	// command codes

	0x0000,	// Read
	0x0050,	// Read1 unused, current DFC don't support
	0x1080,	// Write, two cycle command
	0x0070,	// Read status
	0x0090,	// Read ID
	0xD060,	// Erase, two cycle command
	0x00FF,	// Reset
	0x002A,	// Lock whole flash
	0x23, 	// set lower boundary of unlocking area
	0x24,	// set upper boundary of unlocking area
	0x007A,	// Read block lock status
	Samsung512MbX16Addr2NDCB1,
	Samsung512MbX16NDBBR2Addr,
};

static XLLP_DFC_FLASH_SPECS_T samsung2GbX8 =
{
	{
		10,	// tCH, Enable signal hold time.
		35,	// tCS, Enable signal setup time.
		15,	// tWH, ND_nWE high duration.
		25,	// tWP, ND_nWE pulse time.
		15,	// tRH, ND_nRE high duration.
		25,	// tRP, ND_nRE pulse width.
		25000,	// tR = tR + tRR + tWB + 1, ND_nWE high to ND_nRE low for read.
		60,	// tWHR, ND_nWE high to ND_nRE low delay for status read.
		10,	// tAR, ND_ALE low to ND_nRE low delay.
	},

	1,	// Data flash bus arbiter enable (ND_ARB_EN).
	64,	// 32, Pages per block (PG_PER_BLK).
	1,	// Second cycle start, Row address start position (RA_START).
	4,	// 2 bytes, returned ID bytes(RD_ID_CNT).
	0,	// NAND, (ND_MODE)
	0,	// Chip select don't care bit (NCSX).
	2048,	// 512, Page size in bytes (PAGE_SZ).
	8,	// 16, Width of Flash memory (DWIDTH_M).
	8,	// 16, Width of flash controller(DWIDTH_C).
	2048,	// Number of physical blocks in Flash
	0xaaec, // NAND chip ID
	5,	// Read, Program address cycles
	0,	// Block Unlock address cycles
	// command codes

	0x3000,	// Read
	0x0050,	// Read1 unused, current DFC don't support
	0x1080,	// Write, two cycle command
	0x0070,	// Read status
	0x0090,	// Read ID
	0xD060,	// Erase, two cycle command
	0x00FF,	// Reset
	0x002A,	// Lock whole flash
	0x23, 	// set lower boundary of unlocking area
	0x24,	// set upper boundary of unlocking area
	0x007A,	// Read block lock status
	Samsung2GbX8Addr2NDCB1,
	Samsung2GbX8NDBBR2Addr,
};


 
static XLLP_DFC_FLASH_SPECS_T micron1GbX8 =
{
	{
		10,	// tCH, Enable signal hold time.
		25,	// tCS, Enable signal setup time.
		20,	// tWH, ND_nWE high duration.
		25,	// tWP, ND_nWE pulse time.
		15,	// tRH, ND_nRE high duration.
		25,	// tRP, ND_nRE pulse width.
		25000,	// tR = tR + tRR + tWB + 1, ND_nWE high to ND_nRE low for read.
		60,	// tWHR, ND_nWE high to ND_nRE low delay for status read.
		10,	// tAR, ND_ALE low to ND_nRE low delay.
	},
	1,	// Data flash bus arbiter enable (ND_ARB_EN).
	64,	// 32, Pages per block (PG_PER_BLK).
	1,	// Second cycle start, Row address start position (RA_START).
	4,	// 2 bytes, returned ID bytes(RD_ID_CNT).
	0,	// NAND, (ND_MODE)
	0,	// Chip select don't care bit (NCSX).
	2048,	// 512, Page size in bytes (PAGE_SZ).
	8,	// 16, Width of Flash memory (DWIDTH_M).
	8,	// 16, Width of flash controller(DWIDTH_C).
	1024,	// Number of physical blocks in Flash
	0xa12c, // NAND chip ID
	4,	// Read, Program address cycles
	2,	// Block Unlock address cycles
	// command codes

	0x3000,	// Read
	0x0050,	// Read1 unused, current DFC don't support
	0x1080,	// Write, two cycle command
	0x0070,	// Read status
	0x0090,	// Read ID
	0xD060,	// Erase, two cycle command
	0x00FF,	// Reset
	0x002A,	// Lock whole flash
	0x23,	// set lower boundary of unlocking area
	0x24,	// set upper boundary of unlocking area
	0x007A,	// Read block lock status
	Micron1GbX8Addr2NDCB1,
	Micron1GbX8NDBBR2Addr,
};

static XLLP_DFC_FLASH_SPECS_T micron1GbX16 =
{
	{
		10,	// tCH, Enable signal hold time.
		25,	// tCS, Enable signal setup time.
		15,	// tWH, ND_nWE high duration.
		25,	// tWP, ND_nWE pulse time.
		15,	// tRH, ND_nRE high duration.
		25,	// tRP, ND_nRE pulse width.
		25000,	// tR = tR + tRR + tWB + 1, ND_nWE high to ND_nRE low for read.
		60,	// tWHR, ND_nWE high to ND_nRE low delay for status read.
		10,	// tAR, ND_ALE low to ND_nRE low delay.
	},
	1,	// Data flash bus arbiter enable (ND_ARB_EN).
	64,	// 32, Pages per block (PG_PER_BLK).
	1,	// Second cycle start, Row address start position (RA_START).
	4,	// 2 bytes, returned ID bytes(RD_ID_CNT).
	0,	// NAND, (ND_MODE)
	0,	// Chip select don't care bit (NCSX).
	2048,	// 512, Page size in bytes (PAGE_SZ).
	16,	// width of flash memory (DWIDTH_M)
	16,	// width of flash controller (DWIDTH_C)
	1024,	// Number of physical blocks in Flash
	0xb12c, // NAND chip ID
	4,	// Read, Program address cycles
	2,	// Block Unlock address cycles
	// command codes

	0x3000,	// Read
	0x0050,	// Read1 unused, current DFC don't support
	0x1080,	// Write, two cycle command
	0x0070,	// Read status
	0x0090,	// Read ID
	0xD060,	// Erase, two cycle command
	0x00FF,	// Reset
	0x002A,	// Lock whole flash
	0x23,	// set lower boundary of unlocking area
	0x24,	// set upper boundary of unlocking area
	0x007A,	// Read block lock status
	Micron1GbX16Addr2NDCB1,
	Micron1GbX16NDBBR2Addr,
};

static XLLP_DFC_FLASH_SPECS_T stm1GbX16 =
{
	{
		10,	// tCH, Enable signal hold time.
		10,	// tCS, Enable signal setup time.
		20,	// tWH, ND_nWE high duration.
		25,	// tWP, ND_nWE pulse time.
		20,	// tRH, ND_nRE high duration.
		25,	// tRP, ND_nRE pulse width.
		25000,	// tR = tR + tRR + tWB + 1, ND_nWE high to ND_nRE low for read.
		60,	// tWHR, ND_nWE high to ND_nRE low delay for status read.
		10,	// tAR, ND_ALE low to ND_nRE low delay.
	},
	1,	// Data flash bus arbiter enable (ND_ARB_EN).
	64,	// 32, Pages per block (PG_PER_BLK).
	1,	// Second cycle start, Row address start position (RA_START).
	4,	// 2 bytes, returned ID bytes(RD_ID_CNT).
	0,	// NAND, (ND_MODE)
	0,	// Chip select don't care bit (NCSX).
	2048,	// 512, Page size in bytes (PAGE_SZ).
	16,	// width of flash memory (DWIDTH_M)
	16,	// width of flash controller (DWIDTH_C)
	1024,	// Number of physical blocks in Flash
	0xc120, // NAND chip ID
	4,	// Read, Program address cycles
	2,	// Block Unlock address cycles
	// command codes

	0x3000,	// Read
	0x0050,	// Read1 unused, current DFC don't support
	0x1080,	// Write, two cycle command
	0x0070,	// Read status
	0x0090,	// Read ID
	0xD060,	// Erase, two cycle command
	0x00FF,	// Reset
	0x002A,	// Lock whole flash
	0x23,	// set lower boundary of unlocking area
	0x24,	// set upper boundary of unlocking area
	0x007A,	// Read block lock status
	STM1GbX16Addr2NDCB1,
	STM1GbX16NDBBR2Addr,
};

static XLLP_DFC_FLASH_SPECS_T stm70nm1GbX16 =
{
	{
		30,	// tCH, Enable signal hold time.
		35,	// tCS, Enable signal setup time.
		15,	// tWH, ND_nWE high duration.
		25,	// tWP, ND_nWE pulse time.
		15,	// tRH, ND_nRE high duration.
		25,	// tRP, ND_nRE pulse width.
		25000,	// tR = tR + tRR + tWB + 1, ND_nWE high to ND_nRE low for read.
		60,	// tWHR, ND_nWE high to ND_nRE low delay for status read.
		10,	// tAR, ND_ALE low to ND_nRE low delay.
	},
	1,	// Data flash bus arbiter enable (ND_ARB_EN).
	64,	// 32, Pages per block (PG_PER_BLK).
	1,	// Second cycle start, Row address start position (RA_START).
	4,	// 2 bytes, returned ID bytes(RD_ID_CNT).
	0,	// NAND, (ND_MODE)
	0,	// Chip select don't care bit (NCSX).
	2048,	// 512, Page size in bytes (PAGE_SZ).
	16,	// width of flash memory (DWIDTH_M)
	16,	// width of flash controller (DWIDTH_C)
	1024,	// Number of physical blocks in Flash
	0xb120, // NAND chip ID
	4,	// Read, Program address cycles
	2,	// Block Unlock address cycles
	// command codes

	0x3000,	// Read
	0x0050,	// Read1 unused, current DFC don't support
	0x1080,	// Write, two cycle command
	0x0070,	// Read status
	0x0090,	// Read ID
	0xD060,	// Erase, two cycle command
	0x00FF,	// Reset
	0x002A,	// Lock whole flash
	0x23,	// set lower boundary of unlocking area
	0x24,	// set upper boundary of unlocking area
	0x007A,	// Read block lock status
	STM70nm1GbX16Addr2NDCB1,
	STM70nm1GbX16NDBBR2Addr,
};

static XLLP_DFC_FLASH_SPECS_T stm2GbX16 =
{
	{
		10,	// tCH, Enable signal hold time.
		35,	// tCS, Enable signal setup time.
		15,	// tWH, ND_nWE high duration.
		25,	// tWP, ND_nWE pulse time.
		15,	// tRH, ND_nRE high duration.
		25,	// tRP, ND_nRE pulse width.
		25000,	// tR = tR + tRR + tWB + 1, ND_nWE high to ND_nRE low for read.
		60,	// tWHR, ND_nWE high to ND_nRE low delay for status read.
		10,	// tAR, ND_ALE low to ND_nRE low delay.
	},
	1,	// Data flash bus arbiter enable (ND_ARB_EN).
	64,	// 32, Pages per block (PG_PER_BLK).
	1,	// Second cycle start, Row address start position (RA_START).
	4,	// 2 bytes, returned ID bytes(RD_ID_CNT).
	0,	// NAND, (ND_MODE)
	0,	// Chip select don't care bit (NCSX).
	2048,	// 512, Page size in bytes (PAGE_SZ).
	16,	// width of flash memory (DWIDTH_M)
	16,	// width of flash controller (DWIDTH_C)
	2048,	// Number of physical blocks in Flash
	0xba20, // NAND chip ID
	5,	// Read, Program address cycles
	3,	// Block Unlock address cycles
	// command codes
#ifdef CACHE_READ
	0x3100,	// Read
#else
	0x3000,	// Read
#endif
	0x0050,	// Read1 unused, current DFC don't support
	0x1080,	// Write, two cycle command
	0x0070,	// Read status
	0x0090,	// Read ID
	0xD060,	// Erase, two cycle command
	0x00FF,	// Reset
	0x002A,	// Lock whole flash
	0x23,	// set lower boundary of unlocking area
	0x24,	// set upper boundary of unlocking area
	0x007A,	// Read block lock status
	STM2GbX16Addr2NDCB1,
	STM2GbX16NDBBR2Addr,
};

static XLLP_DFC_FLASH_SPECS_T toshiba2GbX16 =
{
	{
		6,	// tCH, Enable signal hold time.
		10,	// tCS, Enable signal setup time.
		15,	// tWH, ND_nWE high duration.
		30,	// tWP, ND_nWE pulse time.
		25,	// tRH, ND_nRE high duration.
		50,	// tRP, ND_nRE pulse width.
		25000,	// tR = tR + tRR + tWB + 1, ND_nWE high to ND_nRE low for read.
		60,	// tWHR, ND_nWE high to ND_nRE low delay for status read.
		10,	// tAR, ND_ALE low to ND_nRE low delay.
	},
	1,	// Data flash bus arbiter enable (ND_ARB_EN).
	64,	// 32, Pages per block (PG_PER_BLK).
	1,	// Second cycle start, Row address start position (RA_START).
	4,	// 2 bytes, returned ID bytes(RD_ID_CNT).
	0,	// NAND, (ND_MODE)
	0,	// Chip select don't care bit (NCSX).
	2048,	// 512, Page size in bytes (PAGE_SZ).
	16,	// width of flash memory (DWIDTH_M)
	16,	// width of flash controller (DWIDTH_C)
	2048,	// Number of physical blocks in Flash
	0xba98, // NAND chip ID
	5,	// Read, Program address cycles
	0,	// Block Unlock address cycles
	// command codes

	0x3000,	// Read
	0x0050,	// Read1 unused, current DFC don't support
	0x1080,	// Write, two cycle command
	0x0070,	// Read status
	0x0090,	// Read ID
	0xD060,	// Erase, two cycle command
	0x00FF,	// Reset
	0x002A,	// Lock whole flash
	0x23,	// set lower boundary of unlocking area
	0x24,	// set upper boundary of unlocking area
	0x007A,	// Read block lock status
	TOSHIBA2GbX16Addr2NDCB1,
	TOSHIBA2GbX16NDBBR2Addr,
};


static XLLP_DFC_FLASH_SPECS_T Hynix2GbX16 =
{
	{
		10,	// tCH, Enable signal hold time.
		35,	// tCS, Enable signal setup time.
		15,	// tWH, ND_nWE high duration.
		25,	// tWP, ND_nWE pulse time.
		15,	// tRH, ND_nRE high duration.
		25,	// tRP, ND_nRE pulse width.
		25000,	// tR = tR + tRR + tWB + 1, ND_nWE high to ND_nRE low for read.
		60,	// tWHR, ND_nWE high to ND_nRE low delay for status read.
		10,	// tAR, ND_ALE low to ND_nRE low delay.
	},
	1,	// Data flash bus arbiter enable (ND_ARB_EN).
	64,	// 32, Pages per block (PG_PER_BLK).
	1,	// Second cycle start, Row address start position (RA_START).
	4,	// 2 bytes, returned ID bytes(RD_ID_CNT).
	0,	// NAND, (ND_MODE)
	0,	// Chip select don't care bit (NCSX).
	2048,	// 512, Page size in bytes (PAGE_SZ).
	16,	// width of flash memory (DWIDTH_M)
	16,	// width of flash controller (DWIDTH_C)
	2048,	// Number of physical blocks in Flash
	0xbaad, // NAND chip ID
	5,	// Read, Program address cycles
	0,	// Block Unlock address cycles
	// command codes

	0x3000,	// Read
	0x0050,	// Read1 unused, current DFC don't support
	0x1080,	// Write, two cycle command
	0x0070,	// Read status
	0x0090,	// Read ID
	0xD060,	// Erase, two cycle command
	0x00FF,	// Reset
	0x002A,	// Lock whole flash
	0x23,	// set lower boundary of unlocking area
	0x24,	// set upper boundary of unlocking area
	0x007A,	// Read block lock status
	HYNIX2GbX16Addr2NDCB1,
	HYNIX2GbX16NDBBR2Addr,
};
typedef struct {
	XLLP_DFC_FLASH_TYPE type;
	XLLP_DFC_FLASH_SPECS_T *pFlashInfo;
} XLLP_DFC_FLASH_TYPE_INFO;

static XLLP_DFC_FLASH_TYPE_INFO typeInfo[] = {
	{ XLLP_DFC_FLASH_Samsung512MbX16, &samsung512MbX16},
	{ XLLP_DFC_FLASH_Samsung2GbX8, &samsung2GbX8},
	{ XLLP_DFC_FLASH_Micron1GbX8, &micron1GbX8},
	{ XLLP_DFC_FLASH_Micron1GbX16,&micron1GbX16},
	{ XLLP_DFC_FLASH_STM1GbX16,&stm1GbX16},
	{ XLLP_DFC_FLASH_STM2GbX16,&stm2GbX16},
	{ XLLP_DFC_FLASH_STM70nm1GbX16,&stm70nm1GbX16},
	{ XLLP_DFC_FLASH_Toshiba2GbX16,&toshiba2GbX16},
	{ XLLP_DFC_FLASH_Micron2GbX16,&micron2GbX16},
	{ XLLP_DFC_FLASH_Hynix2GbX16,&Hynix2GbX16},
	{ XLLP_DFC_FLASH_NULL, NULL},
};

static XLLP_STATUS_T Samsung512MbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1)
{
	XLLP_UINT32_T ndcb1 = 0;

	if (addr >= 0x4000000)
		return XLLP_STATUS_UNSUPPORTED;
	if (cmd == samsung512MbX16.read1 || cmd == samsung512MbX16.program) {
		ndcb1 = (addr & 0xFF) | ((addr >> 1) & 0x01FFFF00);
	}
	else if (cmd == samsung512MbX16.erase
			|| samsung512MbX16.unlock_low
			|| samsung512MbX16.unlock_high) {
		ndcb1 = ((addr >> 9) & 0x00FFFFFF);
	}
	
	*pNdcb1 = ndcb1;
	return XLLP_STATUS_SUCCESS;

}

static XLLP_STATUS_T Samsung512MbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr)
{
	*pAddr = ndbbr << 9;
	
	return XLLP_STATUS_SUCCESS;
}

static XLLP_STATUS_T Samsung2GbX8Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1)
{
	XLLP_UINT32_T ndcb1 = 0;
	XLLP_UINT32_T page;

	if (addr >= 0x10000000)
		return XLLP_STATUS_UNSUPPORTED;
	page = addr / samsung2GbX8.pageSize;
	addr =  (page / samsung2GbX8.pagePerBlock) << 18 |
		(page % samsung2GbX8.pagePerBlock) << 12;
		
	if (cmd == samsung2GbX8.read1 || cmd == samsung2GbX8.program) {
		ndcb1 = (addr & 0xFFF) | ((addr << 4) & 0xFFFF0000);
	}
	else if (cmd == samsung2GbX8.erase) {
		ndcb1 = ((addr >> 18) << 6) & 0x1FFFF;
	}
	*pNdcb1 = ndcb1;
	return XLLP_STATUS_SUCCESS;

}

static XLLP_STATUS_T Samsung2GbX8NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr)
{
	if (cmd == samsung2GbX8.read1 || cmd == samsung2GbX8.program) {
		*pAddr = ((ndbbr & 0xF) << 8) | ((ndbbr >> 8) << 16);
	}
	else if (cmd == samsung2GbX8.erase) {
		*pAddr = (ndbbr >> 6) << 18;
	}
	
	return XLLP_STATUS_SUCCESS;

}

static XLLP_STATUS_T Micron1GbX8Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1)
{
	XLLP_UINT32_T ndcb1 = 0;
	XLLP_UINT32_T page;

	if (addr >= 0x8000000)
		return XLLP_STATUS_UNSUPPORTED;
	page = addr / micron1GbX8.pageSize;
	addr =  (page / micron1GbX8.pagePerBlock) << 18 |
		(page % micron1GbX8.pagePerBlock) << 12;
		
	if (cmd == micron1GbX8.read1 || cmd == micron1GbX8.program) {
		ndcb1 = (addr & 0xFFF) | ((addr << 4) & 0xFFFF0000);
	}
	else if (cmd == micron1GbX8.erase
			|| cmd == micron1GbX8.unlock_low
			|| cmd == micron1GbX8.unlock_high) {
		ndcb1 = ((addr >> 18) << 6) & 0xFFFF;
	}
	*pNdcb1 = ndcb1;
	return XLLP_STATUS_SUCCESS;
}

static XLLP_STATUS_T Micron1GbX8NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr)
{
	if (cmd == micron1GbX8.read1 || cmd == micron1GbX8.program) {
		*pAddr = ((ndbbr & 0xF) << 8) | ((ndbbr >> 8) << 16);
	}
	else if (cmd == micron1GbX8.erase) {
		*pAddr = (ndbbr >> 6) << 18;
	}
	
	return XLLP_STATUS_SUCCESS;
}

static XLLP_STATUS_T Micron1GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1)
{
	XLLP_UINT32_T ndcb1 = 0;
	XLLP_UINT32_T page;

	if (addr >= 0x8000000)
		return XLLP_STATUS_UNSUPPORTED;
	page = addr / micron1GbX16.pageSize;
	addr =  (page / micron1GbX16.pagePerBlock) << 17 |
		(page % micron1GbX16.pagePerBlock) << 11;

	if (cmd == micron1GbX16.read1 || cmd == micron1GbX16.program) {
		ndcb1 = (addr & 0x7FF) | ((addr << 5) & 0xFFFF0000);
	}
	else if (cmd == micron1GbX16.erase
			|| cmd == micron1GbX16.unlock_low
			|| cmd == micron1GbX16.unlock_high) {
		ndcb1 = ((addr >> 17) << 6) & 0xFFFF;
	}
	*pNdcb1 = ndcb1;
	return XLLP_STATUS_SUCCESS;

}

static XLLP_STATUS_T Micron1GbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr)
{
	if (cmd == micron1GbX16.read1 || cmd == micron1GbX16.program) {
		*pAddr = ((ndbbr & 0x7) << 8) | ((ndbbr >> 8) << 16);
	}
	else if (cmd == micron1GbX16.erase) {
		*pAddr = (ndbbr >> 6) << 17;
	}
	
	return XLLP_STATUS_SUCCESS;
}

static XLLP_STATUS_T STM1GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1)
{
	XLLP_UINT32_T ndcb1 = 0;
	XLLP_UINT32_T page;

	if (addr >= 0x8000000)
		return XLLP_STATUS_UNSUPPORTED;
	page = addr / stm1GbX16.pageSize;
	addr =  (page / stm1GbX16.pagePerBlock) << 17 |
		(page % stm1GbX16.pagePerBlock) << 11;

	if (cmd == stm1GbX16.read1 || cmd == stm1GbX16.program) {
		ndcb1 = (addr & 0x7FF) | ((addr << 5) & 0xFFFF0000);
	}
	else if (cmd == stm1GbX16.erase
			|| cmd == stm1GbX16.unlock_low
			|| cmd == stm1GbX16.unlock_high) {
		ndcb1 = ((addr >> 17) << 6) & 0xFFFF;
	}
	*pNdcb1 = ndcb1;
	return XLLP_STATUS_SUCCESS;

}

static XLLP_STATUS_T STM1GbX16NDBBR2Addr(
		XLLP_UINT16_T __attribute__((unused)) cmd,
	       	XLLP_UINT32_T __attribute__((unused)) ndbbr, 
		XLLP_UINT32_T __attribute__((unused)) *pAddr
		)
{
	if (cmd == stm1GbX16.read1 || cmd == stm1GbX16.program) {
		*pAddr = ((ndbbr & 0x7) << 8) | ((ndbbr >> 8) << 16);
	}
	else if (cmd == stm1GbX16.erase) {
		*pAddr = (ndbbr >> 6) << 17;
	}
	
	return XLLP_STATUS_SUCCESS;
}

static XLLP_STATUS_T STM70nm1GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1)
{
	XLLP_UINT32_T ndcb1 = 0;
	XLLP_UINT32_T page;

	if (addr >= 0x8000000)
		return XLLP_STATUS_UNSUPPORTED;
	page = addr / stm70nm1GbX16.pageSize;
	addr =  (page / stm70nm1GbX16.pagePerBlock) << 17 |
		(page % stm70nm1GbX16.pagePerBlock) << 11;

	if (cmd == stm70nm1GbX16.read1 || cmd == stm70nm1GbX16.program) {
		ndcb1 = (addr & 0x7FF) | ((addr << 5) & 0xFFFF0000);
	}
	else if (cmd == stm70nm1GbX16.erase
			|| cmd == stm70nm1GbX16.unlock_low
			|| cmd == stm70nm1GbX16.unlock_high) {
		ndcb1 = ((addr >> 17) << 6) & 0xFFFF;
	}
	*pNdcb1 = ndcb1;
	return XLLP_STATUS_SUCCESS;

}

static XLLP_STATUS_T STM70nm1GbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr)
{
	if (cmd == stm70nm1GbX16.read1 || cmd == stm70nm1GbX16.program) {
		*pAddr = ((ndbbr & 0x7) << 8) | ((ndbbr >> 8) << 16);
	}
	else if (cmd == stm70nm1GbX16.erase) {
		*pAddr = (ndbbr >> 6) << 17;
	}
	
	return XLLP_STATUS_SUCCESS;
}


static XLLP_STATUS_T STM2GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1)
{
	XLLP_UINT32_T ndcb1 = 0;
	XLLP_UINT32_T page;

	if (addr >= 0x10000000)
		return XLLP_STATUS_UNSUPPORTED;
	page = addr / stm2GbX16.pageSize;
	addr =  (page / stm2GbX16.pagePerBlock) << 17 |
		(page % stm2GbX16.pagePerBlock) << 11;

	if (cmd == stm2GbX16.read1 || cmd == stm2GbX16.program) {
		ndcb1 = (addr & 0x7FF) | ((addr << 5) & 0xFFFF0000);
	}
	else if (cmd == stm2GbX16.erase
			|| cmd == stm2GbX16.unlock_low
			|| cmd == stm2GbX16.unlock_high) {
		ndcb1 = ((addr >> 17) << 6) & 0x1FFFF;
	}
	*pNdcb1 = ndcb1;
	return XLLP_STATUS_SUCCESS;

}

static XLLP_STATUS_T STM2GbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr)
{
	if (cmd == stm2GbX16.read1 || cmd == stm2GbX16.program) {
		*pAddr = ((ndbbr & 0x7) << 8) | ((ndbbr >> 8) << 16);
	}
	else if (cmd == stm2GbX16.erase) {
		*pAddr = (ndbbr >> 6) << 17;
	}
	
	return XLLP_STATUS_SUCCESS;
}

static XLLP_STATUS_T TOSHIBA2GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1)
{
	XLLP_UINT32_T ndcb1 = 0;
	XLLP_UINT32_T page;

	if (addr >= 0x10000000)
		return XLLP_STATUS_UNSUPPORTED;
	page = addr / toshiba2GbX16.pageSize;
	addr =  (page / toshiba2GbX16.pagePerBlock) << 18 |
		(page % toshiba2GbX16.pagePerBlock) << 12;

	if (cmd == toshiba2GbX16.read1 || cmd == toshiba2GbX16.program) {
		ndcb1 = (addr & 0xFFF) | ((addr << 4) & 0xFFFF0000);
	}
	else if (cmd == toshiba2GbX16.erase
			|| cmd == toshiba2GbX16.unlock_low
			|| cmd == toshiba2GbX16.unlock_high) {
		ndcb1 = ((addr >> 18) << 6) & 0x1FFFF;
	}
	*pNdcb1 = ndcb1;
	return XLLP_STATUS_SUCCESS;

}

static XLLP_STATUS_T TOSHIBA2GbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr)
{
	if (cmd == toshiba2GbX16.read1 || cmd == toshiba2GbX16.program) {
		*pAddr = ((ndbbr & 0xF) << 8) | ((ndbbr >> 8) << 16);
	}
	else if (cmd == toshiba2GbX16.erase) {
		*pAddr = (ndbbr >> 6) << 18;
	}
	
	return XLLP_STATUS_SUCCESS;
}


static XLLP_STATUS_T HYNIX2GbX16Addr2NDCB1(XLLP_UINT16_T cmd, XLLP_UINT32_T addr, XLLP_UINT32_T *pNdcb1)
{
	XLLP_UINT32_T ndcb1 = 0;
	XLLP_UINT32_T page;

	if (addr >= 0x10000000)
		return XLLP_STATUS_UNSUPPORTED;
	page = addr / Hynix2GbX16.pageSize;
	addr =  (page / Hynix2GbX16.pagePerBlock) << 18 |
		(page % Hynix2GbX16.pagePerBlock) << 12;

	if (cmd == Hynix2GbX16.read1 || cmd == Hynix2GbX16.program) {
		ndcb1 = (addr & 0xFFF) | ((addr << 4) & 0xFFFF0000);
	}
	else if (cmd == Hynix2GbX16.erase
		|| cmd == Hynix2GbX16.unlock_low
		|| cmd == Hynix2GbX16.unlock_high) {
			ndcb1 = ((addr >> 18) << 6) & 0x1FFFF;
	}
	*pNdcb1 = ndcb1;
	return XLLP_STATUS_SUCCESS;

}

static XLLP_STATUS_T HYNIX2GbX16NDBBR2Addr(XLLP_UINT16_T cmd, XLLP_UINT32_T ndbbr, XLLP_UINT32_T *pAddr)
{
	if (cmd == Hynix2GbX16.read1 || cmd == Hynix2GbX16.program) {
		*pAddr = ((ndbbr & 0xF) << 8) | ((ndbbr >> 8) << 16);
	}
	else if (cmd == Hynix2GbX16.erase) {
		*pAddr = (ndbbr >> 6) << 18;
	}

	return XLLP_STATUS_SUCCESS;
}
XLLP_STATUS_T XllpFlashDfcGetFlashInfo(XLLP_DFC_FLASH_TYPE type, XLLP_DFC_FLASH_SPECS_T **ppFlashInfo)
{
	XLLP_UINT32_T i = 0;
	
	while(typeInfo[i].type != XLLP_DFC_FLASH_NULL) {
		if (typeInfo[i].type == type) {
			*ppFlashInfo = typeInfo[i].pFlashInfo;
			return XLLP_STATUS_SUCCESS;	
		}
		i++;
	}
	*ppFlashInfo = NULL;	
	return XLLP_STATUS_UNSUPPORTED;
}

