/*++
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *(C) Copyright 2006 Marvell International Ltd.  
 * All Rights Reserved 
--*/
/******************************************************************************
**
**  FILENAME:       xllp_mmc_board.c
**
**  PURPOSE: MMC Xllp API that is board scope. These APIs contains  all
**           needed to enable MMC on board like GPIO,WP
**           
**            
**                  
**
******************************************************************************/
#include "xllp_mmc.h"

XLLP_STATUS_T 
XllpMMCConfigure(P_XLLP_MMC_CONTEXT_T pContext)
{
  XLLP_STATUS_T status;
  XLLP_INT32_T  i=0;
  
  XLLP_UINT32_T mmc_mfp_list[] = {
    XLLP_MFP_MMC_CD_0_GPIO_OFFSET,
    //XLLP_MFP_MMC_CD_1_GPIO_OFFSET,
    XLLP_MFP_MMC_WP_0_N_GPIO_OFFSET,
    XLLP_MFP_MMC_WP_1_N_GPIO_OFFSET,
    XLLP_MFP_MMC_DAT0_OFFSET,
    XLLP_MFP_MMC_DAT1_OFFSET,
    XLLP_MFP_MMC_DAT2_OFFSET,
    XLLP_MFP_MMC_DAT3_OFFSET,
    XLLP_MFP_MMC_CLK_OFFSET,
    XLLP_MFP_MMC_CMD_0_OFFSET,
    XLLP_MFP_MMC_CMD_1_OFFSET,
    XLLP_MFP_RSVD_GPIO_1_OFFSET,
    XLLP_MFP_PIN_EOLIST_MARKER
  };
  
  XLLP_MFP_ALT_FN_T mmc_af_list[] = {
    XLLP_MFP_MMC_CD_0_GPIO_AF,
    //XLLP_MFP_MMC_CD_1_GPIO_AF,
    XLLP_MFP_MMC_WP_0_N_GPIO_AF,
    XLLP_MFP_MMC_WP_1_N_GPIO_AF,
    XLLP_MFP_MMC_DAT0_AF,
    XLLP_MFP_MMC_DAT1_AF,
    XLLP_MFP_MMC_DAT2_AF,
    XLLP_MFP_MMC_DAT3_AF,
    XLLP_MFP_MMC_CLK_AF,
    XLLP_MFP_ALT_FN_0, //XLLP_MFP_MMC_CMD_0_AF, defaultly initialized to GPIO
    XLLP_MFP_ALT_FN_0, //XLLP_MFP_MMC_CMD_1_AF, defaultly initialized to GPIO
    XLLP_MFP_RSVD_GPIO_1_AF
  };
  
  XLLP_MFP_DRIVE_STRENGTH_T mmc_ds_list[] = {
    XLLP_MFP_DEFAULT_DS,
    //XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS // for slot1 not selected, any requirement?
  };

  XLLP_MFP_LPM_OUTPUT_T mmc_lpm_list[] = {
    XLLP_MFP_LPMO_DRIVE_HIGH,
    //XLLP_MFP_LPMO_DRIVE_HIGH,
    XLLP_MFP_LPMO_DRIVE_LOW,
    XLLP_MFP_LPMO_DRIVE_LOW,
    XLLP_MFP_LPMO_DRIVE_HIGH,
    XLLP_MFP_LPMO_DRIVE_HIGH,
    XLLP_MFP_LPMO_DRIVE_HIGH,
    XLLP_MFP_LPMO_DRIVE_HIGH,
    XLLP_MFP_LPMO_DRIVE_HIGH, //CLK
    XLLP_MFP_LPMO_DRIVE_HIGH, //CMD0
    XLLP_MFP_LPMO_DRIVE_HIGH, //CMD1
    XLLP_MFP_LPMO_DRIVE_HIGH  //GPIO1_2
  };

  status = XllpMfpResourceManager_List(pContext->pMFPRmDb,
                                      &mmc_mfp_list[0],
                                      XLLP_MFP_RM_ID_XLLP_MMC,
                                      XLLP_SET);
  if (status != XLLP_STATUS_SUCCESS){
    return status;
  }
  
  status = XllpMfpSetAfDs_List(pContext->pMFPBase,
                                &mmc_mfp_list[0],
                                &mmc_af_list[0],
                                &mmc_ds_list[0]);
  if (status != XLLP_STATUS_SUCCESS){
    return status;
  }
  
  status = XllpMfpConfigureLpmOutputLevel_List(pContext->pMFPBase,
               					&mmc_mfp_list[0],
								&mmc_lpm_list[0]);
  if (status != XLLP_STATUS_SUCCESS){
    return status;
  }


  // Todo, need configure pullup/pulldown/sleep_sel/sleep_oe_n/sleep_data??
  while(mmc_mfp_list[i] != XLLP_MFP_PIN_EOLIST_MARKER) {
    status = XllpMfpActivatePullUpDown(pContext->pMFPBase,
                                mmc_mfp_list[i++],
                                XLLP_OFF);
    if (status != XLLP_STATUS_SUCCESS){
      return status;
    } 
  }

  // CD is configured to PULL_UP (failed to detect card if uncomment)
/*
  XllpMfpConfigurePullUpDown(pContext->pMFPBase, 
			XLLP_MFP_MMC_CD_0_GPIO_OFFSET,
			XLLP_MFP_PULL_UP);
  XllpMfpActivatePullUpDown(pContext->pMFPBase,	
			XLLP_MFP_MMC_CD_0_GPIO_OFFSET, 
			XLLP_ON);
*/

  // set output high of CMD_0/CMD_1 (not selected neither defaulty)
  XllpGpioSetDirection(pContext->pGPIOReg, 
                       XLLP_GPIO_MMC_CMD_0, 
                       XLLP_GPIO_DIRECTION_OUT);
  XllpGpioSetOutputLevel(pContext->pGPIOReg, 
                         XLLP_GPIO_MMC_CMD_0,
                         XLLP_HI);
                       
  XllpGpioSetDirection(pContext->pGPIOReg, 
                       XLLP_GPIO_MMC_CMD_1, 
                       XLLP_GPIO_DIRECTION_OUT);
  XllpGpioSetOutputLevel(pContext->pGPIOReg, 
                         XLLP_GPIO_MMC_CMD_1,
                         XLLP_HI);         
                       
                       
  // set direction of CD/WP to IN                    
  XllpGpioSetDirection(pContext->pGPIOReg, 
                       XLLP_GPIO_MMC_CD_0, 
                       XLLP_GPIO_DIRECTION_IN);
/*  XllpGpioSetDirection(pContext->pGPIOReg, 
                       XLLP_GPIO_MMC_CD_1, 
                       XLLP_GPIO_DIRECTION_IN);
*/
                       
  XllpGpioSetDirection(pContext->pGPIOReg, 
                       XLLP_GPIO_MMC_WP_0_N, 
                       XLLP_GPIO_DIRECTION_IN);
  XllpGpioSetDirection(pContext->pGPIOReg, 
                       XLLP_GPIO_MMC_WP_1_N, 
                       XLLP_GPIO_DIRECTION_IN);                                          
  

  // CD is configured to Falling/Rising Edge detect
  XllpGpioSetFallingEdgeDetectEnable(pContext->pGPIOReg,
			XLLP_GPIO_MMC_CD_0,
			XLLP_ON);
  XllpGpioSetRisingEdgeDetectEnable(pContext->pGPIOReg,
			XLLP_GPIO_MMC_CD_0,
			XLLP_ON);

/*  
  XllpGpioSetFallingEdgeDetectEnable(pContext->pGPIOReg,
			XLLP_GPIO_MMC_CD_1,
			XLLP_ON);
  XllpGpioSetRisingEdgeDetectEnable(pContext->pGPIOReg,
			XLLP_GPIO_MMC_CD_1,
			XLLP_ON);
*/  
  return XLLP_STATUS_SUCCESS;
}

XLLP_STATUS_T 
XllpMMC2Configure(P_XLLP_MMC_CONTEXT_T pContext)
{
  XLLP_STATUS_T status;
  XLLP_INT32_T  i=0;

  XLLP_UINT32_T mmc_mfp_list[] = {
    XLLP_MFP_MMC2_DAT0_OFFSET,
    XLLP_MFP_MMC2_DAT1_OFFSET,
    XLLP_MFP_MMC2_DAT2_CS0_OFFSET,
    XLLP_MFP_MMC2_DAT3_CS1_OFFSET,
    XLLP_MFP_MMC2_CLK_OFFSET,
    XLLP_MFP_MMC2_CMD_OFFSET,
    XLLP_MFP_RSVD_GPIO_1_OFFSET,
    XLLP_MFP_PIN_EOLIST_MARKER
  };
  
  XLLP_MFP_ALT_FN_T mmc_af_list[] = {
    XLLP_MFP_MMC2_DAT0_AF,
    XLLP_MFP_MMC2_DAT1_AF,
    XLLP_MFP_MMC2_DAT2_CS0_AF,
    XLLP_MFP_MMC2_DAT3_CS1_AF,
    XLLP_MFP_MMC2_CLK_AF,
    XLLP_MFP_MMC2_CMD_AF,
    XLLP_MFP_RSVD_GPIO_1_AF
  };
  
  XLLP_MFP_DRIVE_STRENGTH_T mmc_ds_list[] = {
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS,
    XLLP_MFP_DEFAULT_DS
  };
  
  XLLP_MFP_LPM_OUTPUT_T mmc_lpm_list[] = {
    XLLP_MFP_LPMO_DRIVE_HIGH,
    XLLP_MFP_LPMO_DRIVE_HIGH,
    XLLP_MFP_LPMO_DRIVE_HIGH,
    XLLP_MFP_LPMO_DRIVE_HIGH,
    XLLP_MFP_LPMO_DRIVE_HIGH, //CLK
    XLLP_MFP_LPMO_DRIVE_HIGH, //CMD0
    XLLP_MFP_LPMO_DRIVE_HIGH  //GPIO1_2
  };

  status = XllpMfpResourceManager_List(pContext->pMFPRmDb,
                                      &mmc_mfp_list[0],
                                      XLLP_MFP_RM_ID_XLLP_MMC,
                                      XLLP_SET);
  if (status != XLLP_STATUS_SUCCESS){
    return status;
  }

  status = XllpMfpSetAfDs_List(pContext->pMFPBase,
                                &mmc_mfp_list[0],
                                &mmc_af_list[0],
                                &mmc_ds_list[0]);
  if (status != XLLP_STATUS_SUCCESS){
    return status;
  }

  status = XllpMfpConfigureLpmOutputLevel_List(pContext->pMFPBase,
               					&mmc_mfp_list[0],
								&mmc_lpm_list[0]);
  if (status != XLLP_STATUS_SUCCESS){
    return status;
  }

  // Todo, need configure pullup/pulldown/sleep_sel/sleep_oe_n/sleep_data??
  while(mmc_mfp_list[i] != XLLP_MFP_PIN_EOLIST_MARKER) {
    status = XllpMfpActivatePullUpDown(pContext->pMFPBase,
                                mmc_mfp_list[i++],
                                XLLP_OFF);
    if (status != XLLP_STATUS_SUCCESS){
      return status;
    } 
  }

  // set output high of CMD (not selected neither defaulty)
  XllpGpioSetDirection(pContext->pGPIOReg, 
                       XLLP_GPIO_MMC2_CMD,
                       XLLP_GPIO_DIRECTION_OUT);

  XllpGpioSetOutputLevel(pContext->pGPIOReg, 
                         XLLP_GPIO_MMC2_CMD,
                         XLLP_HI);

  return XLLP_STATUS_SUCCESS;
}

void 
XllpMMCSelectSlot(P_XLLP_MMC_CONTEXT_T pContext, XLLP_MMC_SLOT_ID_T slot)
{
  switch (slot) {
  case XLLP_MMC_SLOT_0:
    XllpMfpSetAfDs(pContext->pMFPBase, 
                    XLLP_MFP_MMC_CMD_0_OFFSET, 
                    XLLP_MFP_MMC_CMD_0_AF, 
                    XLLP_MFP_DEFAULT_DS);
#if 1
    // set to GPIO output high for CMD_1 pin                
    XllpMfpSetAfDs(pContext->pMFPBase, 
                    XLLP_MFP_MMC_CMD_1_OFFSET, 
                    XLLP_MFP_ALT_FN_0, 
                    XLLP_MFP_DEFAULT_DS); 
    XllpGpioSetDirection(pContext->pGPIOReg, 
                       XLLP_GPIO_MMC_CMD_1, 
                       XLLP_GPIO_DIRECTION_OUT);
    XllpGpioSetOutputLevel(pContext->pGPIOReg, 
                         XLLP_GPIO_MMC_CMD_1,
                         XLLP_HI);  
#endif
    break;        
  case XLLP_MMC_SLOT_1:
    XllpMfpSetAfDs(pContext->pMFPBase, 
                    XLLP_MFP_MMC_CMD_1_OFFSET, 
                    XLLP_MFP_MMC_CMD_1_AF, 
                    XLLP_MFP_DEFAULT_DS);
#if 1
    // set to GPIO output high for CMD_0 pin                
    XllpMfpSetAfDs(pContext->pMFPBase, 
                    XLLP_MFP_MMC_CMD_0_OFFSET, 
                    XLLP_MFP_ALT_FN_0, 
                    XLLP_MFP_DEFAULT_DS); 
    XllpGpioSetDirection(pContext->pGPIOReg, 
                         XLLP_GPIO_MMC_CMD_0, 
                         XLLP_GPIO_DIRECTION_OUT);
    XllpGpioSetOutputLevel(pContext->pGPIOReg, 
                           XLLP_GPIO_MMC_CMD_0,
                           XLLP_HI);
#endif
    break;  
  case XLLP_MMC_SLOT_SDIO:
    XllpMfpSetAfDs(pContext->pMFPBase, 
                    XLLP_MFP_MMC2_CMD_OFFSET, 
                    XLLP_MFP_MMC2_CMD_AF, 
                    XLLP_MFP_DEFAULT_DS);
    break;
  }
}

void 
XllpMMCEnableCardDetect(P_XLLP_MMC_CONTEXT_T pContext, XLLP_MMC_SLOT_ID_T slot)
{
  switch (slot) {
    case XLLP_MMC_SLOT_0:
      XllpGpioSetFallingEdgeDetectEnable(pContext->pGPIOReg, 
                                         XLLP_GPIO_MMC_CD_0, 
                                         XLLP_ON);
      XllpGpioSetRisingEdgeDetectEnable(pContext->pGPIOReg, 
                                         XLLP_GPIO_MMC_CD_0, 
                                         XLLP_ON);
      break;
    case XLLP_MMC_SLOT_1:
/*      XllpGpioSetFallingEdgeDetectEnable(pContext->pGPIOReg, 
                                         XLLP_GPIO_MMC_CD_1, 
                                         XLLP_ON);
      XllpGpioSetRisingEdgeDetectEnable(pContext->pGPIOReg, 
                                         XLLP_GPIO_MMC_CD_1, 
                                         XLLP_ON);
*/      break;
    case XLLP_MMC_SLOT_SDIO:
      //not supported now
      break;
  }
}

XLLP_BOOL_T XllpMMCIsCardWP(P_XLLP_MMC_CONTEXT_T pContext, 
    XLLP_MMC_SLOT_ID_T slot)
{
  XLLP_LEVEL_T level = XLLP_LO; //not wp
  switch (slot) {
    case XLLP_MMC_SLOT_0:
      XllpGpioGetLevel(pContext->pGPIOReg, XLLP_GPIO_MMC_WP_0_N, &level);    
      break;
    case XLLP_MMC_SLOT_1:
      XllpGpioGetLevel(pContext->pGPIOReg, XLLP_GPIO_MMC_WP_1_N, &level);
      break;
    case XLLP_MMC_SLOT_SDIO:
      //not supported now
      level = XLLP_LO; //not wp
      break;
  }
  return ((level == XLLP_LO) ? XLLP_FALSE : XLLP_TRUE);
}

XLLP_BOOL_T XllpMMCIsCardInserted(P_XLLP_MMC_CONTEXT_T pContext, 
    XLLP_MMC_SLOT_ID_T slot)
{
  
  XLLP_LEVEL_T level = XLLP_HI; //empty
  switch (slot) {
    case XLLP_MMC_SLOT_0:
      XllpGpioGetLevel(pContext->pGPIOReg, XLLP_GPIO_MMC_CD_0, &level);    
      break;
    case XLLP_MMC_SLOT_1:
      XllpGpioGetLevel(pContext->pGPIOReg, XLLP_GPIO_MMC_CD_1, &level);
      break;
    case XLLP_MMC_SLOT_SDIO:
      //not supported now
      level = XLLP_LO; //always there
      break;
  }
  return ((level == XLLP_HI) ? XLLP_FALSE : XLLP_TRUE);
}

void
XllpMMCPowerOnSlot(P_XLLP_MMC_CONTEXT_T pContext, XLLP_MMC_SLOT_ID_T slot)
{
  switch (slot) {
    case XLLP_MMC_SLOT_0:
      //fall through
    case XLLP_MMC_SLOT_1:
      break;
    case XLLP_MMC_SLOT_SDIO:
      //not supported now
      break;
  }
}

void
XllpMMCPowerOffSlot(P_XLLP_MMC_CONTEXT_T pContext, XLLP_MMC_SLOT_ID_T slot)
{
  switch (slot) {
    case XLLP_MMC_SLOT_0:
      //fall through
    case XLLP_MMC_SLOT_1:
      break;
    case XLLP_MMC_SLOT_SDIO:
      //not supported now
      break;
  }
}
