@*********************************************************************************
@ This program is free software; you can redistribute it and/or modify
@ it under the terms of the GNU General Public License as published by
@ the Free Software Foundation; either version 2 of the License, or
@ (at your option) any later version.
@ 
@ This program is distributed in the hope that it will be useful,
@ but WITHOUT ANY WARRANTY; without even the implied warranty of
@ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
@ GNU General Public License for more details.
@ 
@ You should have received a copy of the GNU General Public License
@ along with this program; if not, write to the Free Software
@ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
@ 
@ (C) Copyright 2006 Marvell International Ltd.  
@  All Rights Reserved 
@
@*********************************************************************************
@
@  FILENAME:       xlli_Zylonite_defs.inc - Platform specific default
@                  values for Monahans/Zylonite platform bring up.
@
@ LAST MODIFIED:   25-Jun-2007
@
@******************************************************************************
@
@       platform GPIO pin settings (Monahans/Zylonite)
@


        .equ     xlli_GPSR0_value,0x00000000      @ Set registers
        .equ     xlli_GPSR1_value,0x00000000
        .equ     xlli_GPSR2_value,0x00000000
        .equ     xlli_GPSR3_value,0x00000000

        .equ     xlli_GPCR0_value,0xFFFFFFFF      @ Clear registers
        .equ     xlli_GPCR1_value,0xFFFFFFFF
        .equ     xlli_GPCR2_value,0xFFFFFFFF
        .equ     xlli_GPCR3_value,0xFFFFFFFF

        .equ     xlli_GPDR0_value,0x00010000      @ Direction Registers
        .equ     xlli_GPDR1_value,0x00000000      @ FF_TXD bit only!
        .equ     xlli_GPDR2_value,0x00000000
        .equ     xlli_GPDR3_value,0x00000800


@
@       STATIC MEMORY CONTROLLER SETTINGS FOR Monahans/Zylonite
@
       .equ     xlli_MDREFR_value,0x00000023
         .equ     xlli_MSC0_value,0x7FF07FFA
         .equ     xlli_MSC1_value,0x7FFC7FF8
         .equ     xlli_MECR_value,0x00000001
       .equ     xlli_MCMEM0_value,0x0001C391
       .equ     xlli_MCMEM1_value,0x0001C391
       .equ     xlli_MCATT0_value,0x0001C391
       .equ     xlli_MCATT1_value,0x0001C391
        .equ     xlli_MCIO0_value,0x0001C391
        .equ     xlli_MCIO1_value,0x0001C391
      .equ     xlli_FLYCNFG_value,0x00010001
      .equ     xlli_MDMRSLP_value,0x0000C008
       .equ     xlli_SXCNFG_value,0x40044004      @ Default value at boot up

   .equ     xlli_CSMSADRCFG_value,0x2             @ CS0 & CS! set for 256 Mb, One bus mode
    .equ     xlli_CSADRCFG0_value,0x00020000      @ Chip select 0 configuration
    .equ     xlli_CSADRCFG1_value,0x00020000      @ Chip select 1 configuration
    .equ     xlli_CSADRCFG2_value,0x0032091D      @ Chip select 2 configuration (sync reads)
    .equ     xlli_CSADRCFG3_value,0x003E080B      @ Chip select 3 configuration

    .equ     xlli_EMPI_MFPR_value,0x00000041      @ Set to alternate function #1

@
@ SDRAM Settings
@
    .equ     xlli_MDCNFG_value_16,0x8000072D      @ SDRAM Config Reg - 16 bit bus
         .equ     xlli_EMPI_value,0xF4000000      @ Default value
    .equ     xlli_MDCNFG_value_32,0x80000729      @ SDRAM Config Reg - 32 bit bus
        .equ     xlli_MDMRS_value,0x60000033      @ SDRAM Mode Reg Set Config Reg

          .equ     xlli_RCOMP_RCRNG_value,0x2     @ Resistive compensation range
                  .equ     xlli_RCOMP_REI,0xC65D4 @ 2.0 second rcomp updates

@
@ MEMORY PHYSICAL BASE ADDRESS(S)
@

      .equ       xlli_SRAM_PHYSICAL_BASE,(0X5C000000)  @ Physical base address for SRAM
     .equ       xlli_SDRAM_PHYSICAL_BASE,(0x80000000)  @ Physical base address for SDRAM

@
@ Misc constants
@

        .equ     xlli_MemSize_1Mb,0x00100000

        .equ     xlli_p_PageTable,0xA1FFC000    @ Base address for memory Page Table
        .equ     xlli_s_PageTable,0x00004000    @ Page Table size (4K words - 16 Kb)

        .equ     xlli_v_xbBOOTROM,0x00000000

      @.equ     xlli_stack_pointer,0x0             @ Stack pointer in use

      
