/*++
"This software program is available to you under a choice of one of two 
licenses.  You may choose to be licensed under either the GNU General Public 
License (GPL) Version 2, June 1991, available at 
http://www.fsf.org/copyleft/gpl.html, or the BSD License, the text of
which follows:

Copyright (c) 1996-2005, Intel Corporation. All rights reserved.

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this 
list of conditions and the following disclaimer. 

Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or 
other materials provided with the distribution. 

Neither the name of the Intel Corporation ("Intel") nor the names of its 
contributors may be used to endorse or promote products derived from this
software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
--*/
@
@*********************************************************************************
@
@  FILENAME:       xlli_Zylonite_defs.inc (Platform specific addresses and
@                  defalut values for Zylonite platform bring up)
@
@ LAST MODIFIED:   18-Apr-2005
@
@******************************************************************************
@
@       platform GPIO pin settings (Monahans/Zylonite)
@


        .equ     xlli_GPSR0_value,0x00000000      @ Set registers
        .equ     xlli_GPSR1_value,0x00000000
        .equ     xlli_GPSR2_value,0x00000000

        .equ     xlli_GPCR0_value,0xFFFFFFFF      @ Clear registers
        .equ     xlli_GPCR1_value,0xFFFFFFFF
        .equ     xlli_GPCR2_value,0xFFFFFFFF

        .equ     xlli_GPDR0_value,0x00000000      @ Direction Registers
        .equ     xlli_GPDR1_value,0x00000000      @ FF_TXD bit only!
        .equ     xlli_GPDR2_value,0x00000000
@
@       STATIC MEMORY CONTROLLER SETTINGS FOR ZYLONITE
@
       .equ     xlli_MDREFR_value,0x00000019
         .equ     xlli_MSC0_value,0x7FF07FFA
         .equ     xlli_MSC1_value,0x7FF47FF8
         .equ     xlli_MSC2_value,0x00003884
         .equ     xlli_MECR_value,0x00000001
       .equ     xlli_MCMEM0_value,0x0001C391
       .equ     xlli_MCMEM1_value,0x0001C391
       .equ     xlli_MCATT0_value,0x0001C391
       .equ     xlli_MCATT1_value,0x0001C391
        .equ     xlli_MCIO0_value,0x0001C391
        .equ     xlli_MCIO1_value,0x0001C391
      .equ     xlli_FLYCNFG_value,0x00010001
      .equ     xlli_MDMRSLP_value,0x0000C008
       .equ     xlli_SXCNFG_value,0x40044004      @ Default value at boot up

   .equ     xlli_CSMSADRCFG_value,0x2             @ CS0 & CS! set for 256 Mb, One bus mode
    .equ     xlli_CSADRCFG0_value,0x00020000      @ Chip select 0 configuration
    .equ     xlli_CSADRCFG1_value,0x00020000      @ Chip select 1 configuration
    .equ     xlli_CSADRCFG2_value,0x003E0809      @ Chip select 2 configuration
    .equ     xlli_CSADRCFG3_value,0x003E080B      @ Chip select 3 configuration

    .equ     xlli_EMPI_MFPR_value,0x00000041      @ Set to alternate function #1

@
@ SDRAM Settings
@
@xlli_MDCNFG_value       EQU     0x80000729      ; SDRAM Config Reg - 32 bit bus
@xlli_EMPI_value         EQU     0xC0000000      ; Default value - 32 bit mode
       .equ     xlli_MDCNFG_value,0x8000072D      @ SDRAM Config Reg - 16 bit bus
         .equ     xlli_EMPI_value,0xC1000000      @ Default value - 16 bit mode
        .equ     xlli_MDMRS_value,0x60000033      @ SDRAM Mode Reg Set Config Reg

          .equ     xlli_RCOMP_RCRNG_value,0x2     @ Resistive compensation range
                  .equ     xlli_RCOMP_REI,0x13D62 @ 0.2 second rcomp updates

@
@ MEMORY PHYSICAL BASE ADDRESS(S)
@

      .equ       xlli_SRAM_PHYSICAL_BASE,(0X5C000000)  @ Physical base address for SRAM
     .equ       xlli_SDRAM_PHYSICAL_BASE,(0x80000000)  @ Physical base address for SDRAM

@
@ Misc constants
@

        .equ     xlli_MemSize_1Mb,0x00100000

        .equ     xlli_p_PageTable,0xA1FFC000    @ Base address for memory Page Table
        .equ     xlli_s_PageTable,0x00004000    @ Page Table size (4K words - 16 Kb)

        .equ     xlli_v_xbBOOTROM,0x00000000

      .equ     xlli_stack_pointer,0x0             @ Stack pointer in use

      
