/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *(C) Copyright 2006 Marvell International Ltd.  
 * All Rights Reserved 
 */

/*++

Module Name:  $Workfile: xllp_camera_os_depend.h $

Abstract:  
      contains all OS wraper prototypes for XLLP camera.

Notes:Only valid for processor code named Monahans.

--*/


#ifndef __XLLP_CAMERA_OS_DEPEND_H__
#define __XLLP_CAMERA_OS_DEPEND_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "xllp_defs.h"
#include "xllp_ost.h"
#include "xllp_i2c.h"

/**************************
 * Time API
 **************************/
void OS_Delay(int ms);


/**************************
 * I2C API
 **************************/
// Write "bytesCount" data from "bytesBuf" to slave device "slaveAddr", Return: 0-success, non-0: error
int OS_I2CMasterWriteData(XLLP_UINT8_T slaveAddr, const XLLP_UINT8_T * bytesBuf, int bytesCount);

// Read "bufLen" data to "bytesBuf" to slave device "slaveAddr", Return: 0-success, non-0: error
int OS_I2CMasterReadData(XLLP_UINT8_T slaveAddr, XLLP_UINT8_T * bytesBuf, int bufLen);

#ifdef __cplusplus
}
#endif

#endif 

