/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *(C) Copyright 2006 Marvell International Ltd.  
 * All Rights Reserved 
 */

/**  FILENAME:  xllp_lcd_cpu.h
**
**  PURPOSE:   Private header file for XLLP LCD controller. 
**
*******************************************************************************/

#ifndef __XLLP_LCD_CPU_H__
#define __XLLP_LCD_CPU_H__

#include "xllp_defs.h"
#include "xllp_serialization.h"
#include "xllp_clkmgr.h"
#include "xllp_lcd.h"

// Private API functions
void LCDSetupGPIOs(P_XLLP_LCD_T pXllpLCD);
void LCDInitController(P_XLLP_LCD_T pXllpLCD);
void LCDClearStatusReg(P_XLLP_LCD_T pXllpLCD);
void LCDEnableController(P_XLLP_LCD_T pXllpLCD);
void LCDSuspendController(P_XLLP_LCD_T pXllpLCD, int SuspendType);
void OverlayDMALength(P_XLLP_OVERLAY_T pXllpOverlay);
XLLP_STATUS_T MiniLCDEncodeRGB565(P_XLLP_MINI_LCD_T pXllpMiniLCD, 
								  XLLP_UINT32_T FrameSource, 
								  P_XLLP_UINT32_T pByteCount,
								  XLLP_UINT16_T	width,
								  XLLP_UINT16_T height);

#endif //XLLP_LCD
