@ This program is free software; you can redistribute it and/or modify
@ it under the terms of the GNU General Public License as published by
@ the Free Software Foundation; either version 2 of the License, or
@ (at your option) any later version.
@ 
@ This program is distributed in the hope that it will be useful,
@ but WITHOUT ANY WARRANTY; without even the implied warranty of
@ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
@ GNU General Public License for more details.
@ 
@ You should have received a copy of the GNU General Public License
@ along with this program; if not, write to the Free Software
@ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
@

@ (C) Copyright 2006 Marvell International Ltd.  
@  All Rights Reserved 
@  FILENAME:       xllp_pmu.s
@
@  PURPOSE:        Provides low level PMU primitive functions written specifically for
@                  the Monanhans/Zylonite processor/platform.  Specially design to fit  
@                  into Intel VTUNE Architecture
@                  
@ 
@  LAST MODIFIED:  3/1/05
@******************************************************************************
@
@ List of primitive functions in this source code include:
@
   .global XllpReadClkCfg          
   .global XllpWriteClkCfg

    .text

@
@ XllpReadClkCfg - Read the PMU Register
@
@ Description:
@ 	This routine reads the designated PMU register via CoProcesser 14.
@
@ Input Parameters:
@
@ Returns:
@	r0 - clkcfg value
@    
@ Registers Modified:
@	CoProcessor Register Modified: None
@	General Purpose Registers Modified: None	
@
@

XllpReadClkCfg:
	mrc  p14, 0, r0, c6, c0, 0		@ Read clkcfg
    	bx lr          @ return
	 
  

@
@ XllpWriteClkCfg - Writes to the PMU Register
@
@ Description:
@ 	This routine writes to the designated ClkCFG register via CoProcesser 14.
@
@ Input Parameters:   
@       r0 - arg1 - Value to write to ClkCFG register
@

@ Returns:
@	None
@
@ Registers Modified:
@	CoProcessor Register Modified: ClkCFG Register
@	General Purpose Registers Modified: None
@
@ NOTE   
@	Error checking not included
@

XllpWriteClkCfg:
	mcr	 p14, 0, r0, c6, c0, 0	@ Write ClkCFG
	bx	 lr         @ return
    
