@ This program is free software; you can redistribute it and/or modify
@ it under the terms of the GNU General Public License as published by
@ the Free Software Foundation; either version 2 of the License, or
@ (at your option) any later version.
@ 
@ This program is distributed in the hope that it will be useful,
@ but WITHOUT ANY WARRANTY; without even the implied warranty of
@ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
@ GNU General Public License for more details.
@ 
@ You should have received a copy of the GNU General Public License
@ along with this program; if not, write to the Free Software
@ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

@ (C) Copyright 2006 Marvell International Ltd.  
@  All Rights Reserved 
@
@ FILENAME:	xllp_pm_suspend.inc
@
@
@****************************************************************************


.ifndef xllp_pm_suspend_inc
.equ xllp_pm_suspend_inc, 1

.equ	WORD_SIZE, 4

@ value for PWRMODE register 
.equ	XLLP_PM_S2D3C4, 0x06
.equ	XLLP_PM_S0D2C2, 0x03
.equ	XLLP_PM_S3D4C4, 0x07
.equ	XLLP_PM_S0D1C2, 0x02
.equ    XLLP_PM_S0D0C1, 0x01

@ modeSaveFlags
@ These definition must be consistent with xllp_pm_suspend.h
.equ	XLLP_PM_MODE_SAVE_FLAG_SYS, 0x1
.equ	XLLP_PM_MODE_SAVE_FLAG_IRQ, 0x2
.equ	XLLP_PM_MODE_SAVE_FLAG_FIQ, 0x4
.equ	XLLP_PM_MODE_SAVE_FLAG_ABT, 0x8
.equ	XLLP_PM_MODE_SAVE_FLAG_UND, 0x10
.equ	XLLP_PM_MODE_SAVE_FLAG_SVC, 0x20


@ the position of each data memeber
@ typdef struct XLLP_PM_SAVE_DATA_S{
@ ...
@ } XLLP_PM_SAVE_DATA_T, *P_XLLP_PM_SAVE_DATA_T;
@ These definition must be consistent with xllp_pm_suspend.h
.equ	SleepState_begin,		0x0
.equ	SleepState_checksum,		SleepState_begin
.equ	SleepState_wordCount,		SleepState_checksum + WORD_SIZE
.equ	SleepState_areaAddress,		SleepState_wordCount + WORD_SIZE
.equ	SleepState_modeSaveFlags,	SleepState_areaAddress + WORD_SIZE

@ ARM registers 
.equ	SleepState_ENTRY_REGS,		SleepState_modeSaveFlags + WORD_SIZE
.equ	SleepState_ENTRY_CPSR,		SleepState_ENTRY_REGS 
.equ	SleepState_ENTRY_SPSR,		SleepState_ENTRY_CPSR + WORD_SIZE
.equ	SleepState_ENTRY_R0,		SleepState_ENTRY_SPSR + WORD_SIZE
.equ	SleepState_ENTRY_R1,		SleepState_ENTRY_R0 + WORD_SIZE
.equ	SleepState_SYS_REGS,		SleepState_ENTRY_REGS + 17*WORD_SIZE
.equ	SleepState_FIQ_REGS,		SleepState_SYS_REGS + 2*WORD_SIZE 
.equ	SleepState_IRQ_REGS,		SleepState_FIQ_REGS + 8*WORD_SIZE
.equ	SleepState_ABT_REGS,		SleepState_IRQ_REGS + 3*WORD_SIZE 
.equ	SleepState_UND_REGS,		SleepState_ABT_REGS + 3*WORD_SIZE
.equ	SleepState_SVC_REGS,		SleepState_UND_REGS + 3*WORD_SIZE

@ MMU settings
.equ	SleepState_Cp15_ACR_MMU,	SleepState_SVC_REGS + 3*WORD_SIZE
.equ	SleepState_Cp15_AUXCR_MMU,	SleepState_Cp15_ACR_MMU + WORD_SIZE
.equ	SleepState_Cp15_TTBR_MMU,	SleepState_Cp15_AUXCR_MMU + WORD_SIZE
.equ	SleepState_Cp15_DACR_MMU,	SleepState_Cp15_TTBR_MMU + WORD_SIZE
.equ	SleepState_Cp15_PID_MMU,	SleepState_Cp15_DACR_MMU + WORD_SIZE
.equ	SleepState_Cp15_CPAR,		SleepState_Cp15_PID_MMU + WORD_SIZE

.equ	SleepState_extendedChecksumByteCount,	SleepState_Cp15_CPAR + WORD_SIZE
.equ	SleepState_psprAddress,	SleepState_extendedChecksumByteCount + WORD_SIZE
.equ	SleepState_flushFunc,	SleepState_psprAddress + WORD_SIZE
.equ	SleepState_end,	SleepState_flushFunc + WORD_SIZE

@ The size of the XLLP_PM_SAVE_DATA_T structure. Be careful that the value 
@ should be change if the structure changes.
.equ	SleepState_size,	SleepState_end - SleepState_begin

.endif
