/*
 * bogomips.c: Give a meaningless value that is somewhat
 * indicative to processor speed.
 *
 * Copyright (C) 2002  Erik Mouw <J.A.K.Mouw@its.tudelft.nl>
 * Copyright (C) 2003  Russ Dill <Russ.Dill@asu.edu>
 *
 * $Id: bogomips.c,v 1.1 2003/09/04 17:42:09 russd Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ident "$Id: bogomips.c,v 1.1 2003/09/04 17:42:09 russd Exp $"

#ifdef HAVE_CONFIG_H
# include <blob/config.h>
#endif

#include <blob/util.h>
#include <blob/time.h>
#include <blob/command.h>


int bogomips_cmd(int __attribute__((unused)) argc,
		char __attribute__((unused)) *argv[])
{
	int i;
	u32 start = timer_read();
	u32 total;

	for (i = 0; i < 100000; i++);
	total = timer_read() - start;
	printf("Total time: %ums\n", total * 1000 / timer_tps());
	printf("Bogomips: %u\n", timer_tps() * 50 / total);

	return 0;
}

char bogomips_help[] = "bogomips\n"
"bogomips gives a Bogus, Meaningless, Indication of Processor\n"
"Performance\n";
