/**********************************************************************
 * accelent_sa.c
 *
 * Implements several POST routines for Accelent IDP platform
 *
 * Copyright (C) 2001 Stefan Eletzhofer <stefan.eletzhofer@www.eletztrick.de>
 * Copyright (c) 2002 Holger Schurig <h.schurig@mn-logistik.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ident "$Id: accelent_sa.c,v 1.4 2003/09/04 17:39:00 russd Exp $"

/**********************************************************************
 * Includes
 */
#ifdef HAVE_CONFIG_H
# include <blob/config.h>
#endif

#include <blob/types.h>
#include <blob/errno.h>
#include <blob/util.h>
#include <blob/command.h>
#include <blob/init.h>
#include <blob/serial.h>
#include <blob/time.h>
#include <blob/arch.h>



#define MEM(adr)	(*((u32*)adr))
#define SET(reg,bit)	((reg) |= (1<<(bit)))
#define CLR(reg,bit)	((reg) &= ~(1<<(bit)))




static void accelent_sa_init_hardware(void)
{
	/* select serial driver */
	serial_driver = &sa11x0_serial_driver;
	timer_driver = &intelarm_timer_driver;
}

__initlist(accelent_sa_init_hardware, INIT_LEVEL_DRIVER_SELECTION);
