/*
 * trizeps.c: Keith & Koep Trizeps specific stuff
 *
 * Copyright (C) 2002  Erik Mouw <J.A.K.Mouw@its.tudelft.nl>
 *
 * $Id: trizeps.c,v 1.4 2003/09/04 17:39:00 russd Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ident "$Id: trizeps.c,v 1.4 2003/09/04 17:39:00 russd Exp $"

#ifdef HAVE_CONFIG_H
# include <blob/config.h>
#endif

#include <blob/types.h>
#include <blob/errno.h>
#include <blob/util.h>
#include <blob/command.h>

#include <blob/init.h>
#include <blob/serial.h>

#include <blob/time.h>
// #include <blob/arch.h>
// #include <blob/proc/sa1111.h>

// #include <blob/lcd.h>


#define MEM(adr)	(*((u32*)adr))
#define SET(reg,bit)	((reg) |= (1<<(bit)))
#define CLR(reg,bit)	((reg) &= ~(1<<(bit)))


static void trizeps_init_hardware(void)
{
	/* select serial driver */
	serial_driver = &sa11x0_serial_driver;
	timer_driver = &intelarm_timer_driver;
}

__initlist(trizeps_init_hardware, INIT_LEVEL_DRIVER_SELECTION);

/* eof */
