/*
 * led-sa11x0.c: simple LED control functions
 *
 * Copyright (C) 1999 2001  Erik Mouw (J.A.K.Mouw@its.tudelft.nl)
 *
 * $Id: led-sa11x0.c,v 1.2 2003/08/06 22:55:41 abz Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
/*
 * All functions assume that the LED is properly initialised by the code
 * in ledasm.S.
 *
 */

#ident "$Id: led-sa11x0.c,v 1.2 2003/08/06 22:55:41 abz Exp $"

#ifdef HAVE_CONFIG_H
# include <blob/config.h>
#endif

#include <blob/arch.h>
#include <blob/led.h>
#include <blob/init.h>


static int led_state;
static int led_locked;

/* TODO: fix this */
static void sa11x0_led_on(void)
{
	if(led_locked)
		return;

	GPSR = LED_GPIO; 
	led_state = 1;
}

/* TODO: fix this */
static void sa11x0_led_off(void)
{
	if(led_locked)
		return;

	GPCR = LED_GPIO;
	led_state = 0;
}

static void sa11x0_led_toggle(void)
{
	if(led_state)
		sa11x0_led_off();
	else
		sa11x0_led_on();
    return;
}

static void sa11x0_led_lock(void)
{
	led_locked = 1;
}

static void sa11x0_led_unlock(void)
{
	led_locked = 0;
}

led_driver_t sa11x0_gpio_led_driver = {
    led_on:     sa11x0_led_on,
    led_off:    sa11x0_led_off,
    led_toggle: sa11x0_led_toggle,
    led_lock:   sa11x0_led_lock,
    led_unlock: sa11x0_led_unlock,
};
