/*
 * led.c: simple LED control functions
 *
 * Copyright (C) 2002, 2003 by SOMA Networks Inc.
 *
 * $Id: led.c,v 1.9 2003/08/06 22:55:41 abz Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ident "$Id: led.c,v 1.9 2003/08/06 22:55:41 abz Exp $"

#ifdef HAVE_CONFIG_H
# include <blob/config.h>
#endif 

#include <blob/debug.h>
#include <blob/led.h>
#include <blob/types.h>

led_driver_t *led_driver;

void led_init(void)
{
	if (led_driver == NULL){
		deprintf("No LED driver defined in arch specific file\n");
		return;
	}

    led_driver->led_unlock();
    led_driver->led_on();
}

int led_on(void)
{
	if (led_driver == NULL){
		deprintf("No LED driver defined in arch specific file\n");
		return -1;
	}

    led_driver->led_on();

	return 0;
}

int led_off(void)
{
	if (led_driver == NULL){
		deprintf("No LED driver defined in arch specific file\n");
		return -1;
	}

    led_driver->led_off();

	return 0;
}

void led_toggle(void)
{
    led_driver->led_toggle();
}

void led_lock(void)
{
    led_driver->led_lock();
}

void led_unlock(void)
{
    led_driver->led_unlock();
}
