/*
 * memset.c:  fill memory with a constant byte
 *
 * Copyright (C) 2002  Erik Mouw (J.A.K.Mouw@its.tudelft.nl)
 *
 * $Id: memset.c,v 1.1 2002/02/15 23:08:20 erikm Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ident "$Id: memset.c,v 1.1 2002/02/15 23:08:20 erikm Exp $"

#ifdef HAVE_CONFIG_H
# include <blob/config.h>
#endif

#include <blob/util.h>
#include <blob/types.h>



void *memset(void *dest, int c, size_t n)
{
	u8 *tmp = (u8 *)dest;

	while(n-- > 0)
		*tmp++ = (u8)c;

	return dest;
}
