#! /bin/bash

usage_help() {
    echo "usage:  ./setup.sh [PRODUCT=FBWEVB|BENZ|SPARK|JADES|SAAR|BSTD|?], linux_kernel=your_linux_directory, formal_release, TRUSTED"
    echo "param:  PRODUCT=FBWEVB	(FBWEVB)"
    echo "param:  PRODUCT=BENZ  	(BENZINA)"
    echo "param:  PRODUCT=BENZGLB  	(BENZINA global)"
    echo "param:  PRODUCT=BENZ2GWIFI    (BENZINA GSM with WIFI)"
    echo "param:  PRODUCT=BENZ_WBD_512 (benzina 3g 512m ddr)"
    echo "param:  PRODUCT=BLAZE  	(BLAZE)"
    echo "param:  PRODUCT=SPARK	    (SPARK)"
    echo "param:  PRODUCT=JADES	    (JADES)"
    echo "param:  PRODUCT=JADESTD	(JADESTD)"
    echo "param:  PRODUCT=ECT       (ECT)"
    echo "param:  PRODUCT=JADES256	    (JADES support 256M ddr)"
    echo "param:  PRODUCT=SAAR	    (SAAR)"
    echo "param:  PRODUCT=BSTD	    (TD spreadtrum ic )"
    echo "param:  PRODUCT=CHERRY    (CHERRY)"
    echo "param:  PRODUCT=BEACON    (td FBW)"
	echo "param:  PRODUCT=T8200    (td huawei)"
	echo "param:  PRODUCT=BENZ2  	(BENZINA2)"
	echo "param:  PRODUCT=IGNITE  	(IGNITE)"
    echo "        ?		(print this help)"
}


cd ..
export tmpstr=$(echo $PWD | sed -e 's/\//\\\//g')
cd -
export TARGET_SRC=$PWD

cp Def_Rules.make Rules.make
sed -i -e 's/CONFIG_CC_DEVELOPMENT=y/CONFIG_CC_DEVELOPMENT=n/g' ${TARGET_SRC}/Rules.make
sed -i -e '/PXA_ROOT_DIR/s/\/vobs\/xscalelinux/'$tmpstr'/g' ${TARGET_SRC}/Rules.make

case "$1" in
    PRODUCT=FBWEVB)
    sed -e "s/\# CONFIG_PLATFORM_FBWEVB .*$/CONFIG_PLATFORM_FBWEVB=y/" -e "s/\# CONFIG_CPU_TAVOR_P65e1.1 .*$/CONFIG_CPU_TAVOR_P65e1.1=y/" -e "s/\# CONFIG_BOOT_ONENAND .*$/CONFIG_BOOT_ONENAND=y/" -e "s/\# CONFIG_PVK_BLOB_USB11 .*$/CONFIG_PVK_BLOB_USB11=y/"  -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
#	mv -f .tmpconfig .config
    ;;
    PRODUCT=BENZ)
    sed   -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_PLATFORM_BEZ .*$/CONFIG_PLATFORM_BEZ=y/"  -e "s/\# CONFIG_CPU_TAVOR_PV .*$/CONFIG_CPU_TAVOR_PV=y/" -e "s/\# CONFIG_BOOT_ONENAND .*$/CONFIG_BOOT_ONENAND=y/" -e "s/\# CONFIG_PVK_BLOB_USB20 .*$/CONFIG_PVK_BLOB_USB20=y/"  -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
#	mv -f .tmpconfig .config
	;;
	PRODUCT=BENZ2)
    sed   -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_PLATFORM_BEZ2 .*$/CONFIG_PLATFORM_BEZ2=y/"  -e "s/\# CONFIG_CPU_TAVOR_PV .*$/CONFIG_CPU_TAVOR_PV=y/" -e "s/\# CONFIG_BOOT_ONENAND .*$/CONFIG_BOOT_ONENAND=y/" -e "s/\# CONFIG_PVK_BLOB_USB20 .*$/CONFIG_PVK_BLOB_USB20=y/"  -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
#	mv -f .tmpconfig .config
	;;
	PRODUCT=IGNITE)
    sed   -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_PLATFORM_IGNITE .*$/CONFIG_PLATFORM_IGNITE=y/"  -e "s/\# CONFIG_CPU_TAVOR_PV .*$/CONFIG_CPU_TAVOR_PV=y/" -e "s/\# CONFIG_BOOT_ONENAND .*$/CONFIG_BOOT_ONENAND=y/" -e "s/\# CONFIG_PVK_BLOB_USB20 .*$/CONFIG_PVK_BLOB_USB20=y/"  -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
#	mv -f .tmpconfig .config
	;;
    PRODUCT=BENZ2GWIFI)
    sed   -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_PLATFORM_BEZGATT .*$/CONFIG_PLATFORM_BEZGATT=y/"  -e "s/\# CONFIG_CPU_TAVOR_PV .*$/CONFIG_CPU_TAVOR_PV=y/" -e "s/\# CONFIG_BOOT_ONENAND .*$/CONFIG_BOOT_ONENAND=y/" -e "s/\# CONFIG_PVK_BLOB_USB20 .*$/CONFIG_PVK_BLOB_USB20=y/"  -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
#	mv -f .tmpconfig .config
	;;
    PRODUCT=BENZGLB)
    sed -e "s/\# CONFIG_PLATFORM_BEZGLB .*$/CONFIG_PLATFORM_BEZGLB=y/" -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_CPU_TAVOR_PV .*$/CONFIG_CPU_TAVOR_PV=y/" -e "s/\# CONFIG_BOOT_ONENAND .*$/CONFIG_BOOT_ONENAND=y/" -e "s/\# CONFIG_PVK_BLOB_USB20 .*$/CONFIG_PVK_BLOB_USB20=y/"  -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
#	mv -f .tmpconfig .config
	;;
	PRODUCT=BENZ_WBD_512)
    sed -e "s/\# CONFIG_PLATFORM_BEZ3G512 .*$/CONFIG_PLATFORM_BEZ3G512=y/" -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_CPU_TAVOR_PV .*$/CONFIG_CPU_TAVOR_PV=y/" -e "s/\# CONFIG_BOOT_ONENAND .*$/CONFIG_BOOT_ONENAND=y/" -e "s/\# CONFIG_PVK_BLOB_USB20 .*$/CONFIG_PVK_BLOB_USB20=y/"  -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
#	mv -f .tmpconfig .config
	;;
    PRODUCT=BENZWIFI)
    sed   -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_PLATFORM_BEZ .*$/CONFIG_PLATFORM_BEZ=y/"  -e "s/\# CONFIG_CPU_TAVOR_PV .*$/CONFIG_CPU_TAVOR_PV=y/" -e "s/\# CONFIG_BOOT_ONENAND .*$/CONFIG_BOOT_ONENAND=y/" -e "s/\# CONFIG_PVK_BLOB_USB20 .*$/CONFIG_PVK_BLOB_USB20=y/"  -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
#	mv -f .tmpconfig .config
	;;
    PRODUCT=SPARK)
    sed  -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_PLATFORM_SPK .*$/CONFIG_PLATFORM_SPK=y/"  -e "s/\# CONFIG_CPU_TAVOR_PV .*$/CONFIG_CPU_TAVOR_PV=y/" -e "s/\# CONFIG_BOOT_ONENAND .*$/CONFIG_BOOT_ONENAND=y/" -e "s/\# CONFIG_PVK_BLOB_USB20 .*$/CONFIG_PVK_BLOB_USB20=y/"  -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
#	mv -f .tmpconfig .config
    ;;
    PRODUCT=BLAZE)
    sed  -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_PLATFORM_BLAZE .*$/CONFIG_PLATFORM_BLAZE=y/"  -e "s/\# CONFIG_CPU_TAVOR_PV .*$/CONFIG_CPU_TAVOR_PV=y/" -e "s/\# CONFIG_BOOT_ONENAND .*$/CONFIG_BOOT_ONENAND=y/" -e "s/\# CONFIG_PVK_BLOB_USB20 .*$/CONFIG_PVK_BLOB_USB20=y/"  -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
#	mv -f .tmpconfig .config
	;;
    PRODUCT=JADES)
    sed  -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_PLATFORM_EVB2 .*$/CONFIG_PLATFORM_EVB2=y/" -e "s/\# CONFIG_CPU_TAVOR_B1 .*$/CONFIG_CPU_TAVOR_B1=y/" -e "s/\# CONFIG_PLATFORM_EVB2_ULPI .*$/CONFIG_PLATFORM_EVB2_ULPI=y/" -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" -e "s/\# CONFIG_PVK_BLOB_USB11 .*$/CONFIG_PVK_BLOB_USB11=y/" def_config > .config
#	mv -f .tmpconfig .config
    ;;
	PRODUCT=JADESTD)
    sed  -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_PLATFORM_JADESTD .*$/CONFIG_PLATFORM_JADESTD=y/" -e "s/\# CONFIG_CPU_TAVOR_B1 .*$/CONFIG_CPU_TAVOR_B1=y/" -e "s/\# CONFIG_PLATFORM_EVB2_ULPI .*$/CONFIG_PLATFORM_EVB2_ULPI=y/" -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" -e "s/\# CONFIG_PVK_BLOB_USB11 .*$/CONFIG_PVK_BLOB_USB11=y/" def_config > .config
#	mv -f .tmpconfig .config
    ;;
    PRODUCT=ECT)
    sed  -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_PLATFORM_EVB2 .*$/CONFIG_PLATFORM_EVB2=y/" -e "s/\# CONFIG_CPU_TAVOR_B1 .*$/CONFIG_CPU_TAVOR_B1=y/" -e "s/\# CONFIG_PLATFORM_EVB2_ULPI .*$/CONFIG_PLATFORM_EVB2_ULPI=y/" -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_DKB .*$/CONFIG_WTPTP_DKB=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" -e "s/\# CONFIG_PVK_BLOB_USB11 .*$/CONFIG_PVK_BLOB_USB11=y/" def_config > .config
#       mv -f .tmpconfig .config
    ;;
    PRODUCT=JADES256)
    sed  -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_PLATFORM_JADES256 .*$/CONFIG_PLATFORM_JADES256=y/" -e "s/\# CONFIG_PLATFORM_EVB2 .*$/CONFIG_PLATFORM_EVB2=y/" -e "s/\# CONFIG_CPU_TAVOR_B1 .*$/CONFIG_CPU_TAVOR_B1=y/" -e "s/\# CONFIG_PLATFORM_EVB2_ULPI .*$/CONFIG_PLATFORM_EVB2_ULPI=y/" -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" -e "s/\# CONFIG_PVK_BLOB_USB11 .*$/CONFIG_PVK_BLOB_USB11=y/" def_config > .config
    ;;
    PRODUCT=SAAR)
    sed -e "s/\# CONFIG_PLATFORM_SAAR .*$/CONFIG_PLATFORM_SAAR=y/"  -e "s/\# CONFIG_CPU_TAVOR_P65e1.1 .*$/CONFIG_CPU_TAVOR_P65e1.1=y/" -e "s/\# CONFIG_BOOT_ONENAND .*$/CONFIG_BOOT_ONENAND=y/" -e "s/\# CONFIG_PVK_MOBM .*$/CONFIG_PVK_MOBM=y/" -e "s/\# CONFIG_PVK_BLOB_USB11 .*$/CONFIG_PVK_BLOB_USB11=y/" def_config > .config
#	mv -f .tmpconfig .config
	;;
    PRODUCT=BSTD)
    sed -e "s/\# CONFIG_GEN_RELEASE .*$/CONFIG_GEN_RELEASE=y/" -e "s/\# CONFIG_GEN_QVGA .*$/CONFIG_GEN_QVGA=y/" -e "s/\# CONFIG_PLATFORM_BSTD .*$/CONFIG_PLATFORM_BSTD=y/" -e "s/\# CONFIG_CPU_MHNLV .*$/CONFIG_CPU_MHNLV=y/" -e "s/\# CONFIG_PVK_BLOB_USB20 .*$/CONFIG_PVK_BLOB_USB20=y/" -e "s/\# CONFIG_WTPTP_DKB .*$/CONFIG_WTPTP_DKB=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
    ;;
    PRODUCT=CHERRY)
    sed -e "s/\# CONFIG_GEN_RELEASE .*$/CONFIG_GEN_RELEASE=y/" -e "s/\# CONFIG_GEN_QVGA .*$/CONFIG_GEN_QVGA=y/" -e "s/\# CONFIG_PLATFORM_CHERRY .*$/CONFIG_PLATFORM_CHERRY=y/" -e "s/\# CONFIG_CPU_MHNLV .*$/CONFIG_CPU_MHNLV=y/" -e "s/\# CONFIG_PVK_BLOB_USB20 .*$/CONFIG_PVK_BLOB_USB20=y/" -e "s/\# CONFIG_WTPTP_DKB .*$/CONFIG_WTPTP_DKB=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
    ;;
    PRODUCT=BEACON)
    sed   -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_PLATFORM_BEACON .*$/CONFIG_PLATFORM_BEACON=y/" -e "s/\# CONFIG_CPU_TAVOR_PV .*$/CONFIG_CPU_TAVOR_PV=y/" -e "s/\# CONFIG_BOOT_ONENAND .*$/CONFIG_BOOT_ONENAND=y/" -e "s/\# CONFIG_PVK_BLOB_USB20 .*$/CONFIG_PVK_BLOB_USB20=y/"  -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
#	mv -f .tmpconfig .config
	;;
	PRODUCT=T8200)
    sed   -e "s/\# SUPPORT_FOTA .*$/SUPPORT_FOTA=y/" -e "s/\# CONFIG_PLATFORM_T8200 .*$/CONFIG_PLATFORM_T8200=y/" -e "s/\# CONFIG_CPU_TAVOR_PV .*$/CONFIG_CPU_TAVOR_PV=y/" -e "s/\# CONFIG_BOOT_ONENAND .*$/CONFIG_BOOT_ONENAND=y/" -e "s/\# CONFIG_PVK_BLOB_USB20 .*$/CONFIG_PVK_BLOB_USB20=y/"  -e "s/\# CONFIG_WTPTP_MOBM .*$/CONFIG_WTPTP_MOBM=y/" -e "s/\# CONFIG_WTPTP_NTBB .*$/CONFIG_WTPTP_NTBB=y/" -e "s/\# CONFIG_WTPTP_WTPTP .*$/CONFIG_WTPTP_WTPTP=y/" def_config > .config
#	mv -f .tmpconfig .config
	;;
    *)
    usage_help
	exit 1
	;;
esac


kernel_path=`echo $2 | sed -e "s/linux_kernel=//g"`
case "$kernel_path" in
	?)
		echo "usage:  ./setup.sh Your_linux_directory"
		exit 1
		;;
	*)
		if [ "" = "$kernel_path" ];then
			echo "usage:  ./setup.sh Your_linux_directory"
			exit 1
		fi

		if [ -r "$kernel_path" ];then
			echo "$kernel_path is OK!"
			rm -fr linux
			ln -s $kernel_path linux
		else
			echo ""$kernel_path" does not exist!"
			exit 1
		fi
		;;
esac

case "$3" in
	?)
		echo "usage:  setup build type, release or debug \
		      usage:  setup security, security or NULL "
		exit 1
		;;
	*)
		if [ "formal_release" = "$3" ];then
			sed -i -e 's/CONFIG_BLOB_DEBUG=y/CONFIG_BLOB_DEBUG=n/g' ${TARGET_SRC}/Rules.make
		fi
		if [ "TRUSTED" = "$3" ];then
			sed -i -e 's/CONFIG_BLOB_SECURITY=n/CONFIG_BLOB_SECURITY=y/g' ${TARGET_SRC}/Rules.make
		fi

		;;
esac

case "$4" in
	?)
		echo "usage:  setup build type, release or debug \
		      usage:  setup security, security or NULL "
		exit 1
		;;
	*)
		if [ "formal_release" = "$4" ];then
			sed -i -e 's/CONFIG_BLOB_DEBUG=y/CONFIG_BLOB_DEBUG=n/g' ${TARGET_SRC}/Rules.make
		fi
		if [ "TRUSTED" = "$4" ];then
			sed -i -e 's/CONFIG_BLOB_SECURITY=n/CONFIG_BLOB_SECURITY=y/g' ${TARGET_SRC}/Rules.make
		fi
		;;
esac

echo "Please run make zImage firstly,then build blob!" 
