/******************************************************************************
**	(C) Copyright 2007 Marvell International Ltd. 
**	All Rights Reserved
******************************************************************************/

/******************************************************************************
**
**  COPYRIGHT (C) 2000, 2001 Intel Corporation.
**
**  This software as well as the software described in it is furnished under
**  license and may only be used or copied in accordance with the terms of the
**  license. The information in this file is furnished for informational use
**  only, is subject to change without notice, and should not be construed as
**  a commitment by Intel Corporation. Intel Corporation assumes no
**  responsibility or liability for any errors or inaccuracies that may appear
**  in this document or any software that may be provided in association with
**  this document.
**  Except as permitted by such license, no part of this document may be
**  reproduced, stored in a retrieval system, or transmitted in any form or by
**  any means without the express written consent of Intel Corporation.
**
**  FILENAME:  		xllp_udc_os_depend.h
**
**  PURPOSE:   		This files contains the OS specific stuff for USB Device controller
**					(UDC) driver implementation.
**
**  LAST MODIFIED:  1/25/2001
**
******************************************************************************/

#ifndef _xllp_udc_os_depend_h
#define _xllp_udc_os_depend_h

#include "xllp_defs.h"

typedef struct
{
 unsigned int DesSize;
 unsigned int * pDesPayload;
}
OPT_USB_DESCRIPTOR_LOADS, *pOPT_USB_DESCRIPTOR_LOADS;

// UDC Controller Registers' Base
#define XLLP_UDC_REGISTERS_BASE		(0x40600000)

// This definition and functions are used
// because no XLLP clock enable functions were available when
// this code was developed.
#define XLLP_CLK_MGR_REGS_BASE          0x41300000
// #define XLLP_CLK_MGR_REGS_CKEN_UDC_EN   0x1U << 11
// #define XLLP_CLK_MGR_REGS_CKEN_UDC_DIS  0x7FF7FF

typedef struct XLLP_CLK_MGR_REGS_S
{
    XLLP_VUINT32_T CCCR;    // Core clock configuration register
    XLLP_VUINT32_T CKEN;    // Clock Enable register
    XLLP_VUINT32_T OSCC;    // Oscillator Configuration register
    XLLP_VUINT32_T CCSR;    // Core Clock Status register
} XLLP_CLK_MGR_REGS_T, *P_XLLP_CLK_MGR_REGS_T;



#endif 	/* _xllp_udc_os_depend_h */
