/******************************************************************************
**
**  COPYRIGHT (C) 2002, 2003 Intel Corporation.
**
**  This software as well as the software described in it is furnished under
**  license and may only be used or copied in accordance with the terms of the
**  license. The information in this file is furnished for informational use
**  only, is subject to change without notice, and should not be construed as
**  a commitment by Intel Corporation. Intel Corporation assumes no
**  responsibility or liability for any errors or inaccuracies that may appear
**  in this document or any software that may be provided in association with
**  this document.
**  Except as permitted by such license, no part of this document may be
**  reproduced, stored in a retrieval system, or transmitted in any form or by
**  any means without the express written consent of Intel Corporation.
**
**  FILENAME:   Flash.h
**
**  PURPOSE:    Holds all flash related definitions
**
******************************************************************************/
#ifndef __BBM_H__
#define __BBM_H__

#include "typedef.h"

#define VALID_HEADER            0x0000524E  // = 'N' + ('R'*256)

// Indicates the state of the BBT in volatile memory
typedef enum
{
    BBT_INVALID     = 1,
    BBT_UNCHANGED   = 2,
    BBT_CHANGED     = 3,
    BBT_ERASED      = 4
} ReloState_T;

// BBT Structure
typedef struct {
   USHORT   From;
   USHORT   To;
   } ReloPair_T, *P_ReloPair_T;

typedef struct {
   USHORT*          pHeader;
   USHORT*          pNumReloc;
   P_ReloPair_T     pRelo;
   } ReloTable_T, *P_ReloTable_T;

#endif


