/******************************************************************************
**
**  COPYRIGHT (C) 2002, 2003 Intel Corporation.
**
**  This software as well as the software described in it is furnished under
**  license and may only be used or copied in accordance with the terms of the
**  license. The information in this file is furnished for informational use
**  only, is subject to change without notice, and should not be construed as
**  a commitment by Intel Corporation. Intel Corporation assumes no
**  responsibility or liability for any errors or inaccuracies that may appear
**  in this document or any software that may be provided in association with
**  this document.
**  Except as permitted by such license, no part of this document may be
**  reproduced, stored in a retrieval system, or transmitted in any form or by
**  any means without the express written consent of Intel Corporation.
**
**  FILENAME:   Flash.h
**
**  PURPOSE:    Holds all flash related definitions
**
******************************************************************************/
#ifndef __FM_H__
#define __FM_H__

#include "typedef.h"
#include "flash.h"
#include "BBM.h"
//Flash Management (FM) structure contains:
typedef struct
{
    //pointer to the current BBT
    ReloTable_T BBT;
    //information about the current BBT
    ReloState_T BBT_State;
    UINT_T      BBT_Slot;       // Indicates which page in Block BBT located
    UINT_T      NumBBTSlots;
    //pointer to the master parition table
    UINT_T *pMPT;
}
FMProperties_T, *P_FMProperties_T;

//Function Prototypes
P_FMProperties_T GetFMProperties(void);
void FindPT(void);
UINT_T RelocateBlock(UINT_T Block, P_ReloTable_T pBBT, FlashBootType_T fbt);
UINT_T UpdateBBT(FlashBootType_T fbt);
UINT_T CreateBBT(FlashBootType_T fbt);
UINT_T ScanBBT(UINT_T BlockNum);
UINT_T FindBBT(FlashBootType_T fbt);
UINT_T BinarySearch(UINT_T, UINT_T, UINT_T, UINT_T, UINT_T, UINT_T*, FlashBootType_T);
void SetBBTState(ReloState_T newState, FlashBootType_T fbt);

#endif


