;
; Marvell CONFIDENTIAL
; Copyright 2007 Marvell Corporation All Rights Reserved.
;
; The source code contained or described herein and all documents
; related to the source code (Material) are owned by Intel Corporation
; or its suppliers or licensors.  Title to the Material remains with
; Intel Corporation or its suppliers and licensors. The Material contains
; trade secrets and proprietary and confidential information of Intel
; or its suppliers and licensors. The Material is protected by worldwide
; copyright and trade secret laws and treaty provisions. No part of the
; Material may be used, copied, reproduced, modified, published, uploaded,
; posted, transmitted, distributed, or disclosed in any way without Intel's
; prior express written permission.
;
; No license under any patent, copyright, trade secret or other intellectual
; property right is granted to or conferred upon you by disclosure or
; delivery of the Materials, either expressly, by implication, inducement,
; estoppel or otherwise. Any license under such intellectual property rights
; must be express and approved by Intel in writing.
;
;
; Module Name:  PPSet.s
;
;  Yossi Hanin ver.1
;
;*********************************************************************************
;
;;	PRESERVE8

	INCLUDE xlli_platform_defs_fbw.INC

	AREA    PP_SET, CODE, READONLY, ALIGN=5

;///////////////////////////////////////////////////////////////////////////////////////////
;///////////////////////////////////////////////////////////////////////////////////////////
;//SET PP#1: 0x01043110 with DDR at 208 meaning: 0x01042110 according to system spec for A0.
;// new_EVB_can_work_on_260
;// Support B0 serch for B0
;///////////////////////////////////////////////////////////////////////////////////////////
;///////////////////////////////////////////////////////////////////////////////////////////

	 EXPORT  ProductPointSetFunction
ProductPointSetFunction        FUNCTION

		STMFD     SP!, {R0-R3, LR}

 IF :DEF: PV

    ldr r0, =xlli_AVCR_PHYSICAL_BASE    		;
		ldr r1, =xlli_AVCR_VCC_APPS_1_25_VOLT	  ;
		str r1, [r0]                            ; set AVCR

 ENDIF


    ldr     r3,     =xlli_CLKREGS_PHYSICAL_BASE         ; Get clocks register base

		;//#5:set ACCR[XN:8:9:10]=0x1;[XL:0:1:2:3:4]=0x10;[XSPCLK:16:17]=0x00
		ldr r0,[r3, #xlli_ACCR_offset]  ;read ACCR_REG

		;//#5:set ACCR[XN:10:9:8]=b001
		ldr r2,=(xlli_BIT_8 | xlli_BIT_9 | xlli_BIT_10)
		bic r0,r0,r2       ;clear bits 8,9,10
		ldr r2,=xlli_BIT_8
		orr r0,r0,r2       ;set bit 8

		;//#5:[XL:4:3:2:1:0]=0x10 for 208 / 0x08 for 104=b01000
		ldr r2,=(xlli_BIT_0 | xlli_BIT_1 | xlli_BIT_2 | xlli_BIT_3 | xlli_BIT_4)
		bic r0,r0,r2       ;clear bits 0,1,2,3,4
		ldr r2,=xlli_BIT_4
		orr r0,r0,r2       ;set bit 4    ;//for 208

		;//#5:[XSPCLK:16:17]=0x03 = b11
		ldr r2,= (xlli_BIT_16 | xlli_BIT_17)
		orr r0,r0,r2       ;clear bit 16,17

		str r0,[r3,#xlli_ACCR_offset]    ;set ACCR

VERIFYACCR
		ldr r2,[r3,#xlli_ACCR_offset]  ;read ACCR_REG
		cmp r0,r2
		bne VERIFYACCR

		IF :DEF: _QT_ ;// If QT is defined

		;// Do nothing?

		ELSE ;//_QT_
		;//#6:SW set the F bit T bit: 0b10
	  ldr     r0,=xlli_BIT_1                               ; Set the F bit ; F bit 0x02 ; T bit 0x01   0x00000002
    mcr     p14, 0, r0, c6, c0, 0                       ; initiate the frequency change sequence

	 ;//#7 - SW Polls ACSR until XN=01 and XL =0x10
CHECK_ACSR_FOR_XN
		ldr r0,[r3, #xlli_ACSR_offset]  		;read ACSR
		ldr r1,=~(xlli_BIT_8 | xlli_BIT_9 | xlli_BIT_10)
		bic r0,r0,r1
		ldr r2,=xlli_BIT_8
		cmp r0,r2             ;is it 0x01?
		bne CHECK_ACSR_FOR_XN
		;//#7
CHECK_ACSR_FOR_XL
 ;//		ldr r1,=xlli_CLKREGS_PHYSICAL_BASE         ; Get clocks register base
		ldr r0,[r3, #xlli_ACSR_offset]  		;read ACSR
		ldr r1,=~(xlli_BIT_0 | xlli_BIT_1 | xlli_BIT_2 | xlli_BIT_3 | xlli_BIT_4)
		bic r0,r0,r1
		ldr r2,=xlli_BIT_4
		cmp r0,r2             ;is it 0x10?
		bne CHECK_ACSR_FOR_XL

		ENDIF ;//_QT_

		;//DDR ->260 preparations for A0 only needs: MDFNG[HWFREQ1] , DDR_HCAL[DDR_HCAL_HCEN]
		;//#9:set MDFNG[29:28]=1,0
 		ldr r1,=xlli_DMEMREGS_PHYSICAL_BASE
		ldr r0,[r1,#0x00]  ;read MDCNFG_REG
		;//ldr r2,=BIT2829    ;for B0
		;//bic r0,r0,r2       ;set bit29&bit28=00  ;for B0
;;;		ldr r2,=(xlli_BIT_28 | xlli_BIT_29)        	;//for A0 0b11 , B0 0b10
		bic r0,r0,#xlli_BIT_28
		ldr r2,=xlli_BIT_29        										;//for A0 0b11 , B0 0b10
		orr r0,r0,r2       ;//For A0 set bit29&bit28=11 For B0 set bit29&bit28=10
		str r0,[r1,#00]    ;//set MDCNFG_REG  A0[1,1] B0[1,0]

		ldr r0,[r1,#xlli_DDR_HCAL_offset]  ;read DDR_HAL_REG
		ldr r2,=xlli_BIT_31
		orr r0,r0,r2       ;set bit31=1  ;//increase from 26Mhz
		str r0,[r1,#xlli_DDR_HCAL_offset]

		;//#9: check that MDCNFG_REG changed only for BO
;//CHECK_MDFNG_FOR_208_1 ;//according to shuki need to check also this
;//		ldr r1,=MDCNFG_REG
;//		ldr r0,[r1,#0x00]  		;read MDCNFG_REG
;//		ldr r1,=~BIT2829
;//		bic r0,r0,r1
;//		ldr r1,=BIT2829    ;after write they should be[28:29] == 0:0 = cfg=208
;//		cmp r0,r1
;//		bne CHECK_MDFNG_FOR_208_1


		;//#10:set ACCR[DMCFS:13:12]DDR freq
		ldr r0,[r3, #xlli_ACCR_offset]  ;read ACCR_REG
		ldr r2,=(xlli_BIT_12 | xlli_BIT_13)
		bic r0,r0,r2       ;clear bit 13 & 12
 IF :DEF: RUN_DDR_208_MHZ
		ldr r2,=(xlli_BIT_13)                 				;DDR->208
 ELSE
		ldr r2,=(xlli_BIT_12 | xlli_BIT_13) 				  ;DDR->260 new_EVB_can_work_on_260
 ENDIF
		orr r0,r0,r2

		;//#10: HSS[15:14]:b00
		ldr r2,=(xlli_BIT_14 | xlli_BIT_15)
		bic r0,r0,r2       ;clear bits 14,15
		;ldr r2,=xlli_BIT_15
		;orr r0,r0,r2       ;set bit 15 (208 HSIO)

		;//#10:SFLFS[19:18]:b01
		ldr r2,=(xlli_BIT_18 | xlli_BIT_19)
		bic r0,r0,r2       ;clear bits 18,19
		ldr r2,=xlli_BIT_18
		orr r0,r0,r2       ;set bit 18

		;//#10: SMCFS[25:24:23]:b010
		ldr r2,=(xlli_BIT_23 | xlli_BIT_24 | xlli_BIT_25)
		bic r0,r0,r2       ;clear bits
		ldr r2,=xlli_BIT_24
		orr r0,r0,r2       ;set bit 24

		str r0,[r3, #xlli_ACCR_offset]    ;set ACCR

		;//#11: check only the modified bits in the ACSR from above and check MDCNFG_REG [28:29] = b00
CHECK_ACSR_FOR_DMCFS  ;//DMCFS:13:12]
		ldr r0,[r3, #xlli_ACSR_offset]  		;read ACSR
		ldr r1,=~(xlli_BIT_12 | xlli_BIT_13)
		bic r0,r0,r1
		ldr r2,[r3, #xlli_ACCR_offset]  		;read ACCR
		ldr r1,=~(xlli_BIT_12 | xlli_BIT_13)
		bic r2,r2,r1
		cmp r0,r2             ;is it b10?
		bne CHECK_ACSR_FOR_DMCFS

CHECK_ACSR_FOR_HSS  ;//HSS[15:14]:b00
		ldr r0,[r3, #xlli_ACSR_offset]  		;read ACSR
		ldr r1,=~(xlli_BIT_14 | xlli_BIT_15)
		bic r0,r0,r1
		ldr r2,[r3, #xlli_ACCR_offset]  		;read ACCR
		ldr r1,=~(xlli_BIT_14 | xlli_BIT_15)
		bic r2,r2,r1
		cmp r0,r2             ;is it b00?
		bne CHECK_ACSR_FOR_HSS

CHECK_ACSR_FOR_SFLFS  ;//SFLFS[19:18]:b01
		ldr r0,[r3, #xlli_ACSR_offset]  		;read ACSR
		ldr r1,=~(xlli_BIT_18 | xlli_BIT_19)
		bic r0,r0,r1
		ldr r2,[r3, #xlli_ACCR_offset]  		;read ACCR
		ldr r1,=~(xlli_BIT_18 | xlli_BIT_19)
		bic r2,r2,r1
		cmp r0,r2             ;is it b01?
		bne CHECK_ACSR_FOR_SFLFS

CHECK_ACSR_FOR_SMCFS  ;//SMCFS[25:24:23]:b010
		ldr r0,[r3, #xlli_ACSR_offset]  		;read ACSR
		ldr r1,=~(xlli_BIT_23 | xlli_BIT_24 | xlli_BIT_25)
		bic r0,r0,r1
		ldr r2,[r3, #xlli_ACCR_offset]  		;read ACCR
		ldr r1,=~(xlli_BIT_23 | xlli_BIT_24 | xlli_BIT_25)
		bic r2,r2,r1
		cmp r0,r2             ;is it b10?
		bne CHECK_ACSR_FOR_SMCFS

;;CHECK_MDCNFG  																			;check MDCNFG_REG [28:29] = b00
;;    ldr r1,=xlli_DMEMREGS_PHYSICAL_BASE             ;Dynamic Memory Control Reg Base
;;    ldr r0,[r1, #xlli_MDCNFG_offset]                ;read MDCNFG_REG value
;;		ldr r2,=xlli_BIT_29             								;//for A0 0b11 , B0 0b10
;;    and r0, r0, r2
;;		cmp r0,#0x0
;;		bne CHECK_MDCNFG

 		ldr r1,=xlli_STAMREGS_PHYSICAL_BASE
		ldr r0,[r1,#0x68]  														;read MEMCLKCFG_REG
		ldr r2,=(xlli_BIT_18 | xlli_BIT_17 | xlli_BIT_16)
		bic r0,r0,r2       														;clear bits 18,17, 16
		ldr r2,=xlli_BIT_17
		orr r0,r0,r2       														;set bit 17
		str r0,[r1, #0x68]    												;set MEMCLKCFG_REG

	  LDMFD	SP!, {R0-R3, PC}	; Return to caller

		ENDFUNC
    END

