/******************************************************************************
**	(C) Copyright 2007 Marvell International Ltd. 
**	All Rights Reserved
******************************************************************************/

/******************************************************************************
**
**  COPYRIGHT (C) 2001, 2002 Intel Corporation.
**
**  This software as well as the software described in it is furnished under
**  license and may only be used or copied in accordance with the terms of the
**  license. The information in this file is furnished for informational use
**  only, is subject to change without notice, and should not be construed as
**  a commitment by Intel Corporation. Intel Corporation assumes no
**  responsibility or liability for any errors or inaccuracies that may appear
**  in this document or any software that may be provided in association with
**  this document.
**  Except as permitted by such license, no part of this document may be
**  reproduced, stored in a retrieval system, or transmitted in any form or by
**  any means without the express written consent of Intel Corporation.
**
**  FILENAME:       xllp_defs.h
**
**  PURPOSE:        header file contining common XScale Low Level Primitive
**                  (XLLP) type definitions and preprocessor macros. This as
**                  a header file that is intended for inclusion within XLLP
**                  library sources, and in sources that invoke XLLP library
**                  functions.
**
**
******************************************************************************/

#ifndef __XLLP_DEFS_H__
#define __XLLP_DEFS_H__

/* Typedefs for peripheral register variables */
typedef long                   XLLP_INT32_T,   *P_XLLP_INT32_T;
typedef volatile XLLP_INT32_T  XLLP_VINT32_T,  *P_XLLP_VINT32_T;
typedef unsigned long          XLLP_UINT32_T,  *P_XLLP_UINT32_T;
typedef volatile XLLP_UINT32_T XLLP_VUINT32_T, *P_XLLP_VUINT32_T;

typedef short                  XLLP_INT16_T,   *P_XLLP_INT16_T;
typedef volatile XLLP_INT16_T  XLLP_VINT16_T,  *P_XLLP_VINT16_T;
typedef unsigned short         XLLP_UINT16_T,  *P_XLLP_UINT16_T;
typedef volatile XLLP_UINT16_T XLLP_VUINT16_T, *P_XLLP_VUINT16_T;

typedef char                   XLLP_INT8_T,    *P_XLLP_INT8_T;
typedef volatile XLLP_INT8_T   XLLP_VINT8_T,   *P_XLLP_VINT8_T;
typedef unsigned char          XLLP_UINT8_T,   *P_XLLP_UINT8_T;
typedef volatile XLLP_UINT8_T  XLLP_VUINT8_T,  *P_XLLP_VUINT8_T;


#ifndef NULL
#define NULL 0
#endif

/* typedefs for XLLP API */
typedef enum
{
    XLLP_FALSE = 0,
    XLLP_TRUE = 1
} XLLP_BOOL_T;

typedef enum
{
    XLLP_LO = 0,
    XLLP_HI = 1
}XLLP_LEVEL_T;

typedef enum
{
    XLLP_OFF = 0,
    XLLP_ON = 1
}XLLP_CONTROL_T;

// TBD everything below may be commented out

/* Bit Position Macros */
#define XLLP_BIT_0    ( 1 << 0 )
#define XLLP_BIT_1    ( 1 << 1 )
#define XLLP_BIT_2    ( 1 << 2 )
#define XLLP_BIT_3    ( 1 << 3 )
#define XLLP_BIT_4    ( 1 << 4 )
#define XLLP_BIT_5    ( 1 << 5 )
#define XLLP_BIT_6    ( 1 << 6 )
#define XLLP_BIT_7    ( 1 << 7 )
#define XLLP_BIT_8    ( 1 << 8 )
#define XLLP_BIT_9    ( 1 << 9 )
#define XLLP_BIT_10   ( 1 << 10 )
#define XLLP_BIT_11   ( 1 << 11 )
#define XLLP_BIT_12   ( 1 << 12 )
#define XLLP_BIT_13   ( 1 << 13 )
#define XLLP_BIT_14   ( 1 << 14 )
#define XLLP_BIT_15   ( 1 << 15 )
#define XLLP_BIT_16   ( 1 << 16 )
#define XLLP_BIT_17   ( 1 << 17 )
#define XLLP_BIT_18   ( 1 << 18 )
#define XLLP_BIT_19   ( 1 << 19 )
#define XLLP_BIT_20   ( 1 << 20 )
#define XLLP_BIT_21   ( 1 << 21 )
#define XLLP_BIT_22   ( 1 << 22 )
#define XLLP_BIT_23   ( 1 << 23 )
#define XLLP_BIT_24   ( 1 << 24 )
#define XLLP_BIT_25   ( 1 << 25 )
#define XLLP_BIT_26   ( 1 << 26 )
#define XLLP_BIT_27   ( 1 << 27 )
#define XLLP_BIT_28   ( 1 << 28 )
#define XLLP_BIT_29   ( 1 << 29 )
#define XLLP_BIT_30   ( 1 << 30 )
#define XLLP_BIT_31   ( 1 << 31 )

/* Miscellaneous Macros */
#define XLLP_USEMASK    XLLP_TRUE
#define XLLP_NOMASK     XLLP_FALSE
#define XLLP_SET        1
#define XLLP_CLEAR      0
#define XLLP_ENCODED_ERROR 0xdeadc0deL

#endif //__XLLP_DEFS_H__




