/****************************************************************************/
/* FILENAME:		RB_Check.h		*/
/*					*/
/* DESCRIPTION:	Sample code for Memory check used by Red Bend UPI	*/
/*					*/
/* Copyright Red Bend Software.  All rights reserved.	*/
/****************************************************************************/

#ifndef __RB_CHECK_HEADER_
#define __RB_CHECK_HEADER_

#include "RB_ImageUpdate.h"
#ifdef __cplusplus
	extern "C" {
#endif
typedef unsigned char  Byte;
typedef unsigned short Word;
typedef unsigned long  Dword;


#define MAX_NUM_EXCLUDE 10
int num_of_exclude_regions;
Dword exclude_regions_array_start[MAX_NUM_EXCLUDE];
Dword exclude_regions_array_length[MAX_NUM_EXCLUDE];

int check();

int RB_Check	(Dword start,	// start address of app to update
						Dword end,		// end address of app to update
						Byte* pRAM,	// pointer for the ram to use
						Dword dwRAMSize,
						Byte* pbyInternalRAM,
						Dword dwInternalRAMSize,
						Dword* buff_start,
						Dword num_of_buff 	// number of back up buffers
						);

int RB_CheckRamMemory(Byte* pRAM, Dword dwRAMSize);
int RB_CheckInternalRAMMemory(Byte* pbyInternalRAM, Dword dwInternalRAMSize);
int RB_CheckReadImage(Byte* pRam, Dword flash, int readSize);
int RB_CheckReadBackupBlock(Byte *pRam, Dword flash, Dword readSize);
int RB_CheckReadImageCases(Byte* pRam, Dword* pFlash);
int RB_CheckWriteSector(Byte* pRam, Dword flash);
int RB_CheckWriteImage(Byte* pRam, Dword flashStart, Dword flashEnd);
int RB_CheckWriteBackupBlock(Byte* pRam, Dword Flash);
int RB_CheckIfBckInImage(Dword start, Dword end, Dword* buff_start, 
				Dword num_of_buff);

int RB_memcmp(Byte* from, Byte *to, int length);
void RB_memset(Byte* to, Byte value, int size);

void RB_DefineWritingExcludeRegions(void);
int RB_CheckIfAddressNotExcluded(Dword flashAddress, int sectorSize);

#ifdef __cplusplus
}
#endif  /* __cplusplus */

#endif

