/******************************************************************************
**  (C) Copyright 2007 Marvell International Ltd. 
**  All Rights Reserved
******************************************************************************/

/********************************************************************************
**  COPYRIGHT 2007 Marvell Inernational Ltd.
**  All Rights Reserved
**
**  COPYRIGHT (C) 2002, 2003 Intel Corporation.
**
**  This software as well as the software described in it is furnished under
**  license and may only be used or copied in accordance with the terms of the
**  license. The information in this file is furnished for informational use
**  only, is subject to change without notice, and should not be construed as
**  a commitment by Intel Corporation. Intel Corporation assumes no
**  responsibility or liability for any errors or inaccuracies that may appear
**  in this document or any software that may be provided in association with
**  this document.
**  Except as permitted by such license, no part of this document may be
**  reproduced, stored in a retrieval system, or transmitted in any form or by
**  any means without the express written consent of Intel Corporation.
**
**  FILENAME:   Misc.h
**
**  PURPOSE:   Definitions and functions declarations used in the
**             Boot ROM development
**
******************************************************************************/
#ifndef Misc_h
#define Misc_h

#include "tim.h"
#include "typedef.h"
#include "errors.h"
#include "xllp_dfc.h"


#define BV_OSCR0    (volatile unsigned long *)( 0x40A00010 )    //  OS Timer Counter register 0
#define TIMER_CLEAR (*BV_OSCR0 = 0)
#define TIMER_GET   (*BV_OSCR0)
//#define TIMER_FREQ  (3.25)        // in MHz
//#define TIMER_FREQ(A) ((A*15)/4)       // in MHz
#define TIMER_FREQ(A) ((A*13)/4)       // in MHz

typedef  unsigned short  HALF_WORD; // 16 bit unsigned
typedef  unsigned int    WORD;      // 32 bit unsigned
//typedef  unsigned char   BYTE;      //  8 bit unsigned
pIMAGE_INFO FindImageInTIM(pTIM, UINT_T);
int strlen(const char *String);
void memset(void *Addr, unsigned char Val, unsigned long Size);
void *memcpy(void *dest, const void *src, unsigned int n);
INT_T memcmp( const void *buf1, const void *buf2, INT_T count);
int strcpy(char *dest, char *src);
void Delay(int uSec);
pWTP_RESERVED_AREA_HEADER FindPackageInReserved (UINT_T * Retval, pTIM pTIM_h, UINT_T Identifier);
void ConvertIntToBuf8(unsigned char* StringPtr,unsigned int Value, int Width,unsigned int Count);
int strcmpl( char* str1, char* str2, int maxlength );
int stricmpl( char* str1, char* str2, int maxlength );

// These 2 functions allow for multiple instances of one "TYPE" of
// package to be retrieved from the reserved area of the TIM
//-----------------------------------------------------------------------------------------------------
pWTP_RESERVED_AREA_HEADER FindFirstPackageTypeInReserved (UINT_T * Retval, pTIM pTIM_h, UINT_T Identifier);
pWTP_RESERVED_AREA_HEADER FindNextPackageTypeInReserved (UINT_T * Retval);

UINT_T GetOSCR0(void);
UINT_T OSCR0IntervalInMilli(UINT_T Before, UINT_T After);
#define Delay_us(x) Delay(x)
#define Delay_ms(x) Delay(x*1000)
#define Delay_seconds(x) Delay(x*1000*1000)  /* max 4294 seconds */

//mdb - CRC disabled
#if 0
UINT32_T CheckSum(UINT8_T*, UINT_T, UINT8_T*);
UINT_T ValidateCheckSum(UINT_T ImageID, pTIM pTIM_h);
#endif

#endif // Misc_h
