;/******************************************************************************
;**	(C) Copyright 2007 Marvell International Ltd.  
;**	All Rights Reserved
;******************************************************************************/

;;----------------------------------------------------------------------------------------
;;
;; INTEL CONFIDENTIAL
;; Copyright 2000-2005 Intel Corporation All Rights Reserved.
;;
;; The source code contained or described herein and all documents
;; related to the source code (Material) are owned by Intel Corporation
;; or its suppliers or licensors.  Title to the Material remains with
;; Intel Corporation or its suppliers and licensors. The Material contains
;; trade secrets and proprietary and confidential information of Intel
;; or its suppliers and licensors. The Material is protected by worldwide
;; copyright and trade secret laws and treaty provisions. No part of the
;; Material may be used, copied, reproduced, modified, published, uploaded,
;; posted, transmitted, distributed, or disclosed in any way without Intels
;; prior express written permission.
;;
;; No license under any patent, copyright, trade secret or other intellectual
;; property right is granted to or conferred upon you by disclosure or
;; delivery of the Materials, either expressly, by implication, inducement,
;; estoppel or otherwise. Any license under such intellectual property rights
;; must be express and approved by Intel in writing.
;;
;;
;; Memory Map for Bulverde on Mainstone
;;----------------------------------------------------------------------------------------

    EXPORT OEMAddressTable
    ;
    ; OEM memory map for Bulverde on Mainstone
    ;

   def CACHEABLE,  0x0008
   def BUFFERABLE, 0x0004
   def CACHE_BUFF, (CACHEABLE | BUFFERABLE)


OEMAddressTable 
 ;----------------------------------------------------------------------------------------------
 ; virtual address                       physical address                1M      64K   properties
 ;----------------------------------------------------------------------------------------------
   DCD ISRAM_BASE_SELF_VIRTUAL,          ISRAM_BASE_SELF_PHYSICAL,        1,     0,    CACHE_BUFF  ;
   DCD NOR_CS0_BASE_VIRTUAL,			 NOR_CS0_BASE_PHYSICAL,			256,     0,    0   ;     
   DCD NOR_CS2_BASE_VIRTUAL,			 NOR_CS2_BASE_PHYSICAL,			256,     0,    0   ;     
   DCD DDR_DKB_VIRTUAL,				 	 DDR_DKB_PHYSICAL,			      0,	 4,	   CACHE_BUFF
   DCD TLB_BASE_VIRTUAL,                 TLB_BASE_PHYSICAL,               0,     12,    CACHE_BUFF  ;
   DCD DDR_VIRTUAL,				 		 DDR_PHYSICAL,			   	   1023,	 0,   CACHE_BUFF
   DCD PERIF_BASE_VIRTUAL,               PERIF_BASE_PHYSICAL,           448,     0,             0  ; (4000 0000, 4000 0000) Mem-Mapped Registers (perifs)
   DCD 0x00000000,                       0x00000000,                      0,     0,             0  ; End of Table (#MB MUST BE ZERO!)


   def ISRAM_BASE_SELF_PHYSICAL,         0x5C000000
   def ISRAM_BASE_SELF_VIRTUAL,          0x5C000000
   def NOR_CS2_BASE_PHYSICAL,			 0x10000000
   def NOR_CS2_BASE_VIRTUAL,			 0x10000000
   def NOR_CS0_BASE_PHYSICAL,			 0x00000000
   def NOR_CS0_BASE_VIRTUAL,			 0x20000000	   ; Corralated with CS0_MMU_MAPPING_SKEW in general.h
   def DDR_DKB_PHYSICAL,				 0x80000000	   ; 256 KB Remapped to 0
   def DDR_DKB_VIRTUAL,					 0x0
   def TLB_BASE_PHYSICAL,				 0x80040000	   ; 768    KB (TLB won't take up any more than 128 KB)
   def TLB_BASE_VIRTUAL,				 0x80040000
   def DDR_PHYSICAL,				 	 0x80100000	   ; ~127 MB	
   def DDR_VIRTUAL,				 		 0x80100000
   def PERIF_BASE_PHYSICAL,              0x40000000    ; peripherals
   def PERIF_BASE_VIRTUAL,               PERIF_BASE_PHYSICAL


