
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <time.h>
#include <unistd.h>
#include <stdlib.h>

#include "Typedef.h"
#include "Tim.h"

#define O_BINARY 0
int copy_file (int ifd, const char *datafile);
struct stHead
{
    char magic[4];
    int  items;
    #define BITMES_MAX_NUMS 50
    STPreTIMItem bitmes[BITMES_MAX_NUMS];
}__attribute__((packed));

typedef  struct  stHead STHead;

static STHead st_head;
static int bimtes_count = -1;
static STPreTIMItem *pbitmes = &st_head.bitmes[0];
char	*imagefile;
struct stat sbuf;
int PreTimMerge(char* pDestFileName,STPreTIMItem* pPreTimItem,int itemcount)
{
    int i;
    int ifd;
    char *tmp_name,*bak_tmp_name;

    bimtes_count = itemcount;

    memset(&st_head,0,sizeof(STHead));
    memcpy(st_head.magic,"PRET",4);
    
    pbitmes = pPreTimItem;
    for(i = 0;i < itemcount;i++)
    {
        st_head.bitmes[i] = *pbitmes++;
    }

    {
        pbitmes = &st_head.bitmes[0];
        //bimtes_count += 1;
        st_head.items = bimtes_count;

        pbitmes->iFromOffset = (int)pbitmes - (int)&st_head + bimtes_count*sizeof(STPreTIMItem);

        for(i = 0;i < bimtes_count;i++,pbitmes++)
        {
            if (stat (pbitmes->szFileName, &sbuf) < 0) 
            {
                printf("in the loop stat %s\n",pbitmes->szFileName);
                fprintf (stderr, "Can't stat %s: %s\n",
                    pbitmes->szFileName, strerror(errno));
                exit (EXIT_FAILURE);
            }
		    pbitmes->iFileSize = sbuf.st_size;//htonl(sbuf.st_size);
            if(i != bimtes_count)(pbitmes+1)->iFromOffset = pbitmes->iFromOffset + sbuf.st_size;
            #if 1
            fprintf(stderr,
            "\niFromOffset=%d"\
            "\nbDownloadToFlash=%d"\
            "\niFileSize=%d"\
            "\niFlashAddress=0x%x"\
            "\nbYaffsFile=%d"\
            "\niYaffsSize=0x%x"\
            "\nszFileName=%s\n",
            pbitmes->iFromOffset,
            pbitmes->bDownloadToFlash,
            pbitmes->iFileSize,//ntohl(pbitmes->iFileSize),
            pbitmes->iFlashAddress,
            pbitmes->bYaffsFile,
            pbitmes->iYaffsSize,
            pbitmes->szFileName
            );
            #endif
        }
    }
    
    imagefile = pDestFileName;
    //    printf("start analyse the filename:%s\n",pbitemes->szFileName);
    
    fprintf(stderr,"\n=========%s============\n\n",imagefile);
    ifd = open(imagefile, O_RDWR|O_CREAT|O_TRUNC|O_BINARY, 0666);
    
    if (ifd < 0) {
        fprintf (stderr, "%s: Can't open %s: %s\n",
                 imagefile, strerror(errno));
        exit (EXIT_FAILURE);
    }
    
    #if 1
    {UINT32 name_len = 0;
     char *pos;
     char __tmp[256];
        pbitmes = &st_head.bitmes[0];
        for(i = 0;i < bimtes_count;i++,pbitmes++)
         name_len += strlen(pbitmes->szFileName)+1;
        bak_tmp_name = tmp_name = (char*)calloc(name_len,sizeof(char));
       
        pbitmes = &st_head.bitmes[0];
        for(i = 0;i < bimtes_count;i++,pbitmes++)
        {
            strcpy(tmp_name,pbitmes->szFileName);
            tmp_name += strlen(pbitmes->szFileName)+1;
        }
        //strrchr
        pbitmes = &st_head.bitmes[0];
        for(i = 0;i < bimtes_count;i++,pbitmes++)
        {
            pos = strrchr(pbitmes->szFileName,'/');
            if(pos)
            {
                strcpy(__tmp,pbitmes->szFileName);
                memset(pbitmes->szFileName,0,strlen(pbitmes->szFileName));
                strcpy(pbitmes->szFileName,__tmp+(pos-pbitmes->szFileName)+1);
                fprintf(stderr,"\n\n+++++\nstr=%s\n-----\n\n",pbitmes->szFileName);
            }
        }
        tmp_name = bak_tmp_name;
    }
    #endif

    pbitmes = &st_head.bitmes[0];

	if (write(ifd, &st_head,  pbitmes->iFromOffset) !=  pbitmes->iFromOffset) {
		fprintf (stderr, "%s: Write error on %s: %s\n",
			     imagefile, strerror(errno));
        free(bak_tmp_name);
		exit (EXIT_FAILURE);
	}

    fprintf(stderr,"\ntmp_name=%s\n",tmp_name);

    for(i = 0;i < bimtes_count;i++)
     if(copy_file (ifd, tmp_name) == EXIT_FAILURE)
     {
        free(bak_tmp_name);
        exit(EXIT_FAILURE);    
     }else
        {
            tmp_name += strlen(tmp_name) + 1;
        }
    free(bak_tmp_name);

#if defined(_POSIX_SYNCHRONIZED_IO) && !defined(__sun__) && !defined(__FreeBSD__) && !defined(__APPLE__)
	(void) fdatasync (ifd);
#else
	(void) fsync (ifd);
#endif

	if (close(ifd)) {
		fprintf (stderr, "%s: Write error on %s: %s\n",
			     imagefile, strerror(errno));
		exit (EXIT_FAILURE);
	}
}

 int
copy_file (int ifd, const char *datafile)
{
	int dfd;
	struct stat sbuf;
	unsigned char *ptr;
	int zero = 0;
	int size;


	if ((dfd = open(datafile, O_RDONLY|O_BINARY)) < 0) {
		fprintf (stderr, "Can't open %s: %s\n",
			     datafile, strerror(errno));
		return (EXIT_FAILURE);
	}

	if (fstat(dfd, &sbuf) < 0) {
		fprintf (stderr, "Can't stat %s: %s\n",
			     datafile, strerror(errno));
		return (EXIT_FAILURE);
	}

	ptr = (unsigned char *)mmap(0, sbuf.st_size,
				    PROT_READ, MAP_SHARED, dfd, 0);
	if (ptr == (unsigned char *)MAP_FAILED) {
		fprintf (stderr, "Can't read %s: %s\n",
			     datafile, strerror(errno));
		return (EXIT_FAILURE);
	}


	size = sbuf.st_size;
	if (write(ifd, ptr, size) != size) {
		fprintf (stderr, "Write error on %s: %s\n",
			     imagefile, strerror(errno));
		return (EXIT_FAILURE);
	}

	(void) munmap((void *)ptr, sbuf.st_size);
	(void) close (dfd);
    return EXIT_SUCCESS;
}

