# (C) Copyright 2007 Marvell International Ltd. 
# All Rights Reserved
#
###############################################################
# (C) Copyright 2007 Marvell International Ltd. 
# All Rights Reserved
#
###############################################################
#	Makefile for the Intel NonTrusted OBM
#
#
##############################################################

#Global Macros
BASE = ..
SDT = C:\Program Files\Intel\SDT2.0.1
RELEASE = 1
WINCE = 0
LINUX = 0
SDRAM = 0
NAND = 1
ONENAND = 0
MSYS = 0
RM = del /F/Q

#Tools
!if ("$(PLATFORM)" == "MHP" )
C_Compiler = "$(SDT)\intelxsc\bin\ccxscthb.exe"
Cxx_Compiler = "$(SDT)\intelxsc\bin\ccxscthb.exe"
!endif

!if ("$(PLATFORM)" == "MHL")
C_Compiler = "$(SDT)\intelxsc\bin\ccxscthb.exe"
Cxx_Compiler = "$(SDT)\intelxsc\bin\ccxscthb.exe"
!endif

!if ("$(PLATFORM)" == "MHLV")
C_Compiler = "$(SDT)\intelxsc\bin\ccxscthb.exe"
Cxx_Compiler = "$(SDT)\intelxsc\bin\ccxscthb.exe"
!endif

!if ("$(PLATFORM)" == "TAVOR")
C_Compiler = "$(SDT)\intelxsc\bin\ccxscthb.exe"
Cxx_Compiler = "$(SDT)\intelxsc\bin\ccxscthb.exe"
!endif

Assembler = "$(SDT)\intelxsc\bin\asxsc.exe"
JTAG_Debugger = "$(SDT)\xdb\xdb.exe"
Linker = "$(SDT)\intelxsc\bin\ldxsc.exe"
ROM_Monitor_Debugger = "$(SDT)\xdb\xdb.exe"
Simulator_Debugger = "$(SDT)\xdb\xdb.exe"
Symbol_Converter = "$(SDT)\xdbbin\dwarf2bd.exe"
elf2bin = "$(SDT)\xdbbin\elf2bin.exe"

!if ($(SDRAM) == 128)
SDRAM_SIZE = ENABLE_CS1_SDRAM SETA 1
!else
SDRAM_SIZE = SINGLE_BANK_SDRAM SETA 1
!endif

!if $(WINCE)
OS_BUILD = WINCE_BUILD SETA 1
RESUME_TYPE = "_wince_"
!else
!if $(LINUX)
OS_BUILD = LINUX_BUILD SETA 1
RESUME_TYPE = "_linux_"
!else
OS_BUILD = STD_BUILD SETA 1
RESUME_TYPE = "_"
!endif
!endif


######## Monahans SPECIFIC DEFINES ########
######## END MONAHANS SPECIFIC DEFINES ########


######## TAVOR SPECIFIC DEFINES ########
!if ("$(PLATFORM)" == "TAVOR")



!if ("$(OBM_MODE)" == "MODE_0")
ObmMode = MODE_0
!else
!if ("$(OBM_MODE)" == "MODE_2")
ObmMode = MODE_2
!else
!if ("$(OBM_MODE)" == "MODE_3")
ObmMode = MODE_3
!else
!if ("$(OBM_MODE)" == "MODE_4")
ObmMode = MODE_4
!else
!if ("$(OBM_MODE)" == "MODE_6")
ObmMode = MODE_6
!else
ObmMode = MODE_1
!endif
!endif
!endif
!endif
!endif

!if ("$(FLASH_TYPE)" == "MDOC")
FlashType = mdoc
Flash_Type = MDOC
$(MSYS) = 1
$(ONENAND) = 0
$(NAND) = 0
!else
!if ("$(FLASH_TYPE)" == "ONENAND")
FlashType = oneNand
Flash_Type = ONENAND
$(MSYS) = 0
$(ONENAND) = 1
$(NAND) = 0
!else
FlashType = nand8
Flash_Type = NAND8
$(MSYS) = 0
$(ONENAND) = 0
$(NAND) = 1
!endif
!endif


!if ("$(BOARD_TYPE)" == "YARDEN")
boardType = YARDEN
!else
!if ("$(BOARD_TYPE)" == "B0_ULPI")
boardType = B0_ULPI
!else
!if ("$(BOARD_TYPE)" == "SAAR")
boardType = SAAR
!else
boardType = B0
!endif
!endif
!endif


!endif
######  END TAVOR DEFINES ########




!if $(RELEASE)
#release flags
OUTDIR = release
CC_FLAGS = -nologo -Gy -O1 /Zi -DNDT /DTRUSTED=0 /DOBM=1 /DDKB=0 /DBOOTROM=0 /DJTAG_USED=0 /DONENAND_CODE=$(ONENAND) /DMDOC_CODE=$(MSYS) /DNAND_CODE=$(NAND) -D__OPTIMISE_TIME -D__TARGET_ARCH_5 -D__TARGET_FEATURE_DSPMUL -D__TARGET_CPU_XSCALE -D__TARGET_FEATURE_DOUBLEWORD -DINLINE_ASSEMBLER_NOT_SUPPORTED=1
!else
#debug flags
OUTDIR = debug
CC_FLAGS = -nologo -Gy /Od /Zi /DNDT /DTRUSTED=0 /DOBM=1 /DDKB=0 /DBOOTROM=0 /DJTAG_USED=0 /DONENAND_CODE=$(ONENAND) /DMDOC_CODE=$(MSYS) /DNAND_CODE=$(NAND) /D__OPTIMISE_TIME /D__TARGET_ARCH_5 /D__TARGET_FEATURE_DSPMUL /D__TARGET_CPU_XSCALE /D__TARGET_FEATURE_DOUBLEWORD /DINLINE_ASSEMBLER_NOT_SUPPORTED=1
!endif


OUTPUT_NAME = $(BASE)\$(PLATFORM)\$(OUTDIR)\$(PLATFORM)$(RESUME_TYPE)NTOBM


INCLUDES = /I$(BASE)\Flash\DFC /I$(BASE)\Download /I$(BASE)\MainProgram /I$(BASE)\Misc /I$(BASE)\Flash /I$(BASE)\DMA /I$(BASE)\Startup /I$(BASE)\$(PLATFORM) /I$(BASE)\$(PLATFORM)\DDR

!if $(ONENAND)
INCLUDES = $(INCLUDES) /I$(BASE)\Flash\OneNAND
!endif
!if $(MSYS)
INCLUDES = $(INCLUDES) /I$(BASE)\Flash\M-SYS
!endif


!if ("$(PLATFORM)" == "TAVOR")
OUTDIR = $(OUTDIR)\$(BOARD_TYPE)\$(FlashType)
OUTPUT_NAME = $(BASE)\$(PLATFORM)\$(OUTDIR)\$(PLATFORM)$(RESUME_TYPE)$(boardType)_NTOBM_$(Flash_Type)_$(ObmMode)$(RESUME_TYPE)D2D2
CC_FLAGS = $(CC_FLAGS) /D$(ObmMode) /DTAVOR_BOERNE /DD2D2WK
INCLUDES = $(INCLUDES) /I$(BASE)\$(PLATFORM)\pin_mux\INC /I$(BASE)\$(PLATFORM)\I2C

!if ("$(BOARD_TYPE)" == "YARDEN")
CC_FLAGS = $(CC_FLAGS) /DYARDEN
!else
!if ("$(BOARD_TYPE)" == "B0_ULPI")
CC_FLAGS = $(CC_FLAGS) /DB0_ULPI
!else
!if ("$(BOARD_TYPE)" == "SAAR")
CC_FLAGS = $(CC_FLAGS) /DSAAR
!else
!if ("$(BOARD_TYPE)" == "B0")
CC_FLAGS = $(CC_FLAGS) /DB0
!endif
!endif
!endif
!endif

!endif


#Platform Object Definitions
!if ("$(PLATFORM)" == "MHP" )
USBOBJS = UsbDownload.o \
      UsbDriver.o \
      xllp_udc.o \
!endif

!if ("$(PLATFORM)" == "MHL")
USBOBJS = UsbDownload.o \
      UsbDriver.o \
      xllp_udc.o \
!endif

!if ("$(PLATFORM)" == "MHLV")
USBOBJS = U2DDriver.o \
      U2Download.o \
      xllp_u2d.o \
      xllp_u2d_dma.o \
!endif

!if ("$(PLATFORM)" == "TAVOR")
USBOBJS = U2DDriver.o \
      U2Download.o \
      xllp_u2d.o \
      xllp_u2d_dma.o \
      UsbDownload.o \
      UsbDriver.o \
      xllp_udc.o \
!endif

DOWNLOADOBJS = ProtocolManager.o \
      UartDownload.o \
      uart.o \
      usb_descriptors.o \
      $(USBOBJS)

!if $(MSYS)
M_SYS_OBJS = boot.o \
             msys_interface.o \
             msys_dkb_interface.o \
             doch_api.o \
             tffs_api.o \
             doch_ata.o \
             flsystem.o \
             flmalloc.o \
             docdrv.o \
             defs.o \
             dochstub.o \
             geometry.o \
             flcustom.o \
             formatdata.o
!else
M_SYS_OBJS = 
!endif

!if $(ONENAND)
ONENANDOBJS = ONLD.o \
              OAM.o \
              ONAND_OBM_interface.o
!else
ONENANDOBJS =
!endif

DFCOBJS = xllp_dfc.o \
      xllp_dfc_support.o

MAINOBJS = OBM.o \
           Interrupts.o

FLASHOBJS = flash.o \
	    obm_flash.o

MISCOBJS = misc.o


!if ("$(PLATFORM)" == "TAVOR")
I2COBJS = i2c.o
!endif


PLATFORMOBJS = PlatformConfig.o \
			platform_obm.o \
!if ("$(PLATFORM)" == "TAVOR")
			pinmux.o
!endif


JTAGOBJS = iJtag.o


DMAOBJS = xllp_dmac.o


OBJ = OBM_Startup.o \
      mini_xlli_lowlev_init.o \
      ddr_init.o \
      iJtag.o	\
      $(DOWNLOADOBJS) \
      $(DFCOBJS) \
      $(MAINOBJS) \
      $(FLASHOBJS) \
      $(MISCOBJS) \
      $(DMAOBJS) \
      $(PLATFORMOBJS) \
      $(M_SYS_OBJS) \
      $(ONENANDOBJS) \
!if ("$(PLATFORM)" == "TAVOR")
      $(I2COBJS) \
	  PPSet.o 
!endif





#Link List for Platforms

!if ("$(PLATFORM)" == "MHP" )
USBLINK = "$(BASE)\$(PLATFORM)\$(OUTDIR)\usb_descriptors.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\UsbDownload.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\UsbDriver.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\xllp_udc.o" \
!endif

!if ("$(PLATFORM)" == "MHL")
USBLINK = "$(BASE)\$(PLATFORM)\$(OUTDIR)\usb_descriptors.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\UsbDownload.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\UsbDriver.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\xllp_udc.o" \
!endif

!if ("$(PLATFORM)" == "MHLV")
USBLINK = "$(BASE)\$(PLATFORM)\$(OUTDIR)\usb_descriptors.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\U2Download.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\U2DDriver.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\xllp_u2d_dma.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\xllp_u2d.o" \
!endif

!if ("$(PLATFORM)" == "TAVOR")
USBLINK = "$(BASE)\$(PLATFORM)\$(OUTDIR)\usb_descriptors.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\U2Download.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\U2DDriver.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\xllp_u2d_dma.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\xllp_u2d.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\UsbDownload.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\UsbDriver.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\xllp_udc.o" \
!endif

!if $(ONENAND)
ONENANDOBJECTS = "$(BASE)\$(PLATFORM)\$(OUTDIR)\onld.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\oam.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\ONAND_OBM_interface.o"
!else
ONENANDOBJECTS =
!endif

!if $(MSYS)
MSYSOBJECTS = "$(BASE)\$(PLATFORM)\$(OUTDIR)\boot.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\msys_interface.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\msys_dkb_interface.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\doch_api.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\tffs_api.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\doch_ata.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\flsystem.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\flmalloc.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\docdrv.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\defs.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\dochstub.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\geometry.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\flcustom.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\formatdata.o" \
!else
MSYSOBJECTS = 
!endif

#Rules

ALL: $(OBJ)
	$(Linker) -remove -debug -listing="$(OUTPUT_NAME).map" -output "$(OUTPUT_NAME).elf"  \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\OBM_StartUp.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\ddr_init.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\mini_xlli_lowlev_init.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\flash.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\obm_flash.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\misc.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\obm.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\Interrupts.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\PlatformConfig.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\platform_obm.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\ProtocolManager.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\UartDownload.o" \
	 $(USBLINK) \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\uart.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\xllp_dmac.o" \
    "$(BASE)\$(PLATFORM)\$(OUTDIR)\xllp_dfc.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\xllp_dfc_support.o" \
    $(ONENANDOBJECTS) \
	$(MSYSOBJECTS) \
!if ("$(PLATFORM)" == "TAVOR")
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\pinmux.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\i2c.o" \
	"$(BASE)\$(PLATFORM)\$(OUTDIR)\PPSet.o" \
        "c:\views\tavor_obm_D2D2_WA\iJtag.o" \
!endif
      "$(SDT)\intelxsc\lib\x0__ac30.a" -bf="$(BASE)\Build\default.bld" /Init DATA,BSS
      $(elf2bin)  -bin -map CODE=0x0 -keeponly CODE "$(OUTPUT_NAME).elf" "$(OUTPUT_NAME).bin"
      $(Symbol_Converter)  -hx "$(OUTPUT_NAME).elf"

OBM_StartUp.o: $(BASE)\STARTUP\OBM_StartUp.s
	@$(Assembler)  -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\OBM_StartUp.o"  "$(BASE)\STARTUP\OBM_StartUp.s"  -mcpu 3 -arm -PD "$(OS_BUILD)" -PD "USE_NDT_INIT SETA 1" -g /I "$(BASE)\$(PLATFORM)" /I "$(BASE)\$(PLATFORM)\DDR" /I "$(BASE)\StartUp" -list "$(BASE)\$(PLATFORM)\$(OUTDIR)\OBM_StartUp".lis

ddr_init.o: $(BASE)\$(PLATFORM)\DDR\ddr_init.s
	@$(Assembler) -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\ddr_init.o" "$(BASE)\$(PLATFORM)\DDR\ddr_init.s" -mcpu 3 -arm -PD "USE_NDT_INIT SETA 1" -g /I "$(BASE)\$(PLATFORM)" /I "$(BASE)\$(PLATFORM)\DDR" -list "$(BASE)\$(PLATFORM)\$(OUTDIR)\ddr_init".lis

mini_xlli_lowlev_init.o: $(BASE)\$(PLATFORM)\DDR\mini_xlli_lowlev_init.s
	@$(Assembler)  -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\mini_xlli_lowlev_init.o"  "$(BASE)\$(PLATFORM)\DDR\mini_xlli_lowlev_init.s"  -mcpu 3 -arm -PD "$(SDRAM_SIZE)" -PD "USE_NDT_INIT SETA 1" -g /I "$(BASE)\$(PLATFORM)" /I "$(BASE)\StartUp" /I "$(BASE)\$(PLATFORM)\DDR" -list "$(BASE)\$(PLATFORM)\$(OUTDIR)\mini_xlli_lowlev_init".lis

$(DOWNLOADOBJS): "$(BASE)\Download\$*.c"
	@$(C_Compiler) $(CC_FLAGS) $(INCLUDES) -c "$(BASE)\Download\$*.c" -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\$@"

$(MAINOBJS): "$(BASE)\MainProgram\$*.c"
	@$(C_Compiler) $(CC_FLAGS) $(INCLUDES) -c "$(BASE)\MainProgram\$*.c" -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\$@"

$(FLASHOBJS): "$(BASE)\Flash\$*.c"
	@$(C_Compiler) $(CC_FLAGS) $(INCLUDES) -c "$(BASE)\flash\$*.c" -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\$@"

$(MISCOBJS): "$(BASE)\Misc\$*.c"
	@$(C_Compiler) $(CC_FLAGS) $(INCLUDES) -c "$(BASE)\Misc\$*.c" -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\$@"

$(PLATFORMOBJS): "$(BASE)\$(PLATFORM)\$*.c"
	@$(C_Compiler) $(CC_FLAGS) $(INCLUDES) -c "$(BASE)\$(PLATFORM)\$*.c" -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\$@"

$(DMAOBJS): "$(BASE)\DMA\$*.c"
	@$(C_Compiler) $(CC_FLAGS) $(INCLUDES) -c "$(BASE)\DMA\$*.c" -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\$@"

$(DFCOBJS): "$(BASE)\Flash\DFC\$*.c"
	@$(C_Compiler) $(CC_FLAGS) $(INCLUDES) -c "$(BASE)\Flash\DFC\$*.c" -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\$@"

!if $(MSYS)
$(M_SYS_OBJS): "$(BASE)\Flash\M-SYS\$*.c"
	@$(C_Compiler) $(CC_FLAGS) $(INCLUDES) -c "$(BASE)\Flash\M-SYS\$*.c" -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\$@"
!endif

!if $(ONENAND)
$(ONENANDOBJS): "$(BASE)\Flash\OneNAND\$*.c"
        @$(C_Compiler) $(CC_FLAGS) $(INCLUDES) -c "$(BASE)\Flash\OneNAND\$*.c" -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\$@"
!endif

$(JTAGOBJS): "C:\views\tavor_obm_D2D2_WA\iJtag.c"
        @$(C_Compiler) $(CC_FLAGS) $(INCLUDES) -c "C:\views\tavor_obm_D2D2_WA\iJtag.c" -o "C:\views\tavor_obm_D2D2_WA\iJtag.o"

!if ("$(PLATFORM)" == "TAVOR")
$(I2COBJS): "$(BASE)\$(PLATFORM)\I2C\$*.c"
	@$(C_Compiler) $(CC_FLAGS) $(INCLUDES) -c "$(BASE)\$(PLATFORM)\I2C\$*.c" -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\$@"

PPSet.o: $(BASE)\$(PLATFORM)\DDR\PPSet.s
	@$(Assembler) -o "$(BASE)\$(PLATFORM)\$(OUTDIR)\PPSet.o" "$(BASE)\$(PLATFORM)\DDR\PPSet.s" -mcpu 3 -arm -PD "USE_NDT_INIT SETA 1" -g /I "$(BASE)\$(PLATFORM)" /I "$(BASE)\$(PLATFORM)\DDR" -list "$(BASE)\$(PLATFORM)\$(OUTDIR)\PPSet".lis
!endif


clean :
	-$(RM) $(BASE)\$(PLATFORM)\debug\*.*
	-$(RM) $(BASE)\$(PLATFORM)\release\*.*
	-$(RM) /S $(BASE)\*.scc
	-$(RM) /S $(BASE)\*.bak
