/******************************************************************************
**	(C) Copyright 2007 Marvell International Ltd. 
**	All Rights Reserved
******************************************************************************/

/******************************************************************************
**
** INTEL CONFIDENTIAL
** Copyright 2003-2004 Intel Corporation All Rights Reserved.
**
** The source code contained or described herein and all documents
** related to the source code (Material) are owned by Intel Corporation
** or its suppliers or licensors.  Title to the Material remains with
** Intel Corporation or its suppliers and licensors. The Material contains
** trade secrets and proprietary and confidential information of Intel
** or its suppliers and licensors. The Material is protected by worldwide
** copyright and trade secret laws and treaty provisions. No part of the
** Material may be used, copied, reproduced, modified, published, uploaded,
** posted, transmitted, distributed, or disclosed in any way without Intel is
** prior express written permission.
**
** No license under any patent, copyright, trade secret or other intellectual
** property right is granted to or conferred upon you by disclosure or
** delivery of the Materials, either expressly, by implication, inducement,
** estoppel or otherwise. Any license under such intellectual property rights
** must be express and approved by Intel in writing.
**
**  FILENAME:   DSVL.h
**
**  PURPOSE:    DSVL or IPP Library functions
**
******************************************************************************/
#ifndef __DSVL_H__
#define __DSVL_H__

#include "wtmfastsignatureverification.h"
// From Libraries
// WTM - Security H/W

// This enum is used to select enabling/disabling
// of the Caddo Unit
typedef enum
{
	DISABLE_CADDO = 0,
	ENABLE_CADDO  = 1
}CaddoEnable_T;
  
/********************************************************************************
************************* List of PI's provided by DSVL *******************************
***************************************************************************************/
extern int EnableDisableCaddo(CaddoEnable_T CaddoState);
extern int WtmReset (unsigned int selftest);
extern int WTMFSV (pFastSignatureVerify pFastSignIO);
extern int WtmPlatform_Config (unsigned int DataValue, unsigned int *pOutput, unsigned int, unsigned int, unsigned int );
extern int WtmPlatform_Bind (unsigned int *OEMKeyDataSrcAddr, int KeyLength, unsigned int *HashValue, unsigned int, unsigned int, unsigned int);


#endif


