/******************************************************************************
**	(C) Copyright 2007 Marvell International Ltd.
**	All Rights Reserved
******************************************************************************/

/******************************************************************************
**
**  COPYRIGHT (C) 2006 Intel Corporation.
**
**  This software as well as the software described in it is furnished under
**  license and may only be used or copied in accordance with the terms of the
**  license. The information in this file is furnished for informational use
**  only, is subject to change without notice, and should not be construed as
**  a commitment by Intel Corporation. Intel Corporation assumes no
**  responsibility or liability for any errors or inaccuracies that may appear
**  in this document or any software that may be provided in association with
**  this document.
**  Except as permitted by such license, no part of this document may be
**  reproduced, stored in a retrieval system, or transmitted in any form or by
**  any means without the express written consent of Intel Corporation.
**
**  FILENAME:       CI2Driver.c
**
**  PURPOSE:        This files contains the BootROM specific functions for
**                  ChipIdea 13611-a USB 2.0 OTG Device controller
**
**  LAST MODIFIED:
**
******************************************************************************/

/*
*******************************************************************************
*   HEADER FILES
*******************************************************************************
*/

#include "interrupts.h"
#include "misc.h"
#include "errors.h"
#include "xllp_ciu2d.h"


extern const XLLP_U2D_EP_CONFIG_TABLE_T defaultU2DEndpointConfigTable[];
extern void ClearPortInterruptFlag();

extern const    XLLP_U2D_EP_T             usbTransmitEp;
extern const    XLLP_U2D_EP_T             usbReceiveEp;

//---------------------------------------------------------------
// BootRomCI2HWShutdown
//
//
//---------------------------------------------------------------
XLLP_UINT32_T BootRomCI2HWShutdown (void)
{
    XLLP_UINT32_T status = FALSE;

    // Disable the CI2 interrupt at the SOC CPU
    //-----------------------------------------
    DisablePeripheralIRQInterrupt(USB0_OTG_INT);

    //Shut down the CI2 peripheral
    //----------------------------
    status = xllpCI2HWShutdown();

    return status;
}

//---------------------------------------------------------------
//  BootRomCI2SWInit()
//      Get entier driver S/W and periperhal H/W up
//
//---------------------------------------------------------------
XLLP_UINT32_T BootRomCI2SWInit(void (*pCpuCI2IntEnable)(void), void (*pPlatformReadyFunc)(void), UINT32 optionFlags )
{
   XLLP_UINT32_T status;

   status = xllpCI2SWInit ((P_XLLP_U2D_EP_CONFIG_TABLE_T)defaultU2DEndpointConfigTable, pCpuCI2IntEnable, pPlatformReadyFunc, optionFlags);
   return status;
}

