/******************************************************************************
**	(C)Copyright Marvell. All Rights Reserved. 2007 
**
**  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MARVELL.
**	The copyright notice above does not evidence any actual or intended  
**  publication of such source code.	
**
**  This Module contains Proprietary Information of Marvell and should be treated 
**  as Confidential.
**	  
**  The information in this file is provided for the exclusive use of the licensees 
**  of Marvell.	
**	Such users have the right to use, modify, and incorporate this code into products 
**  for purposes authorized by the license agreement provided they include this notice 
**  and the associated copyright notice with any such product. 
**  The information in this file is provided "AS IS" without warranty.
**
**  FILENAME: OneNAND_Cmd.h
**
**  PURPOSE:  The driver for the One NAND device.
**
******************************************************************************/
#ifndef __ONENAND_CMD_H__
#define __ONENAND_CMD_H__

#include "typedef.h"
#include "flash.h"
#include "OneNAND_Driver.h"

UINT_T LoadSector(UINT_T FlashOffset, UINT_T buffer, UINT_T size, FlashBootType_T fbt, P_FlashProperties_T pFlashProp);
UINT_T LoadSpareSector(void);
UINT_T ProgramSector(UINT_T address, UINT_T buffer, UINT_T size, FlashBootType_T fbt, P_FlashProperties_T pFlashProp);
UINT_T ProgramSpareSector(void);
UINT_T CopyBackProgram(void);
UINT_T UnlockNANDArray(void);
UINT_T LockNANDArray(void);
UINT_T LockTightNANDArray(void);
UINT_T EraseVerifyRead(void);
UINT_T BlockErase( UINT32 blockNumber);
UINT_T MultiBlockErase(void);
UINT_T EraseSuspend(void);
UINT_T EraseResume(void);
UINT_T ResetNANDCore(void);
UINT_T ResetOneNAND(void);
UINT_T OTPAccess(void);
UINT32 ComputeDivisorShiftFromPowerOf2( UINT32 power);

#endif

