/******************************************************************************
**
**  COPYRIGHT (C) 2005 Intel Corporation.
**
**  This software as well as the software described in it is furnished under
**  license and may only be used or copied in accordance with the terms of the
**  license. The information in this file is furnished for informational use
**  only, is subject to change without notice, and should not be construed as
**  a commitment by Intel Corporation. Intel Corporation assumes no
**  responsibility or liability for any errors or inaccuracies that may appear
**  in this document or any software that may be provided in association with
**  this document.
**  Except as permitted by such license, no part of this document may be
**  reproduced, stored in a retrieval system, or transmitted in any form or by
**  any means without the express written consent of Intel Corporation.
**
**  FILENAME:	micco_defs.h
**
**  PURPOSE: 	This file provides basic type definitions for A0 chip model
**
******************************************************************************/


#ifndef _MICCO_DEFS_H_
#define _MICCO_DEFS_H_

/***********************************************************************************************/
/******   The total votage is 2.65 volt ===>> so basically                          ************/
/******           each bit in the ADC_IN6 register represent a 0.010352 volt	    ************/
/***********************************************************************************************/
// SAAR_PV 3.2 is define as 0.5 volt in the ADC_IN6 register
//#define SAAR_PV_3_2_LOW_LIMIT         46              // 0.4762 V
//#define SAAR_PV_3_2_HIGH_LIMIT        52              // 0.5383 V

#define SAAR_PV_3_2_LOW_LIMIT         38              // 0.393376 V
#define SAAR_PV_3_2_HIGH_LIMIT        45              // 0.46584 V


// SAAR_PV 3.1 is define as 0.0 volt in the ADC_IN6 register
#define SAAR_PV_3_1_LOW_LIMIT         00              // 0.0 V
#define SAAR_PV_3_1_HIGH_LIMIT        10              // 0.10352 V




// EVB2 for production is define as 0.55 volt in the ADC_IN6 register
#define EVB2_PRODUCTION_LOW_LIMIT         42              // 0.4347 V
#define EVB2_PRODUCTION_HIGH_LIMIT        68              // 0.72464 V










/***********************************************************************************************/

typedef enum
{
	MICCO_ADC6_DISABLE  	= 0,
	MICCO_ADC6_ENABLE  		= 1
} OBM_MICCO_ADC6;


#define MICCO_ADC_ENABLE_REF_VOLT_SUPPLY	0x10
#define MICCO_ADC_ENABLE_AUTO_MEASUREMENT	0x04

/***********************************************************************************************/






#endif // _MICCO_DEFS_H_
