@/******************************************************************************
@**	(C) Copyright 2007 Marvell International Ltd. 
@**	All Rights Reserved
@******************************************************************************/

@*********************************************************************************
@
@        COPYRIGHT (c) 2002 - 2004 Intel Corporation
@
@   The information in this file is furnished for informational use only,
@   is subject to change without notice, and should not be construed as
@   a commitment by Intel Corporation. Intel Corporation assumes no
@   responsibility or liability for any errors or inaccuracies that may appear
@   in this document or any software that may be provided in association with
@   this document.
@
@*********************************************************************************
@
@  FILENAME:       XXX_defs.inc (Platform specific addresses and
@                  default values for Monahan platforms bring up)
@
@  LAST MODIFIED:   21-July-2004
@
@******************************************************************************
@
@

@Define Processor variant for version information
 .ifdef PV
	.equ		   Processor,(0x545056B0)	@ TPV B0
 .else
	.equ		   Processor,(0x545650B0)	@ TV-P B0
 .endif

@ Stack location defines
@ for PV, we can move the stack to the base of ISRAM, as it is NOT locked
 .ifdef PV
			.equ		BV_SRAM,(0x5c000400) @
 .else
			.equ		BV_SRAM,(0x5c00B000) @
 .endif

		.equ		BV_SRAMSIZE,(0x00007c00) @ SRAM


@ The following are defines for pad register addresses

@ Tavor Pad Addresses
    .equ   ADDR_PAD_DF_nCS0_TAVOR,(0x40E1022C)
    .equ   ADDR_PAD_DF_nCS1_TAVOR,(0x40E10230)

       .equ   ADDR_PAD_nLUA_TAVOR,(0x40e10254)
       .equ   ADDR_PAD_nLLA_TAVOR,(0x40e10258)
     .equ   ADDR_PAD_DF_CLE_TAVOR,(0x40e1020C)
 .equ ADDR_PAD_DF_nADV1_ALE_TAVOR,(0x40e10218)
 .equ ADDR_PAD_DF_nADV2_ALE_TAVOR,(0x40e10224)
     .equ   ADDR_PAD_ND_nWE_TAVOR,(0x40e10234)
     .equ   ADDR_PAD_ND_nRE_TAVOR,(0x40e10238)
  .equ   ADDR_PAD_DF_SCLK_E_TAVOR,(0x40e10214)

@Next two Addresses needed for SV board to work
		  .equ	ADDR_PAD_nBE0_TAVOR,(0x40E1021C)
		  .equ	ADDR_PAD_nBE1_TAVOR,(0x40E10220)

     .equ   ADDR_PAD_DF_IO0_TAVOR,(0x40e1023C)
     .equ   ADDR_PAD_DF_IO1_TAVOR,(0x40e10240)
     .equ   ADDR_PAD_DF_IO2_TAVOR,(0x40e10244)
     .equ   ADDR_PAD_DF_IO3_TAVOR,(0x40e10248)
     .equ   ADDR_PAD_DF_IO4_TAVOR,(0x40e10264)
     .equ   ADDR_PAD_DF_IO5_TAVOR,(0x40e10268)
     .equ   ADDR_PAD_DF_IO6_TAVOR,(0x40e1026C)
     .equ   ADDR_PAD_DF_IO7_TAVOR,(0x40e10270)
     .equ   ADDR_PAD_DF_IO8_TAVOR,(0x40e10274)
     .equ   ADDR_PAD_DF_IO9_TAVOR,(0x40e10278)
    .equ   ADDR_PAD_DF_IO10_TAVOR,(0x40e1027C)
    .equ   ADDR_PAD_DF_IO11_TAVOR,(0x40e10280)
    .equ   ADDR_PAD_DF_IO12_TAVOR,(0x40e10284)
    .equ   ADDR_PAD_DF_IO13_TAVOR,(0x40e10288)
    .equ   ADDR_PAD_DF_IO14_TAVOR,(0x40e1028C)
    .equ   ADDR_PAD_DF_IO15_TAVOR,(0x40e10290)

    		  .equ   ADDR_SMEMC_MSC0,(0x4A000008)
    		  .equ   ADDR_SMEMC_MSC1,(0x4A00000C)
     .equ   ADDR_SMEMC_CSADRCFG_0,(0x4A000080)
     .equ   ADDR_SMEMC_CSADRCFG_1,(0x4A000084)
     .equ   ADDR_SMEMC_CSADRCFG_2,(0x4A000088)
     .equ   ADDR_SMEMC_CSADRCFG_3,(0x4A00008C)
     .equ   ADDR_SMEMC_CSMSADRCFG,(0x4A0000A0) @ Master Address Configuration register
               .equ   ADDR_MDCNFG,(0x48100000) @ SDRAM configuration register
                 .equ   ADDR_EMPI,(0x48100090) @ EMPI register address
                 .equ   ADDR_SGSR,(0x4600FE08) @ Boot address map bit. 1 => external ; 0 => boot ROM.
      .equ   ADDR_SMEMC_MEMCLKCFG,(0x4A000068) @ Clock Configuration Register
		  .equ   ADDR_CHIP_BOOTTYPE,(0x40F50208)

@; The following are values to write for each of the pad registers
 .ifdef PV
        .equ   VAL_PAD_nLUA_TAVOR,(0x00001101)
        .equ   VAL_PAD_nLLA_TAVOR,(0x00001101)
      .equ   VAL_PAD_DF_CLE_TAVOR,(0x00001001)
 .equ   VAL_PAD_DF_nADV1_ALE_TAVOR,(0x00001001)
 .equ   VAL_PAD_DF_nADV2_ALE_TAVOR,(0x00001003)
   .equ   VAL_PAD_DF_SCLK_E_TAVOR,(0x00001001)
      .equ   VAL_PAD_DF_IO0_TAVOR,(0x00001001)
      .equ   VAL_PAD_DF_IO1_TAVOR,(0x00001001)
      .equ   VAL_PAD_DF_IO2_TAVOR,(0x00001001)
      .equ   VAL_PAD_DF_IO3_TAVOR,(0x00001001)
      .equ   VAL_PAD_DF_IO4_TAVOR,(0x00001001)
      .equ   VAL_PAD_DF_IO5_TAVOR,(0x00001001)
      .equ   VAL_PAD_DF_IO6_TAVOR,(0x00001001)
      .equ   VAL_PAD_DF_IO7_TAVOR,(0x00001001)
      .equ   VAL_PAD_DF_IO8_TAVOR,(0x00001041)
      .equ   VAL_PAD_DF_IO9_TAVOR,(0x00001041)
     .equ   VAL_PAD_DF_IO10_TAVOR,(0x00001041)
     .equ   VAL_PAD_DF_IO11_TAVOR,(0x00001041)
     .equ   VAL_PAD_DF_IO12_TAVOR,(0x00001041)
     .equ   VAL_PAD_DF_IO13_TAVOR,(0x00001041)
     .equ   VAL_PAD_DF_IO14_TAVOR,(0x00001041)
     .equ   VAL_PAD_DF_IO15_TAVOR,(0x00001041)
 .else
         .equ   VAL_PAD_nLUA_TAVOR,(0x00001901)
         .equ   VAL_PAD_nLLA_TAVOR,(0x00001901)
       .equ   VAL_PAD_DF_CLE_TAVOR,(0x00001801)
 .equ   VAL_PAD_DF_nADV1_ALE_TAVOR,(0x00001801)
 .equ   VAL_PAD_DF_nADV2_ALE_TAVOR,(0x00001801)
	     .equ   VAL_PAD_DF_nCS0_TAVOR,(0x00001803)
	     .equ   VAL_PAD_DF_nCS1_TAVOR,(0x00001803)
      .equ   VAL_PAD_ND_nWE_TAVOR,(0x00001801)
      .equ   VAL_PAD_ND_nRE_TAVOR,(0x00001801)
   .equ   VAL_PAD_DF_SCLK_E_TAVOR,(0x00001801)
      .equ   VAL_PAD_DF_IO0_TAVOR,(0x00001401)
      .equ   VAL_PAD_DF_IO1_TAVOR,(0x00001401)
      .equ   VAL_PAD_DF_IO2_TAVOR,(0x00001401)
      .equ   VAL_PAD_DF_IO3_TAVOR,(0x00001401)
      .equ   VAL_PAD_DF_IO4_TAVOR,(0x00001401)
      .equ   VAL_PAD_DF_IO5_TAVOR,(0x00001401)
      .equ   VAL_PAD_DF_IO6_TAVOR,(0x00001401)
      .equ   VAL_PAD_DF_IO7_TAVOR,(0x00001401)
      .equ   VAL_PAD_DF_IO8_TAVOR,(0x00001401)
      .equ   VAL_PAD_DF_IO9_TAVOR,(0x00001401)
     .equ   VAL_PAD_DF_IO10_TAVOR,(0x00001401)
     .equ   VAL_PAD_DF_IO11_TAVOR,(0x00001401)
     .equ   VAL_PAD_DF_IO12_TAVOR,(0x00001401)
     .equ   VAL_PAD_DF_IO13_TAVOR,(0x00001401)
     .equ   VAL_PAD_DF_IO14_TAVOR,(0x00001401)
     .equ   VAL_PAD_DF_IO15_TAVOR,(0x00001401)
 .endif
 .equ VAL_PAD_INPUT_RELEASE_TAVOR,(0x00000700)

@Next two values needed for SV board to work
		  .equ	VAL_PAD_nBE0_TAVOR,(0x00001801)
		  .equ	VAL_PAD_nBE1_TAVOR,(0x00001801)

@VAL_SMEMC_CSADRCFG_2      EQU   (0x00320919)
@VAL_SMEMC_CSADRCFG_2      EQU   (0x00320809)
@VAL_SMEMC_MSC1    		  	 EQU   (0x00001238)
@VAL_SMEMC_MSC1    		     EQU   (0x7FF87FF8)
    		     .equ   VAL_SMEMC_MSC1,(0x12381238)
       .equ   VAL_SMEMC_CSADRCFG_2,(0x00320809)
		     .equ   VAL_CHIP_BOOTTAVOR,(0x00080000)


@Clock Control Unit definitions
     	.equ   ADDR_CCU_D0CKEN_A,(0x4134000C)
     	.equ   ADDR_CCU_D0CKEN_B,(0x41340010)
     	  .equ   VAL_CCU_D0CKEN_A,(0xC0780F10)
     	  .equ   VAL_CCU_D0CKEN_B,(0x000000C0)

		  .equ 	ADDR_ACCR,(0x41340000)
		  .equ 	ADDR_ASCR,(0x41340004)
		  .equ	  VAL_HSIO,(0x00008000) @ set HSIO to 208 (0b10)

@ RTC
@ TO DO, VERIFY ADDRESS....
@ TO DO....
			  .equ 	PMU_PSPR_ADDR,(0x40F50008)
@TO DO.....



@Define Tavor chip ID
@--------------------------------
 .equ		ProductionIdRegAddr,(0x4600FF80)

          .equ		TAVOR_P_A0,(0x00002000)
          .equ		TAVOR_P_B0,(0x00002020)
          .equ		TAVOR_P_B1,(0x00002060)
          .equ		TAVOR_P_B2,(0x00002061)
     .equ		TAVOR_PV_DIS_Z0,(0x00002200)
     .equ		TAVOR_PV_DIS_A0,(0x00002220)
     .equ		TAVOR_PV_DIS_B0,(0x00002240)
     .equ		TAVOR_PV_DIS_B1,(0x00002241)
     .equ		TAVOR_PV_DIS_C0,(0x00002280)
    .equ		TAVOR_PV2_DIS_Z0,(0x00002400)
    .equ		TAVOR_PV2_DIS_A0,(0x00002420)
    .equ		TAVOR_PV2_DIS_B0,(0x00002440)
		.equ		TAVOR_PV2_DIS_C0,(0x00002480)




@Define Tavor PV2 U_YA_AIBI register
@----------------------------------------
     .equ		U_YA_AIBI_REG_ADDR,(0x40E101D8)

     .equ		U_YA_AIBI_CAPTURE_REG_VALUE,(0x1)
           .equ		U_YA_AIBI_COMM_PLL_ON,(0x2)


			.equ       	SET_COMM_PLL_TO_ON,(U_YA_AIBI_CAPTURE_REG_VALUE | U_YA_AIBI_COMM_PLL_ON)



      
