/******************************************************************************
**
**  COPYRIGHT (C) 2005 Intel Corporation.
**
**  This software as well as the software described in it is furnished under
**  license and may only be used or copied in accordance with the terms of the
**  license. The information in this file is furnished for informational use
**  only, is subject to change without notice, and should not be construed as
**  a commitment by Intel Corporation. Intel Corporation assumes no
**  responsibility or liability for any errors or inaccuracies that may appear
**  in this document or any software that may be provided in association with
**  this document.
**  Except as permitted by such license, no part of this document may be
**  reproduced, stored in a retrieval system, or transmitted in any form or by
**  any means without the express written consent of Intel Corporation.
**
**  FILENAME:	reliable_data.h
**
**  PURPOSE: 	This file provides basic type definitions for A0 chip model
**
******************************************************************************/
#ifndef _RELIABLE_DATA_H_
#define _RELIABLE_DATA_H_


#if (TAVOR_BOERNE)

/***************************************************************************************************/
/***************************************************************************************************/

typedef enum
{
   RD_FORMAT_VER    = 0x00001306,
   IMEI_TYPE 		= 0xCAFE0010,
   CALIB_TYPE 		= 0xCAFE0020,
   VALID_BUF_STMP 	= 0xCAFECAFE,
   END_BUF_STMP 	= 0xDADADADA
} RELIABLE_TYPES;



typedef struct
{
   	unsigned long 		validBufferStamp;
   	unsigned long 		bufCheckSum;
   	unsigned long 		version;
   	unsigned long 		reserve;
   	unsigned long 		reserve1;
} FLASH_BUFFER_HEADER;



//struct size should be aligned to UINT32

typedef struct
{
   	RELIABLE_TYPES 		entryType;
   	unsigned long 		entrySize;
   	unsigned char 	    fileName[128];
   	unsigned long 	   *pFileToWrite;
} FLASH_ENTRY_HEADER;





typedef struct
{
	FLASH_BUFFER_HEADER    	header;
    FLASH_ENTRY_HEADER    	entry;
} RELIABLE_DATA;








/***************************************************************************************************/
/***************************************************************************************************/

#endif   // TAVOR_BOERNE


#endif   // _RELIABLE_DATA_H_
