/******************************************************************************

**	(C) Copyright 2007 Borqs  Ltd.

**	All Rights Reserved
******************************************************************************/

#include "protocolmanager.h"
#include "flash.h"
#include "tim.h"
#include "misc.h"

#include "obm_pxa930.h"
#include "obm_pxa930_gpio.h"

#if TRUSTED
#include "obm_security.h"
#endif

#if MDOC_CODE
#include "msys.h"
#endif

#if ONENAND_CODE
#ifndef DDR_WORKAROUND
//#include "onenand_obm_interface.h"
#endif
#endif
UINT8_T FlashKeyChk( void )
#if 0
{
	volatile unsigned int *GPLR0 = (volatile unsigned int *)0x40e00000;
	volatile unsigned int *GPDR0 = (volatile unsigned int *)0x40e0000c;
	volatile unsigned int *GSDR0 = (volatile unsigned int *)0x40e00400;
	volatile unsigned int *GCDR0 = (volatile unsigned int *)0x40e00420;
	volatile unsigned int *GPCR0 = (volatile unsigned int *)0x40e00024;

       volatile unsigned int *MFPR_gpio4 = (volatile unsigned int *) (0x40e102e4) ;

	unsigned int 		   mfpr_gpio4_val;
	unsigned int 		   GPDR0_val;
	UINT8_T 		 	   Keypress = FALSE ;


	// Save the value of GPDR0 and MFPR-GPIO0
	GPDR0_val = *GPDR0;
	mfpr_gpio4_val = *MFPR_gpio4;

	AddMessage((UINT8_T*) ("\0"));
	AddMessage((UINT8_T*) ("*** OBM Checking Flash Key .... ***\0"));
	

	// Set GPIO 4 direction to be -- input
	*GCDR0 = 0x10;

	// GPIO 4 - set to disable pull
	*MFPR_gpio4 &= ~(0xe000);
	// GPIO4 - enable pull & set pull down
	*MFPR_gpio4  |= (0xa000);

       Delay_ms(2) ; // delay 2ms wait for pull down stable .

	// check if value of GPIO0 is HIGH , if HIGH - "*" key is pressed... go to update SW mode
	if ( (*GPLR0 & 0x10) == 0x10 )
	{
		Keypress = TRUE;
		AddMessage((UINT8_T*) ("*** Flash Key pressed ...\0"));
	}
	else
	{  
	       AddMessage((UINT8_T*) ("*** No Flash Key pressed ...\0"));
	}
	AddMessage((UINT8_T*) ("\0"));	
	 //restore reset values of registers
	*MFPR_gpio4 = mfpr_gpio4_val;
	*GPDR0 = GPDR0_val;

	return Keypress ;
}
#endif
#if DDR_WORKAROUND
{
    unsigned int 		   mfpr_val, mfpr_val_sec;
    unsigned int 		   pre_GPDR, pre_GPDR_sec;
    unsigned int 		   tmp, tmp_sec;
    UINT8_T 		 	   Keypress = FALSE ;

    pre_GPDR_sec = gpio_direction_reg_get(MFP_PIN_GPIO43);

    mfpr_val_sec = pxa3xx_mfp_read(MFP_PIN_GPIO43);   


    AddMessage((UINT8_T*) ("\0"));
	AddMessage((UINT8_T*) ("*** OBM Checking Flash Key .... ***\0"));

    gpio_direction_input(MFP_PIN_GPIO43); 

    //pxa3xx_mfp_config( (MFP_PIN_GPIO4 << 16) | | MFP_AF0 , 1);
    tmp  = mfpr_val & ~0xe000;
    tmp |= 0xa000;
    tmp_sec  = mfpr_val_sec & ~0xe000;
    tmp_sec |= 0xa000;

    pxa3xx_mfp_write(MFP_PIN_GPIO43,tmp_sec);
    Delay_ms(2) ; // delay 2ms wait for pull down stable .

    if(!gpio_get(MFP_PIN_GPIO43))
    {  
        Keypress = TRUE;
    }
    //restore reset values of registers

    pxa3xx_mfp_write(MFP_PIN_GPIO43, mfpr_val_sec);
    gpio_direction_reg_set(MFP_PIN_GPIO43, pre_GPDR_sec);

    return Keypress;
}
#else
{
    unsigned int 		   mfpr_val;
    unsigned int 		   pre_GPDR;
    unsigned int 		   tmp;
    UINT8_T 		 	   Keypress = FALSE ;

    pre_GPDR = gpio_direction_reg_get(MFP_PIN_GPIO4);
    mfpr_val = pxa3xx_mfp_read(MFP_PIN_GPIO4);   

    AddMessage((UINT8_T*) ("\0"));
	AddMessage((UINT8_T*) ("*** OBM Checking Flash Key .... ***\0"));

    gpio_direction_input(MFP_PIN_GPIO4); 
    //pxa3xx_mfp_config( (MFP_PIN_GPIO4 << 16) | | MFP_AF0 , 1);
    tmp  = mfpr_val & ~0xe000;
    tmp |= 0xa000;
    pxa3xx_mfp_write(MFP_PIN_GPIO4,tmp);
    Delay_ms(2) ; // delay 2ms wait for pull down stable .
    if(gpio_get(MFP_PIN_GPIO4))
    {
		Keypress = TRUE;
		AddMessage((UINT8_T*) ("*** Flash Key pressed ...\0"));    }else
        {  
            AddMessage((UINT8_T*) ("*** No Flash Key pressed ...\0"));
        }
    //restore reset values of registers
    pxa3xx_mfp_write(MFP_PIN_GPIO4, mfpr_val);
    gpio_direction_reg_set(MFP_PIN_GPIO4, pre_GPDR);
    return Keypress;
}
#endif
/************************************************************************************/
