#include "obm_pxa930_gpio.h"

/*
int pxa_gpio_mode(int gpio_mode)
{
	//unsigned long flags;
	int gpio = gpio_mode & GPIO_MD_MASK_NR;
	int fn = (gpio_mode & GPIO_MD_MASK_FN) >> 8;
	int gafr;

	//if (gpio > pxa_last_gpio)
	//	return -EINVAL;

	//local_irq_save(flags);
	if (gpio_mode & GPIO_DFLT_LOW)
		GPCR(gpio) = GPIO_bit(gpio);
	else if (gpio_mode & GPIO_DFLT_HIGH)
		GPSR(gpio) = GPIO_bit(gpio);
	if (gpio_mode & GPIO_MD_MASK_DIR)
		GPDR(gpio) |= GPIO_bit(gpio);
	else
		GPDR(gpio) &= ~GPIO_bit(gpio);
    //gliethttp usede for pxa27x cpu
	//gafr = GAFR(gpio) & ~(0x3 << (((gpio) & 0xf)*2));
	//GAFR(gpio) = gafr |  (fn  << (((gpio) & 0xf)*2));
	//local_irq_restore(flags);

	return 0;
}
*/
static int pxa_gpio2regbase(unsigned gpio, void __iomem **pregbase)
{
    struct regbase_offset
    {
        void __iomem *regbase;
        u32 offset;
    };
#ifdef SAAR_PV
    static struct regbase_offset ro_gliethttp[6]=
    {
        {GPIO0_BASE, 0},
        {GPIO1_BASE,32},
        {GPIO2_BASE,64},
        {GPIO3_BASE,96},
        {GPIO4_BASE,128}, 
		{GPIO5_BASE,160}
    };
#else
    static struct regbase_offset ro_gliethttp[4]=
    {
        {GPIO0_BASE, 0},
        {GPIO1_BASE,32},
        {GPIO2_BASE,64},
        {GPIO3_BASE,96}
    };
#endif
    
    /*
    u32 offset;
    
    if(gpio < 32)
    {
        *pregbase = GPIO0_BASE;
        offset = gpio-0;
    }else if(gpio < 64)
          {
              *pregbase = GPIO1_BASE;
              offset = gpio - 32;
          }
     else if(gpio < 96)
          {
              *pregbase = GPIO3_BASE;
              offset = gpio - 64;
          }
     else if(gpio < 128)
          {
              *pregbase = GPIO3_BASE;
              offset = gpio - 96;
          }
     else offset = 0xff;

     return offset;
     */
    char base = gpio >> 5;//gpio / 32;
#ifdef SAAR_PV
    if(base > 5)return -1;
#else
    if(base > 3)return -1;
#endif
    *pregbase = ro_gliethttp[base].regbase;
    return (gpio - ro_gliethttp[base].offset);
}
inline static int pxa_gpio_direction_input(unsigned gpio)
{
	//unsigned long flags;
	u32 value;
	//struct pxa_gpio_chip *pxa;
    void __iomem *regbase;
    int offset;
    
    offset = pxa_gpio2regbase(gpio,&regbase);
	//pxa = container_of(chip, struct pxa_gpio_chip, chip);

	//local_irq_save(flags);
	value = __raw_readl(regbase + GPDR_OFFSET) & ~(1 << offset);
	__raw_writel(value, regbase + GPDR_OFFSET);
	//local_irq_restore(flags);

	return 0;
}

inline static int pxa_gpio_direction_output(unsigned gpio, int value)
{
	unsigned long        flags;
	u32                  tmp;
	u32                  mask;
    unsigned             offset;
    void __iomem         *regbase;

    offset = pxa_gpio2regbase(gpio,&regbase);
    mask   = 1 << offset;
	//struct pxa_gpio_chip *pxa;

	//pxa = container_of(chip, struct pxa_gpio_chip, chip);

	__raw_writel(mask, regbase + (value ? GPSR_OFFSET : GPCR_OFFSET));

	//local_irq_save(flags);
	tmp = __raw_readl(regbase + GPDR_OFFSET) | mask;
	__raw_writel(tmp, regbase + GPDR_OFFSET);
	//local_irq_restore(flags);

	return 0;
}


static int pxa_gpio_get(unsigned gpio)
{
	u32                  mask;
    unsigned             offset;
    void __iomem         *regbase;

    offset = pxa_gpio2regbase(gpio,&regbase);
    mask = 1 << offset;
	//struct pxa_gpio_chip *pxa;

	//pxa = container_of(chip, struct pxa_gpio_chip, chip);
	return __raw_readl(regbase + GPLR_OFFSET) & mask;
    //return GPLR(gpio) & GPIO_bit(gpio); //gliethttp lnx2624pxa930/include/asm-arm/arch-pxa/gpio.h
}

static void pxa_gpio_set(unsigned gpio, int value)
{
    u32                  mask;
    unsigned             offset;
    void __iomem         *regbase;

    offset = pxa_gpio2regbase(gpio,&regbase);
    mask = 1 << offset;
	//struct pxa_gpio_chip *pxa;

	//pxa = container_of(chip, struct pxa_gpio_chip, chip);

	if (value)
		__raw_writel(mask, regbase + GPSR_OFFSET);
	else
		__raw_writel(mask, regbase + GPCR_OFFSET);
    
    /*
    //gliethttp lnx2624pxa930/include/asm-arm/arch-pxa/gpio.h
    if (value)
        GPSR(gpio) = GPIO_bit(gpio);
    else
        GPCR(gpio) = GPIO_bit(gpio);
    */
}

int gpio_direction_reg_get(unsigned gpio)
{
    unsigned             offset;
    void __iomem         *regbase;

    offset = pxa_gpio2regbase(gpio,&regbase);
    return __raw_readl(regbase + GPDR_OFFSET);
}

int gpio_direction_reg_set(unsigned gpio, int value)
{
    unsigned             offset;
    void __iomem         *regbase;

    offset = pxa_gpio2regbase(gpio,&regbase);
    __raw_writel(value, regbase + GPDR_OFFSET);
    return 0;
}

int gpio_direction_input(unsigned gpio)
{
    return pxa_gpio_direction_input(gpio);
}

int gpio_direction_output(unsigned gpio, int value)
{
    return pxa_gpio_direction_output(gpio,value);
}

int gpio_get(unsigned gpio)
{
    return pxa_gpio_get(gpio);
}

void gpio_set(unsigned gpio, int value)
{
    pxa_gpio_set(gpio,value);
}

