#include "obm_pxa_charger.h"

#define GPIO61_CHARGER_IN           MFP_CFG_X(GPIO61, AF0, DS02X, PULL_HIGH)
#define GPIO10_CHARGING_STATE       MFP_CFG_X(GPIO10, AF0, DS02X, PULL_HIGH)
#define GPIO11_CHARGE_CTR_EN1       MFP_CFG_X(GPIO11, AF0, DS02X, PULL_LOW)
#define GPIO62_CHARGE_CTR_EN2       MFP_CFG_X(GPIO64, AF0, DS02X, PULL_LOW)

#define CHARGE_CTR_EN1_IO   MFP_PIN_GPIO11
#define CHARGE_CTR_EN2_IO   MFP_PIN_GPIO64
#define CHARGER_IN_IRQ_IO   MFP_PIN_GPIO61

static mfp_cfg_t jades_mfp_cfg[] = {
    GPIO61_CHARGER_IN,
	GPIO10_CHARGING_STATE,
	GPIO11_CHARGE_CTR_EN1,
	GPIO62_CHARGE_CTR_EN2,
};
static int pxa_is_charger_online(void);
void pxa_charger_ini(void)
{
    pxa3xx_mfp_config(ARRAY_AND_SIZE(jades_mfp_cfg));

    //if(pxa_is_charger_online())
    pxa_charger_set_e1_e2(0x01);
    //else pxa_charger_set_e1_e2(0x11);
}

static int pxa_is_charger_online(void)
{
    unsigned char micco_status_b;
    micco_read( 0x06, &micco_status_b );
    if(micco_status_b & 0x1)
    {
        AddMessage("charger detected...");
        return 1;
    }
    else
    {
        AddMessage("charger not detected...");
         return 0;
    }
    //return (gpio_get(CHARGER_IN_IRQ_IO) ? 0 : 1);
}

void pxa_charger_set_e1_e2(char value)
{
    switch(value)
    {
        case 0x00:gpio_direction_output(CHARGE_CTR_EN1_IO, 0);gpio_direction_output(CHARGE_CTR_EN2_IO, 0);break;
        case 0x01:gpio_direction_output(CHARGE_CTR_EN1_IO, 0);gpio_direction_output(CHARGE_CTR_EN2_IO, 1);break;
        case 0x10:gpio_direction_output(CHARGE_CTR_EN1_IO, 1);gpio_direction_output(CHARGE_CTR_EN2_IO, 0);break;
        case 0x11:
        default  :gpio_direction_output(CHARGE_CTR_EN1_IO, 1);gpio_direction_output(CHARGE_CTR_EN2_IO, 1);break;
    }
}
