;/******************************************************************************
;**	(C) Copyright 2007 Marvell International Ltd. 
;**	All Rights Reserved
;******************************************************************************/

;*********************************************************************************
;
;        COPYRIGHT (c) 2002 - 2004 Intel Corporation
;
;   The information in this file is furnished for informational use only,
;   is subject to change without notice, and should not be construed as
;   a commitment by Intel Corporation. Intel Corporation assumes no
;   responsibility or liability for any errors or inaccuracies that may appear
;   in this document or any software that may be provided in association with
;   this document.
;
;*********************************************************************************
;
;  FILENAME:       XXX_defs.inc (Platform specific addresses and
;                  default values for Monahan platforms bring up)
;
;  LAST MODIFIED:   21-July-2004
;
;******************************************************************************
;
;

;Define Processor variant for version information
 IF :DEF: PV
Processor	EQU		   (0x545056B0)	; TPV B0
 ELSE
Processor	EQU		   (0x545650B0)	; TV-P B0
 ENDIF

; The following are defines for pad register addresses

; Tavor Pad Addresses
ADDR_PAD_DF_nCS0_TAVOR    EQU   (0x40E1022C)
ADDR_PAD_DF_nCS1_TAVOR    EQU   (0x40E10230)

ADDR_PAD_nLUA_TAVOR       EQU   (0x40e10254)
ADDR_PAD_nLLA_TAVOR       EQU   (0x40e10258)
ADDR_PAD_DF_CLE_TAVOR     EQU   (0x40e1020C)
ADDR_PAD_DF_nADV1_ALE_TAVOR EQU (0x40e10218)
ADDR_PAD_DF_nADV2_ALE_TAVOR EQU (0x40e10224)
ADDR_PAD_ND_nWE_TAVOR     EQU   (0x40e10234)
ADDR_PAD_ND_nRE_TAVOR     EQU   (0x40e10238)
ADDR_PAD_DF_SCLK_E_TAVOR  EQU   (0x40e10214)

;Next two Addresses needed for SV board to work
ADDR_PAD_nBE0_TAVOR		  EQU	(0x40E1021C)
ADDR_PAD_nBE1_TAVOR		  EQU	(0x40E10220)

ADDR_PAD_DF_IO0_TAVOR     EQU   (0x40e1023C)
ADDR_PAD_DF_IO1_TAVOR     EQU   (0x40e10240)
ADDR_PAD_DF_IO2_TAVOR     EQU   (0x40e10244)
ADDR_PAD_DF_IO3_TAVOR     EQU   (0x40e10248)
ADDR_PAD_DF_IO4_TAVOR     EQU   (0x40e10264)
ADDR_PAD_DF_IO5_TAVOR     EQU   (0x40e10268)
ADDR_PAD_DF_IO6_TAVOR     EQU   (0x40e1026C)
ADDR_PAD_DF_IO7_TAVOR     EQU   (0x40e10270)
ADDR_PAD_DF_IO8_TAVOR     EQU   (0x40e10274)
ADDR_PAD_DF_IO9_TAVOR     EQU   (0x40e10278)
ADDR_PAD_DF_IO10_TAVOR    EQU   (0x40e1027C)
ADDR_PAD_DF_IO11_TAVOR    EQU   (0x40e10280)
ADDR_PAD_DF_IO12_TAVOR    EQU   (0x40e10284)
ADDR_PAD_DF_IO13_TAVOR    EQU   (0x40e10288)
ADDR_PAD_DF_IO14_TAVOR    EQU   (0x40e1028C)
ADDR_PAD_DF_IO15_TAVOR    EQU   (0x40e10290)

ADDR_SMEMC_MSC0    		  EQU   (0x4A000008)
ADDR_SMEMC_MSC1    		  EQU   (0x4A00000C)
ADDR_SMEMC_CSADRCFG_0     EQU   (0x4A000080)
ADDR_SMEMC_CSADRCFG_1     EQU   (0x4A000084)
ADDR_SMEMC_CSADRCFG_2     EQU   (0x4A000088)
ADDR_SMEMC_CSADRCFG_3     EQU   (0x4A00008C)
ADDR_SMEMC_CSMSADRCFG     EQU   (0x4A0000A0) ; Master Address Configuration register
ADDR_MDCNFG               EQU   (0x48100000) ; SDRAM configuration register
ADDR_EMPI                 EQU   (0x48100090) ; EMPI register address
ADDR_SGSR                 EQU   (0x4600FE08) ; Boot address map bit. 1 => external ; 0 => boot ROM.
ADDR_SMEMC_MEMCLKCFG      EQU   (0x4A000068) ; Clock Configuration Register
ADDR_CHIP_BOOTTYPE		  EQU   (0x40F50208)

;; The following are values to write for each of the pad registers
 IF :DEF: PV
VAL_PAD_nLUA_TAVOR        EQU   (0x00001101)
VAL_PAD_nLLA_TAVOR        EQU   (0x00001101)
VAL_PAD_DF_CLE_TAVOR      EQU   (0x00001001)
VAL_PAD_DF_nADV1_ALE_TAVOR EQU   (0x00001001)
VAL_PAD_DF_nADV2_ALE_TAVOR EQU   (0x00001003)
VAL_PAD_DF_SCLK_E_TAVOR   EQU   (0x00001001)
VAL_PAD_DF_IO0_TAVOR      EQU   (0x00001001)
VAL_PAD_DF_IO1_TAVOR      EQU   (0x00001001)
VAL_PAD_DF_IO2_TAVOR      EQU   (0x00001001)
VAL_PAD_DF_IO3_TAVOR      EQU   (0x00001001)
VAL_PAD_DF_IO4_TAVOR      EQU   (0x00001001)
VAL_PAD_DF_IO5_TAVOR      EQU   (0x00001001)
VAL_PAD_DF_IO6_TAVOR      EQU   (0x00001001)
VAL_PAD_DF_IO7_TAVOR      EQU   (0x00001001)
VAL_PAD_DF_IO8_TAVOR      EQU   (0x00001041)
VAL_PAD_DF_IO9_TAVOR      EQU   (0x00001041)
VAL_PAD_DF_IO10_TAVOR     EQU   (0x00001041)
VAL_PAD_DF_IO11_TAVOR     EQU   (0x00001041)
VAL_PAD_DF_IO12_TAVOR     EQU   (0x00001041)
VAL_PAD_DF_IO13_TAVOR     EQU   (0x00001041)
VAL_PAD_DF_IO14_TAVOR     EQU   (0x00001041)
VAL_PAD_DF_IO15_TAVOR     EQU   (0x00001041)
 ELSE
VAL_PAD_nLUA_TAVOR        EQU   (0x00001901)
VAL_PAD_nLLA_TAVOR        EQU   (0x00001901)
VAL_PAD_DF_CLE_TAVOR      EQU   (0x00001801)
VAL_PAD_DF_nADV1_ALE_TAVOR EQU   (0x00001801)
VAL_PAD_DF_nADV2_ALE_TAVOR EQU   (0x00001801)
VAL_PAD_DF_nCS0_TAVOR	  EQU   (0x00001803)
VAL_PAD_DF_nCS1_TAVOR	  EQU   (0x00001803)
VAL_PAD_ND_nWE_TAVOR      EQU   (0x00001801)
VAL_PAD_ND_nRE_TAVOR      EQU   (0x00001801)
VAL_PAD_DF_SCLK_E_TAVOR   EQU   (0x00001801)
VAL_PAD_DF_IO0_TAVOR      EQU   (0x00001401)
VAL_PAD_DF_IO1_TAVOR      EQU   (0x00001401)
VAL_PAD_DF_IO2_TAVOR      EQU   (0x00001401)
VAL_PAD_DF_IO3_TAVOR      EQU   (0x00001401)
VAL_PAD_DF_IO4_TAVOR      EQU   (0x00001401)
VAL_PAD_DF_IO5_TAVOR      EQU   (0x00001401)
VAL_PAD_DF_IO6_TAVOR      EQU   (0x00001401)
VAL_PAD_DF_IO7_TAVOR      EQU   (0x00001401)
VAL_PAD_DF_IO8_TAVOR      EQU   (0x00001401)
VAL_PAD_DF_IO9_TAVOR      EQU   (0x00001401)
VAL_PAD_DF_IO10_TAVOR     EQU   (0x00001401)
VAL_PAD_DF_IO11_TAVOR     EQU   (0x00001401)
VAL_PAD_DF_IO12_TAVOR     EQU   (0x00001401)
VAL_PAD_DF_IO13_TAVOR     EQU   (0x00001401)
VAL_PAD_DF_IO14_TAVOR     EQU   (0x00001401)
VAL_PAD_DF_IO15_TAVOR     EQU   (0x00001401)
 ENDIF
VAL_PAD_INPUT_RELEASE_TAVOR EQU (0x00000700)

;Next two values needed for SV board to work
VAL_PAD_nBE0_TAVOR		  EQU	(0x00001801)
VAL_PAD_nBE1_TAVOR		  EQU	(0x00001801)

;VAL_SMEMC_CSADRCFG_2      EQU   (0x00320919)
;VAL_SMEMC_CSADRCFG_2      EQU   (0x00320809)
;VAL_SMEMC_MSC1    		  EQU   (0x00001238)
;VAL_SMEMC_MSC1    		  EQU   (0x7FF87FF8)
VAL_SMEMC_MSC1    		  EQU   (0x12381238)
VAL_SMEMC_CSADRCFG_2      EQU   (0x00320809)
VAL_CHIP_BOOTTAVOR		  EQU   (0x00080000)


;Clock Control Unit definitions
ADDR_CCU_D0CKEN_A     	  EQU   (0x4134000C)
ADDR_CCU_D0CKEN_B     	  EQU   (0x41340010)
VAL_CCU_D0CKEN_A     	  EQU   (0xC0780F10)
VAL_CCU_D0CKEN_B     	  EQU   (0x000000C0)

ADDR_ACCR		  EQU 	(0x41340000)
ADDR_ASCR		  EQU 	(0x41340004)
VAL_HSIO		  EQU	(0x00008000) ; set HSIO to 208 (0b10)

; RTC
; TO DO, VERIFY ADDRESS....
; TO DO....
PMU_PSPR_ADDR			  EQU 	(0x40F50008)
;TO DO.....



      END
