// custom.cpp : Defines the entry point for the application.
// this file implements most of the application specific code.
//
// the main file created by the new project wizard,
// (named "projectname.cpp" by default") has been customized
// just enough to build hooks into this file. 
// that customization was:
//
//  an extern declaration to custom initialization code here
//  an call to the custom initialization code here, and
//  an extra TranslateAccelerator call to ensure the main
//  menu's accelerator keys are checked before the custom code's.
//
//  see comments containing "custom code" to locate these areas.


#include "stdafx.h"
#include "pdu.h"



#include <time.h>
#include <windows.h>
#include <basetyps.h>
#include <windowsx.h>
#include <initguid.h>
#include <devioctl.h>
#include <usbioctl.h>
#include <dbt.h>
#include <stdio.h>

typedef struct PROCMON_S
{
  int           inuse;
  __time64_t    ltime;    // process creation time
  HANDLE        hProcess;
  unsigned long ulProcId;
  char          intrface[MAX_PATH];
} PROCMON_T;

// Global Variables:
#define MAX_PROCS 10
PROCMON_T proclist[MAX_PROCS];

// Notification Infrastructure Stuff
HDEVNOTIFY      hNotifyDev;

// Configure GUI Stuff

HWND            hwndConfigure;
HWND            hwndConfigureName;
char            ConfigureNameText[256]={0};
HWND            hwndConfigureStartIn;
char            ConfigureStartInText[256]={0};
HWND            hwndConfigureArgs;
char            ConfigureArgsText[256]={0};
HWND            hwndConfigureArgs1;
char            ConfigureArgsText1[256]={0};

// Main GUI Stuff
HINSTANCE       lhInst;
HWND            hDialogWnd = NULL;
HWND            hwndComments = NULL;
HWND            hwndInfo = NULL;
HWND            hwndControl = NULL;

HWND            hParentWnd = NULL;
WNDPROC         pParentWinProc = NULL;

#define INFOTEXTBUFLEN    8192
#define CONTROLTEXTBUFLEN 8192
char            InfoText[INFOTEXTBUFLEN];
char            ControlText[CONTROLTEXTBUFLEN];
char            Comments[1024];

BOOL	          gVerbose = TRUE;
BOOL            gMonitorOnly = FALSE;

LRESULT CALLBACK DialogMainWndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ConfigureWndProc(HWND, UINT, WPARAM, LPARAM);

const char WtptpToolLocation[] = "C:\\projects\\u2d\\WTPTP\\WtptpConsole\\Debug\\ntwtptp.exe";
const char BinariesLocation[] = "c:\\projects\\u2d\\dkb\\mhlv\\debug";
const char WtptpToolCmdLnArgs[] = "-P USB -M 3 -V -t ntim_nand_dkb.bin -f mhlv_ntdkb_h.bin";
const char WtptpToolCmdLnArgs1[] = "-P USB -M 3 -V -t ntim_nand_obm_bbu.bin -f MHLV_ntobm_h.bin";

unsigned long exitCode = 0;

typedef enum
{
	NO_DEVICE	= 0,  
	BOOTROM     = 1,
	DKB		   	= 2,
} DeviceType_T;

#define IMAGE_DOWNLOAD_ERROR 1		// Download of binary failed

#define NO_MAX_CODES 1

typedef struct

{
	int ErrorCode;
	char Description[50];

} ERRORS_FROM_WTPTP;

ERRORS_FROM_WTPTP WtptpErrorCodes[NO_MAX_CODES] =

{

	{IMAGE_DOWNLOAD_ERROR,"ImageDownloadError"}
};

BOOL InitCustom(HINSTANCE hInstance, HWND hWnd )
{
  lhInst = hInstance;

  // get and save the window procedure of the main window for later use.
  pParentWinProc = (WNDPROC)GetWindowLong( hWnd, GWL_WNDPROC );
  hParentWnd = hWnd;

  // this is the window that we really want.
  hDialogWnd = CreateDialog(
                hInstance, 
                MAKEINTRESOURCE(IDD_DIALOG_MAIN), 
                hWnd, 
                (DLGPROC)DialogMainWndProc
                ); 

  return TRUE;
}

// GUIDs that are of interest
DEFINE_GUID(GUID_CLASS_BOOTROM,
0x6f40032f,0x99be,0x47c0,0xb1,0x9c,0xbd,0xb4,0xbf,0x32,0x2f,0x49);


// AppendWindowTextVisible: add text to a window,
//                          ensure the new text is visible by scrolling to the bottom
//                          ensure the buffer doesn't overflow by discarding data when necessary
int
AppendWindowTextVisible(
  HWND  hwnd,
  char  *wndtext,
  int   wndtextbufsize,
  char  *newtext
  )
{
  int  wndtextlen;
  int  newtextlen;
  char *newstart;

  if( 
    (hwnd==NULL)        || 
    (wndtext==NULL)     || 
    (newtext==NULL)     || 
    (wndtextbufsize<=0) 
    ) return -1;  // return if some arg is not good.

  // first make sure the new text won't overflow the buffer allocted to this window.
  wndtextlen = strlen(wndtext);
  newtextlen = strlen(newtext);
  if( (wndtextlen + newtextlen) > ( wndtextbufsize - 1 ) ) // remember strlen doesn't count terminating \0
  {
    // throw away the first 20% of the buffer
    newstart = strchr( wndtext + wndtextbufsize/5, '\n' );
    if( !newstart )
    {
      // something is wrong: couldn't find the start of a line.
      // in this case, just throw away the entire buffer contents.
      wndtext[0] = '\0';
    }
    else
    {
      // move the remaining 4/5ths of the buffer up to the start of the buffer.
      ++newstart; // point to the text that follows the newline character.
      strcpy( wndtext, newstart );
      wndtextlen -= ( newstart - wndtext );
    }
  } // end of buffer full check

  // add the new text, display it and scroll to the bottom to ensure it is visible.
  strcat( wndtext, newtext );
  wndtextlen += newtextlen;
  SetWindowText( hwnd, wndtext );
  SendMessage(hwnd, WM_VSCROLL, SB_BOTTOM, 0);  // this automatically scrolls the window contents
                                                // so the new text is visible on the last line.

  return wndtextlen;
}



void
UpdateProcListWindow()
{
  int   i;
  char  tbuf[256];
  strcpy( ControlText, "Running Processes:\r\n" );

  for(i=0;i<MAX_PROCS;i++)
  {
    if( !proclist[i].inuse ) continue;
    sprintf( tbuf, "ProcID %08x started at %s", proclist[i].ulProcId, _ctime64( &proclist[i].ltime ));
    tbuf[strlen(tbuf)-1] = '!'; // get rid of the newline from ctime().
    sprintf( tbuf+strlen(tbuf), " for %s\r\n", proclist[i].intrface );
    strcat( ControlText, tbuf );
  }
  SetWindowText(hwndControl, ControlText);
  SendMessage(hwndControl, WM_VSCROLL, SB_BOTTOM, 0); // this automatically scrolls the window contents
                                                      // so the new text is visible on the last line.
}


void
AddProcList(
  HANDLE        hProcess,
  unsigned long ulProcId,
  char          *intrface
  )
{
  int i;

  // find an available process list record
  for(i=0;i<MAX_PROCS;i++)
  {
    if( !proclist[i].inuse ) break;
  }

  if( i == MAX_PROCS )
  {
    AppendWindowTextVisible( hwndInfo, InfoText, INFOTEXTBUFLEN, "ProcList full. Proc is executing, but not monitored.\r\n" );
    return;
  }

  proclist[i].inuse = 1;
  _time64( &proclist[i].ltime );
  proclist[i].hProcess = hProcess;
  proclist[i].ulProcId = ulProcId;
  strcpy( proclist[i].intrface, intrface );

  UpdateProcListWindow();
}

void
RemoveProcList(
  char    *intrface
  )
{
  int i;
  int found = 0;
  char  tbuf[256];
  unsigned long rc;

  // look at all in use process list records
  for(i=0;i<MAX_PROCS;i++)
  {
    if( proclist[i].inuse ) 
    {
      if( strcmp( intrface, proclist[i].intrface ) == 0 )  // this is the record to be deleted.
      {
		//char	lbuf[64];

		rc = GetExitCodeProcess(proclist[i].hProcess, &exitCode );

        proclist[i].inuse = FALSE;
        CloseHandle( proclist[i].hProcess );
        found = 1;
        //if( gVerbose )
        {
			__time64_t          ltime;    // for timestamps on messages.
			_time64( &ltime );            // for timestamps on messages
			// get a timestamp into lbuf
			tbuf[0] = 0;
			strcpy( tbuf, _ctime64( &ltime ));
			tbuf[24] = ' ';	// convert linefeed to space (byte 24 is a \n)
			// Return value is non-zero when an error is retrieved successfully.
			if (exitCode == 25)
			{
				sprintf(tbuf, "Process %08x for %s terminated with error code %d.\r\n", proclist[i].ulProcId, proclist[i].intrface, exitCode );
				AppendWindowTextVisible( hwndInfo, InfoText, INFOTEXTBUFLEN, tbuf );
			}
			else
			{
				sprintf(tbuf, "Process %08x for %s done.\r\n", proclist[i].ulProcId, proclist[i].intrface);
				AppendWindowTextVisible( hwndInfo, InfoText, INFOTEXTBUFLEN, tbuf );
			}
        }
        break;
      }
    }
  }
  if( found ) UpdateProcListWindow();
}



// buffer for list of args for the process to be launched.
char		lArgs[512]; 

// Launch App:
BOOL
LaunchApp(
    char*  AppPath,
    char*  StartIn,
    char*  Args,
    char*  InterfaceName
    )
{
  BOOL b;
  STARTUPINFO StartupInfo;
  PROCESS_INFORMATION ProcessInformation;

  GetStartupInfo(&StartupInfo);

	// combine the app name and interface into the args
	// need app name first because CreateProcess 
  // doesn't automatically put it as argv[0]. many 
  // apps may expect argv[0] to be the app name.
	strcpy( lArgs, AppPath );   // app name first
	strcat( lArgs, " " );
	strcat( lArgs, Args );      // followed by the args
	strcat( lArgs, " " );
	strcat( lArgs, "  -i " );   // followed by the interface name
	strcat( lArgs, "\"" );	    // note: need to put interface name inside quotes
	strcat( lArgs, InterfaceName );
	strcat( lArgs, "\"" );

  if( gVerbose )
  {
    AppendWindowTextVisible( hwndInfo, InfoText, INFOTEXTBUFLEN, "LaunchApp: lArgLst = " );
    AppendWindowTextVisible( hwndInfo, InfoText, INFOTEXTBUFLEN, lArgs );
    AppendWindowTextVisible( hwndInfo, InfoText, INFOTEXTBUFLEN, "\r\n" );
  }

  b = CreateProcess(AppPath,
                    lArgs,
                    NULL,
                    NULL,
                    FALSE,
                    DETACHED_PROCESS | NORMAL_PRIORITY_CLASS,
                    NULL,
                    StartIn,
                    &StartupInfo,
                    &ProcessInformation
                    );

  if(b) {
    AddProcList( ProcessInformation.hProcess, ProcessInformation.dwProcessId, InterfaceName );
    {
      __time64_t          ltime;    // for timestamps on messages.
      _time64( &ltime );            // for timestamps on messages
      // get a timestamp into lbuf
      lArgs[0] = 0;
      strcpy( lArgs, _ctime64( &ltime ));
      lArgs[24] = ' ';	// convert linefeed to space (byte 24 is a \n)
      sprintf(lArgs+strlen(lArgs), "Process %08x for %s started.\r\n", ProcessInformation.dwProcessId, InterfaceName);
      AppendWindowTextVisible( hwndInfo, InfoText, INFOTEXTBUFLEN, lArgs );
    }
    CloseHandle( ProcessInformation.hThread );  // no need to keep a handle to the thread open.
  }
	else
	{
		int		rc = GetLastError();
		char	lbuf[64];
		sprintf(lbuf,"error %d launching app.\r\n",rc);
    AppendWindowTextVisible( hwndInfo, InfoText, INFOTEXTBUFLEN, lbuf );
	}

  return b;
}




char  lbuf[1024];
LRESULT CALLBACK HandleDeviceChange(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

	DEV_BROADCAST_HDR             *devbcasthdr;
	DEV_BROADCAST_DEVICEINTERFACE *iface;

	BOOL                          bDeviceKnown;

	__time64_t                    ltime;    // for timestamps on messages.
	_time64( &ltime );                      // for timestamps on messages


	// get a timestamp into lbuf
	lbuf[0] = 0;
	strcpy( lbuf, _ctime64( &ltime ));
	lbuf[24] = ' ';	// convert linefeed to space (byte 24 is a \n)

	// append info about this event.
	sprintf( lbuf+strlen(lbuf), "event summary - h: %08x m: %08x w: %08x l:%08x", (DWORD)hwndDlg, message, wParam, lParam );

	// move the formatted string to the comments window
	strcpy( Comments, lbuf );
	SetWindowText( hwndComments, Comments );

	if( gVerbose )
	{
		strcat( lbuf, "\r\n" );
		AppendWindowTextVisible( hwndInfo, InfoText, INFOTEXTBUFLEN, lbuf );
	}

	lbuf[0] = 0;

	switch( wParam )
	{
	case DBT_DEVICEARRIVAL:
		bDeviceKnown = FALSE;
		devbcasthdr = (DEV_BROADCAST_HDR*)lParam;

		if( DBT_DEVTYP_DEVICEINTERFACE == devbcasthdr->dbch_devicetype )
		{
			iface = (DEV_BROADCAST_DEVICEINTERFACE*)lParam;

			if( gVerbose )
			{
				sprintf( lbuf, "Device arrival - dt: %08x, INTERFACE: %s.\r\n", iface->dbcc_devicetype, iface->dbcc_name);
				AppendWindowTextVisible( hwndInfo, InfoText, INFOTEXTBUFLEN, lbuf );
			}

			// is this a known interface?
			// search by GUID first...
			if( memcmp( &iface->dbcc_classguid, &GUID_CLASS_BOOTROM, sizeof(GUID_CLASS_BOOTROM) ) == 0 )
			{
				sprintf( lbuf, "%s BootROM attached.\r\n", _ctime64( &ltime ));
				lbuf[24]=' ';
				bDeviceKnown = TRUE;
			}
			else
			// not found by GUID...check the vid & pid in the name field
			if( (strstr( iface->dbcc_name, "#Vid_8086&Pid_c001" ) != 0) ||
				(strstr( iface->dbcc_name, "#Vid_8086&Pid_d001" ) != 0) )
			{
				sprintf( lbuf, "%s BootROM attached.\r\n", _ctime64( &ltime ));
				lbuf[24]=' ';
				bDeviceKnown = TRUE;
			}
			else
			// not found by GUID...check the vid & pid in the name field
			if( (strstr( iface->dbcc_name, "#Vid_1286&Pid_8101" ) != 0)  ||
				(strstr( iface->dbcc_name, "#Vid_1286&Pid_8102" ) != 0)  ||
				(strstr( iface->dbcc_name, "#Vid_1286&Pid_8103" ) != 0)  ||
				(strstr( iface->dbcc_name, "#Vid_1286&Pid_8104" ) != 0) )
			{
				sprintf( lbuf, "%s DKB attached.\r\n", _ctime64( &ltime ));
				lbuf[24]=' ';
				bDeviceKnown = TRUE;
			}

			if( bDeviceKnown )
			{
				// log the results of the parsing above...
				AppendWindowTextVisible( hwndInfo, InfoText, INFOTEXTBUFLEN, lbuf );

				if( !gMonitorOnly )
				{
					if( (strstr( iface->dbcc_name, "#Vid_8086&Pid_c001" ) != 0) ||
						(strstr( iface->dbcc_name, "#Vid_8086&Pid_d001" ) != 0) )
						LaunchApp( ConfigureNameText, ConfigureStartInText, ConfigureArgsText, iface->dbcc_name );
					else if((strstr( iface->dbcc_name, "#Vid_1286&Pid_8101" ) != 0)  ||
							(strstr( iface->dbcc_name, "#Vid_1286&Pid_8102" ) != 0)  ||
							(strstr( iface->dbcc_name, "#Vid_1286&Pid_8103" ) != 0)  ||
							(strstr( iface->dbcc_name, "#Vid_1286&Pid_8104" ) != 0) )
						LaunchApp( ConfigureNameText, ConfigureStartInText, ConfigureArgsText1, iface->dbcc_name );
					// Launch a thread to handle this device.
					// FIXME: add the code here.
					// FIXME: for a device w/ multiple instances, how to identify which is new?
				}
			} // end of known device handling
		} // end of if devicetype == DEVICEINTERFACE handling

		break;  // end of switch wParam - case DBT_ARRIVAL

	case  DBT_DEVICEREMOVECOMPLETE:
		bDeviceKnown = FALSE;
		devbcasthdr = (DEV_BROADCAST_HDR*)lParam;

		if( DBT_DEVTYP_DEVICEINTERFACE == devbcasthdr->dbch_devicetype )
		{
			iface = (DEV_BROADCAST_DEVICEINTERFACE*)lParam;

			if( gVerbose )
			{
				sprintf( lbuf, "Device removal - dt: %08x, INTERFACE: %s.\r\n", iface->dbcc_devicetype, iface->dbcc_name);
				AppendWindowTextVisible( hwndInfo, InfoText, INFOTEXTBUFLEN, lbuf );
			}

			// is this a known interface?
			// search by GUID first...
			if( memcmp( &iface->dbcc_classguid, &GUID_CLASS_BOOTROM, sizeof(GUID_CLASS_BOOTROM) ) == 0 )
			{
				sprintf( lbuf, "%s BootROM removed.\r\n", _ctime64( &ltime ));
				lbuf[24]=' ';
				bDeviceKnown = TRUE;
			}
			else
			// not found by GUID...check the vid & pid in the name field
			// MH-L / MH-LV and Tavor bootROM
			if( (strstr( iface->dbcc_name, "#Vid_8086&Pid_c001" ) != 0) ||
				(strstr( iface->dbcc_name, "#Vid_8086&Pid_d001" ) != 0)  )
			{
				sprintf( lbuf, "%s BootROM removed.\r\n", _ctime64( &ltime ));
				lbuf[24]=' ';
				bDeviceKnown = TRUE;
			}
			else
			// not found by GUID...check the vid & pid in the name field
			// MH-L / MH-LV and Tavor DKB
			if( (strstr( iface->dbcc_name, "#Vid_1286&Pid_8101" ) != 0)  ||
				(strstr( iface->dbcc_name, "#Vid_1286&Pid_8102" ) != 0)  ||
				(strstr( iface->dbcc_name, "#Vid_1286&Pid_8103" ) != 0)  ||
				(strstr( iface->dbcc_name, "#Vid_1286&Pid_8104" ) != 0) )
			{
				sprintf( lbuf, "%s DKB removed.\r\n", _ctime64( &ltime ));
				lbuf[24]=' ';
				bDeviceKnown = TRUE;
			}

			if( bDeviceKnown )
			{
				// log the results of the parsing above...
				AppendWindowTextVisible( hwndInfo, InfoText, INFOTEXTBUFLEN, lbuf );

				if( !gMonitorOnly )
				{
					RemoveProcList( iface->dbcc_name );
					// update the status line for the process associated with this interface.
					// FIXME: add the code here.
					// FIXME: for a device w/ multiple instances, how to identify which is new?
				}
			} // end of known device handling
		} // end of if devicetype == DEVICEINTERFACE handling

		break;

	} // end of switch wParam

	return TRUE;  // indicate message handled.
}


LRESULT CALLBACK ConfigureWndProc(HWND hwndConfigureDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
  LRESULT rv = FALSE; // default return value: "false" = not processed.

    switch (message) 
    { 

        // WM_INITDIALOG:
        //    Called when the dialog box is being created.
        //    Do all initialization stuff here:
        //      . Store the handles to the gui elements for use in later updates.
        //      . Set some initial values for the gui elements.
        case WM_INITDIALOG: 

            // set up the gui components
            {
              hwndConfigureName     = GetDlgItem( hwndConfigureDlg, IDC_EDIT_CONFIGURE_APP_NAME );
              hwndConfigureStartIn  = GetDlgItem( hwndConfigureDlg, IDC_EDIT_CONFIGURE_STARTIN );
              hwndConfigureArgs     = GetDlgItem( hwndConfigureDlg, IDC_EDIT_CONFIGURE_ARGS );
			  hwndConfigureArgs1    = GetDlgItem( hwndConfigureDlg, IDC_EDIT_CONFIGURE_ARGS1 );


			        if( *ConfigureNameText      ) 
			        {
				        SetWindowText(hwndConfigureName, ConfigureNameText );
			        }
			        else
			        {
				        SetWindowText(hwndConfigureName, WtptpToolLocation );
			        }

			        if( *ConfigureStartInText   ) 
			        {
				        SetWindowText(hwndConfigureStartIn, ConfigureStartInText );
			        }
			        else
			        {
				        SetWindowText(hwndConfigureStartIn, BinariesLocation );
			        }

			        if( *ConfigureArgsText      ) 
			        {
				        SetWindowText(hwndConfigureArgs, ConfigureArgsText );
			        }
			        else
			        {
				        SetWindowText(hwndConfigureArgs, WtptpToolCmdLnArgs );
			        }

			        if( *ConfigureArgsText1      ) 
			        {
				        SetWindowText(hwndConfigureArgs1, ConfigureArgsText1 );
			        }
			        else
			        {
				        SetWindowText(hwndConfigureArgs1, WtptpToolCmdLnArgs1 );
			        }

              ShowWindow(hwndConfigureDlg, SW_SHOW); 
            }

            rv = TRUE;    // set return value to "true" = processed the message.
            break;

        // WM_COMMAND:
        //    Called when some event related to the gui occurs
        case WM_COMMAND: 

            switch (LOWORD(wParam)) 
            { 
              case  ID_SAVE:        // FIXME: this accelerator is actually being consumed by the main window.
                GetWindowText(hwndConfigureName,    ConfigureNameText,    sizeof(ConfigureNameText));
                GetWindowText(hwndConfigureStartIn, ConfigureStartInText, sizeof(ConfigureStartInText));
                GetWindowText(hwndConfigureArgs,    ConfigureArgsText,    sizeof(ConfigureArgsText));
				GetWindowText(hwndConfigureArgs1,    ConfigureArgsText1,    sizeof(ConfigureArgsText1));
                DestroyWindow(hwndConfigureDlg);
                rv = TRUE;
                break;

              case IDCANCEL:
                {
                  DestroyWindow(hwndConfigureDlg);
                  rv = TRUE;
                }
                break;

              default:
                // allow the main wnd proc to see the menu items, etc.
                rv = CallWindowProc( pParentWinProc, hParentWnd, message, wParam, lParam );
                break;
            } 
            break;

      default:
          break;
    } 

	return rv;   // false means we haven't processed the message.
} 


// Open a handle to the device.
// Try some writes and reads.
void Configure( HWND hwndDlg )
{
  hwndConfigure = CreateDialog(
                lhInst,
                MAKEINTRESOURCE(IDD_DIALOG_CONFIGURE), 
                hwndDlg, 
                (DLGPROC)ConfigureWndProc
                ); 
}




LRESULT CALLBACK DialogMainWndProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
    LRESULT rv = FALSE; // default return value: "false" = not processed.
	int currentOption = 1;

    switch (message) 
    { 

        // WM_INITDIALOG:
        //    Called when the dialog box is being created.
        //    Do all initialization stuff here:
        //      1. Create the device notification infrastructure
        //      2. Store the handles to the gui elements for use in later updates.
        //      3. Set some initial values for the gui elements.
        case WM_INITDIALOG: 

            // set up the infrastructure for monitoring usb events
            {
              DEV_BROADCAST_DEVICEINTERFACE   broadcastInterface;

              // Register to receive notification when the BootROM device is plugged in.
              broadcastInterface.dbcc_size = sizeof(DEV_BROADCAST_DEVICEINTERFACE);
              broadcastInterface.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE;

              memcpy( &(broadcastInterface.dbcc_classguid),
                      &(GUID_CLASS_BOOTROM),
                      sizeof(struct _GUID));

              hNotifyDev = RegisterDeviceNotification(
                            hwndDlg,
                            &broadcastInterface,
                            DEVICE_NOTIFY_WINDOW_HANDLE);

            }

            // set up the gui components
            {
              hwndComments  = GetDlgItem( hwndDlg, IDC_EDIT_COMMENTS );
              hwndInfo      = GetDlgItem( hwndDlg, IDC_EDIT_INFO );
              hwndControl   = GetDlgItem( hwndDlg, IDC_EDIT_CONTROL );

              //  init the edit box strings.
              InfoText[0]     = 0;  // null terminate the edit box strings
              ControlText[0]  = 0;
              Comments[0]     = 0;

              SetWindowText( hwndComments, Comments);
              SetWindowText( hwndInfo, InfoText);
              SetWindowText( hwndControl, ControlText);

              // some defaults: FIXME: get these from some permanent store. Gizem.
				      strcpy(ConfigureNameText, WtptpToolLocation );
				      strcpy(ConfigureStartInText, BinariesLocation );
				      strcpy(ConfigureArgsText, WtptpToolCmdLnArgs );
					  strcpy(ConfigureArgsText1, WtptpToolCmdLnArgs1 );

              ShowWindow(hwndDlg, SW_SHOW); 
            }

            rv = TRUE;    // set return value to "true" = processed the message.
            break;

        // WM_COMMAND:
        //    Called when some event related to the gui occurs
        case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
              case  ID_ACTIONS_CLEAR:   // FIXME: this accelerator is actually being consumed by the main window.
                InfoText[0] = 0;        // FIXME: how to get it to be handled here?
                SetWindowText( hwndInfo, InfoText );
                rv = TRUE;
                break;

              case  ID_ACTIONS_CONFIGURE:        // FIXME: this accelerator is actually being consumed by the main window.
                Configure(hwndDlg);
                rv = TRUE;
                break;

              case IDCANCEL:
                {
                  DestroyWindow(GetParent(hwndDlg));    // need this so the entire app closes.

                  // bpc: not sure if OK to just destroy the containing parent, as above, or...
                  //      if the current window & then the parent need destroying, use three lines below...
                  //HWND  hwndParent = GetParent(hwndDlg);  // have to save this before calling DestroyWindow(hwndDlg);
                  //DestroyWindow(hwndDlg);
                  //DestroyWindow(hwndParent);    // need this so the entire app closes.

                  rv = TRUE;
                }
                break;
              
				      case ID_SETTINGS_VERBOSE:
					      {
					        MENUITEMINFO menuInfo;

					        gVerbose = !gVerbose;

					        menuInfo.cbSize = sizeof(menuInfo);
					        menuInfo.fMask  = MIIM_STATE;
					        menuInfo.fState = gVerbose ? MFS_CHECKED : MFS_UNCHECKED;

					        SetMenuItemInfo(GetMenu(hDialogWnd),
									        ID_SETTINGS_VERBOSE,
									        FALSE,
									        &menuInfo);

					      }
					      break;

              case ID_SETTINGS_MONITORONLY:
					      {
					        MENUITEMINFO menuInfo;

					        gMonitorOnly = !gMonitorOnly;

					        menuInfo.cbSize = sizeof(menuInfo);
					        menuInfo.fMask  = MIIM_STATE;
					        menuInfo.fState = gMonitorOnly ? MFS_CHECKED : MFS_UNCHECKED;

					        SetMenuItemInfo(GetMenu(hDialogWnd),
									        ID_SETTINGS_MONITORONLY,
									        FALSE,
									        &menuInfo);

					      }
					      break;

              default:
                // allow the main wnd proc to see the menu items, etc.
                rv = CallWindowProc( pParentWinProc, hParentWnd, message, wParam, lParam );
                break;
              } 
              break;



        // WM_DEVICECHANGE:
        //    Called when a device attach or detach occurs.
        case WM_DEVICECHANGE:
            rv = HandleDeviceChange( hwndDlg, message, wParam, lParam) ;
            break;

      default:
          break;
    } 

    return rv;   // false means we haven't processed the message.
} 

