###############################################################
#	Makefile for the Marvel NonTrusted Boot Builder 
# 
# 
############################################################## 

CC = g++
BASE:=$(shell pwd)
##IPP_PATH = /opt/intel/ipp/5.2/ia32
IPP_PATH = /opt/intel/ipp/5.3.4.080/ia32
IPP_INCLUDE_DIR = $(IPP_PATH)/include
IPP_LIBRARY_DIR = $(IPP_PATH)/sharedlib

TRUSTED=0

OBJS = NTBBLIB.o NTBBTIM.o 
CCFLAGS = -D LINUX -D WINDOWS=0

ifeq "$(TRUSTED)" "1"
	OBJS += TBBLIB.o TBBTIM.o
	LIBS = $(IPP_LIBRARY_DIR)/libippcp.so \
	       $(IPP_LIBRARY_DIR)/libippcore.so \
	       $(IPP_LIBRARY_DIR)/libguide.so
	CCFLAGS += -D TRUSTED -I $(IPP_INCLUDE_DIR)
	OUTPUT = tbb_linux.exe
else
	LIBS = 
	CCFLAGS += -D TRUSTED=0
	OUTPUT = ntbb_linux.exe
endif

all: $(OBJS)
	$(CC) -o $(OUTPUT) $(OBJS) $(LIBS)
	-rm *.o

$(OBJS): %.o: %.cpp
	$(CC) $(CCFLAGS) -I $(BASE) -c $*.cpp -o $*.o

.PHONY: clean
clean:
	@echo "TBB make clean..."
	-rm $(OUTPUT)




