###############################################################
#	Makefile for the Marvel NonTrusted Boot Builder 
# 
# 
############################################################## 

TRUSTED	= 0
BASE	= .
SDK		= C:\Program Files\Microsoft Visual Studio 8\VC

INCLUDE	= /I$(BASE) /I"$(SDK)\include"
LINK_LIB = "$(SDK)/lib"

CC = "$(SDK)\bin\cl.exe"
LD = "$(SDK)\bin\link.exe"
CCFLAGS = /TP /c /w /nologo /DLINUX=0 /DWINDOWS=1 /DTRUSTED=$(TRUSTED)
LDFLAGS = /nologo /LIBPATH:$(LINK_LIB)


NTOBJS = NTBBLIB.o NTBBTIM.o 


!if $(TRUSTED)
TOBJS = TBBLIB.o TBBTIM.o
LIBS = ippcp.lib
OUTPUT = tbb_windows.exe
!else
TOBJS = 
LIBS = 
OUTPUT = ntbb_windows.exe
!endif

OBJS = $(NTOBJS) $(TOBJS)

ALL: $(OBJS)
	@$(LD) $(LDFLAGS) /OUT:$(OUTPUT) $(LIBS) $(OBJS)
	@echo. 
	@echo $(OUTPUT) successfully created!
	@del *.o

$(OBJS): $*.cpp
	@$(CC) $(CCFLAGS) $(INCLUDE) /Fo$@ $*.cpp




.PHONY: clean
clean:
	del *.o ntbb_windows.exe tbb_windows.exe







