/**************************************************************************
**
** (C) Copyright December 2006 Marvell International Ltd.
**
** All Rights Reserved.
**
** This software file (the "File") is distributed by Marvell International  
** Ltd. under the terms of the GNU General Public License Version 2, June  
** 1991 (the "License").  You may use, redistribute and/or modify this File   
** in accordance with the terms and conditions of the License, a copy of  
** which is available along with the File in the license.txt file or by   
** writing to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,   
** Boston, MA 02111-1307 or on the worldwide web at 
** http://www.gnu.org/licenses/gpl.txt.
**
** THE FILE IS DISTRIBUTED AS-IS, WITHOUT WARRANTY OF ANY KIND, AND THE   
** IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR  
** PURPOSE ARE EXPRESSLY DISCLAIMED.  The License provides additional
** details about this warranty disclaimer. 
**
**  FILENAME:	FlashCodes.h
**
**  PURPOSE: 	Definition file for the flash types currently available.
**  
******************************************************************************/

#ifndef FLASHTYPE // Only make declarations once.
#define FLASHTYPE

#ifdef __cplusplus
	extern "C" {
#endif

#define MAXFLASHTYPES 8

typedef struct
{
	BYTE FlashCode;
	char Description[50];
} FLASHCODETABLE;

FLASHCODETABLE FlashTypeCodes[MAXFLASHTYPES] =
{
	{0x00,"Default - 0x00000000"},
	{0x01,"MSystemDFI - 0x4E414E01"},
	{0x02,"OneNandDFI - 0x4E414E02"},
	{0x03,"XIPDDR16EMPI - 0x58495003"},
	{0x04,"NAND_1_16_16 - 0x4E414E04"},
	{0x05,"Sibley_16 - 0x58495005"},
	{0x06,"NAND_1_8_8 - 0x4E414E06"},
	{0x07,"Tyax16DFI - 0x58495007"}
};

#ifdef __cplusplus
	}
#endif

#endif

