/**************************************************************************
**
** (C) Copyright December 2006 Marvell International Ltd.
**
** All Rights Reserved.
**
** This software file (the "File") is distributed by Marvell International  
** Ltd. under the terms of the GNU General Public License Version 2, June  
** 1991 (the "License").  You may use, redistribute and/or modify this File   
** in accordance with the terms and conditions of the License, a copy of  
** which is available along with the File in the license.txt file or by   
** writing to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,   
** Boston, MA 02111-1307 or on the worldwide web at 
** http://www.gnu.org/licenses/gpl.txt.
**
** THE FILE IS DISTRIBUTED AS-IS, WITHOUT WARRANTY OF ANY KIND, AND THE   
** IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR  
** PURPOSE ARE EXPRESSLY DISCLAIMED.  The License provides additional
** details about this warranty disclaimer. 
**
**  FILENAME:	WTPCOMMCLASS.h
**
**  PURPOSE: 	Contains definitions for CtpComm class. 
**                  
******************************************************************************/

#if !defined WTPCOMM
#define WTPCOMM

//#ifndef WTPDEF
#if LINUX
#include "../Include/WTPDEF.h"
#endif
#if WINDOWS
#include "..\Include\WTPDEF.h"
#endif
//#endif

#if _MSC_VER >= 1000
#pragma once
#endif

class CWtpComm
{
	public:
		CWtpComm ();
#if LINUX
		virtual ~CWtpComm ();
#endif
#if WINDOWS
		~CWtpComm ();
#endif
		void SetPortType (int iSelect);
		int GetPortType ();
		void SetUartPort (int iPort);
		int GetUartPort ();
		void SetBaudRate (DWORD dwRate);
		void SetUsbPortTimeout (long int lTimeout);
		void SetImageSectionDelay (DWORD dwSectionDelay);
		bool OpenPort ();
		void ClosePort ();
		bool SendPreamble ();
		bool GetVersion (WTPSTATUS *pWtpStatus);
		bool SelectImage (PDWORD pImageType);
		bool VerifyImage (BYTE AckOrNack);
		bool DataHeader (unsigned int uiRemainingData,WTPSTATUS *pWtpStatus);
		bool Data (PBYTE pData,long Length);
		bool DebugBoot (PBYTE pFlashType);
		bool Done ();
		bool Disconnect (WTPSTATUS *pWtpStatus);
		bool PublicKey ();
		bool Password (WTPSTATUS *pWtpStatus);
		bool SignedPassword ();
		bool GetMessage (WTPSTATUS *pWtpStatus);
		bool GetTargetMessage (WTPSTATUS *pWtpStatus);
		void SetFlashType (BYTE FlashCode);
		BYTE GetFlashType ();
		bool OtpView ();
		void SetVerboseMode (bool bOnOff);
		void SetMessageMode (MESSAGE_MODES MessageModeOnOff);
		bool WaitForHostReply (WTPSTATUS *pWtpStatus,int nCharsRead,int nTotalChars);
	private:
		int PortType;
		int iPortNumber;
		int iSequence;
		BYTE FlashType;
		DWORD dwBaudRate;
		DWORD dwImageSectionDelay;
		long int Timeout;
		char Message[100];
		bool bVerbose;
		bool bMsg;
		MESSAGE_MODES MessageMode;
		bool bBaudRateSet;
};

extern CWtpComm WtpComm;

#endif

