/**************************************************************************
**
** (C) Copyright December 2006 Marvell International Ltd.
**
** All Rights Reserved.
**
** This software file (the "File") is distributed by Marvell International  
** Ltd. under the terms of the GNU General Public License Version 2, June  
** 1991 (the "License").  You may use, redistribute and/or modify this File   
** in accordance with the terms and conditions of the License, a copy of  
** which is available along with the File in the license.txt file or by   
** writing to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,   
** Boston, MA 02111-1307 or on the worldwide web at 
** http://www.gnu.org/licenses/gpl.txt.
**
** THE FILE IS DISTRIBUTED AS-IS, WITHOUT WARRANTY OF ANY KIND, AND THE   
** IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR  
** PURPOSE ARE EXPRESSLY DISCLAIMED.  The License provides additional
** details about this warranty disclaimer. 
**
**  FILENAME:	Typedef.h
**
**  PURPOSE: 	Windows Dll routines 
**                  
******************************************************************************/

#ifndef __TYPEDEF_H__
#define __TYPEDEF_H__

 
typedef volatile unsigned long 	VUINT32_T;
typedef unsigned long 		   	UINT32_T, ULONG;
typedef volatile unsigned int  	VUINT_T;
typedef unsigned int 		   	UINT_T;
typedef int			 		   	INT_T;
typedef unsigned short 		   	UINT16_T, USHORT;
typedef volatile unsigned short VUINT16_T;
typedef unsigned char 			UINT8_T;
typedef char		 			INT8_T;

typedef void(*FnPVOID)(void);

typedef unsigned int        	UINT,     *PUINT;    // The size is not important
#if defined( _WIN32 ) || defined ( _WIN64 )
#define UINT64    unsigned __int64
typedef unsigned __int64 *PUINT64;  
#else
typedef unsigned long long  	UINT64,   *PUINT64;
#endif
typedef unsigned int        	UINT32,   *PUINT32;
typedef unsigned short      	UINT16,   *PUINT16;
typedef unsigned char       	UINT8,    *PUINT8;
typedef unsigned char       	UCHAR,BYTE,*PUCHAR;

typedef int                 	INT,      *PINT;    // The size is not important
#if defined( _WIN32 ) || defined ( _WIN64 )
#define INT64    __int64
typedef __int64 *PINT64;  
#else
typedef long long           	INT64,    *PINT64;
#endif
typedef int                 	INT32,    *PINT32;
typedef short               	INT16,    *PINT16;
typedef char                	INT8,     *PINT8;
typedef char                	CHAR,     *PCHAR;
//typedef void                	VOID,     *PVOID;

typedef volatile  UINT      	VUINT,    *PVUINT;    // The size is not important
typedef volatile  UINT64    	VUINT64,  *PVUINT64;
typedef volatile  UINT32    	VUINT32,  *PVUINT32;
typedef volatile  UINT16    	VUINT16,  *PVUINT16;
typedef volatile  UINT8     	VUINT8,   *PVUINT8;
typedef volatile  UCHAR     	VUCHAR,   *PVUCHAR;

typedef volatile  INT       	VINT,     *PVINT;    // The size is not important
typedef volatile  INT64     	VINT64,   *PVINT64;
typedef volatile  INT32     	VINT32,   *PVINT32;
typedef volatile  INT16     	VINT16,   *PVINT16;
typedef volatile  INT8      	VINT8,    *PVINT8;
typedef volatile  CHAR      	VCHAR,    *PVCHAR;

typedef struct{
UINT_T	ErrorCode;
UINT_T 	PCRCode;
}FUNC_STATUS, *pFUNC_STATUS;

#endif

