/**************************************************************************
**
** (C) Copyright December 2006 Marvell International Ltd.
**
** All Rights Reserved.
**
** This software file (the "File") is distributed by Marvell International  
** Ltd. under the terms of the GNU General Public License Version 2, June  
** 1991 (the "License").  You may use, redistribute and/or modify this File   
** in accordance with the terms and conditions of the License, a copy of  
** which is available along with the File in the license.txt file or by   
** writing to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,   
** Boston, MA 02111-1307 or on the worldwide web at 
** http://www.gnu.org/licenses/gpl.txt.
**
** THE FILE IS DISTRIBUTED AS-IS, WITHOUT WARRANTY OF ANY KIND, AND THE   
** IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR  
** PURPOSE ARE EXPRESSLY DISCLAIMED.  The License provides additional
** details about this warranty disclaimer. 
**
**  FILENAME:	WTPSECURITYLIB.h
**
**  PURPOSE: 	Security LIB routines 
**                  
******************************************************************************/

#ifndef WTPSECURITYLIB
#define WTPSECURITYLIB

#if LINUX
#include "../Include/Typedef.h"
#define MAX_PATH 260
#endif

#ifdef __cplusplus
	extern "C" {
#endif

#define NoError	0x00
#define NotFoundError 0x01
#define KeyLengthReadError 0x0D
#define	FlashTypeReadError 0x0F
#define IssueDateReadError 0x10
#define OEMUniqueIDReadError 0x11
#define HashValueLengthReadError 0x12
#define RSAExponentReadError 0x13
#define RSAPrivateKeyReadError 0x14
#define RSAModulusReadError 0x15
#define MAXIMAGEFILES 20

typedef struct
{
	DWORD FileType;
	char FileName[MAX_PATH];
	char ShortFileName[MAX_PATH];
} IMAGEFILES;
#if LINUX
extern IMAGEFILES ImageFiles[MAXIMAGEFILES];
#endif
#if WINDOWS
IMAGEFILES ImageFiles[MAXIMAGEFILES];
#endif

#if TRUSTED
typedef struct 
{
	unsigned char PublicKey[256];
	unsigned char Modulus[256];
	unsigned char PrivateKey[256];
	unsigned int  KeyLength;
} KeyInfo, *pKeyInfo;

int ReadKeyFile (FILE *kFile,unsigned char *pPubKey,unsigned char *pPrivKey,
                 unsigned char *pModulus,unsigned int *pKeyLength);
#if LINUX
bool RSA (unsigned int *PubKey,unsigned int *pModulus,int modlen,
          unsigned int *pInput,unsigned int *pOutput);
#endif
#if WINDOWS
void RSA (unsigned int *PubKey,unsigned int *pModulus,int modlen,
          unsigned int *pInput,unsigned int *pOutput);
#endif

void Sha1Digest (unsigned char *pMesg,int len,unsigned char *pMD);
void PadPasswordToSign (unsigned int *Password,unsigned int KeyLength);
#endif
void Endian_Convert (unsigned char *first);
#if LINUX
extern bool ParseTim (IMAGEFILES *pImageFiles,int nFiles,int *pNumberOfImages);
#endif
#if WINDOWS
BOOL ParseTim (IMAGEFILES *pImageFiles,int nFiles,int *pNumberOfImages);
#endif

#ifdef __cplusplus
	}
#endif

#endif
