###############################################################
#	Makefile for the Marvel NonTrusted Boot Builder 
# 
# 
############################################################## 

TRUSTED = 0
CC = g++
TOPDIR :=$(shell pwd)
CCFLAGS = -D LINUX=1 -D WINDOWS=0 -D TRUSTED=$(TRUSTED)
INCLUDE = $(TOPDIR)/Common/Include
SUBDIRS = $(TOPDIR)/WtptpConsole $(TOPDIR)/Common/WTPSECURITYLIB $(TOPDIR)/Common/WTPUARTLIB \
          $(TOPDIR)/Common/WTPCOMMCLASS $(TOPDIR)/Common/WTPUSBLIB
MAKE = make

ifeq "$(TRUSTED)" "1"
	OUTPUT = wtptp.exe
	LIBS = libippcp.so libippcore.so libguide.so
else
	OUTPUT = ntwtptp.exe
	LIBS =
endif


OBJS = WtpDownload.o \
	WTPSECURITYLIB.o \
	TimParser.o \
	WTPUARTLIB.o \
	WTPUSBLIB.o \
	WTPCOMMCLASS.o

all: $(OBJS)
	$(CC) -o $(OUTPUT) $(OBJS) $(LIBS)
	@-rm *.o

WtpDownload.o:$(TOPDIR)/WtptpConsole/WtpDownload.cpp
	$(CC) -w $(CCFLAGS) -c $(TOPDIR)/WtptpConsole/WtpDownload.cpp -o WtpDownload.o 

WTPSECURITYLIB.o:$(TOPDIR)/Common/WTPSECURITYLIB/WTPSECURITYLIB.c
	$(CC) -w $(CCFLAGS) -c $(TOPDIR)/Common/WTPSECURITYLIB/WTPSECURITYLIB.c -o WTPSECURITYLIB.o

TimParser.o:$(TOPDIR)/Common/WTPSECURITYLIB/TimParser.c
	$(CC) -w $(CCFLAGS) -c "$(TOPDIR)/Common/WTPSECURITYLIB/TimParser.c" -o TimParser.o

WTPUARTLIB.o:$(TOPDIR)/Common/WTPUARTLIB/WTPUARTLIB_linux.c
	$(CC) -w $(CCFLAGS) -c "$(TOPDIR)/Common/WTPUARTLIB/WTPUARTLIB_linux.c" -o WTPUARTLIB.o

WTPUSBLIB.o:$(TOPDIR)/Common/WTPUSBLIB/WTPUSBLIB_linux.c
	$(CC) -w $(CCFLAGS) -c "$(TOPDIR)/Common/WTPUSBLIB/WTPUSBLIB_linux.c" -o WTPUSBLIB.o

WTPCOMMCLASS.o:$(TOPDIR)/Common/WTPCOMMCLASS/WTPCOMMCLASS.cpp
	$(CC) -w $(CCFLAGS) -c "$(TOPDIR)/Common/WTPCOMMCLASS/WTPCOMMCLASS.cpp" -o WTPCOMMCLASS.o


.PHONY: clean
clean:
	@echo "WTPTP_LINUX make clean..."
	find . -name "*.o" -exec rm -fr {} \;
	-rm *.exe




